/**********************************************************************/
/*                                                                    */
/*              CSMI TEST TOOL FOR LINUX                              */
/*                                                                    */
/*                                                                    */
/* Revision History                                                   */
/* ----------------                                                   */
/* 1.0-1   AJ   03/16/04     Initial Release                          */
/* 1.1     JB   07/28/04     Added the rest of the ioctl's in         */
/*			     the CSMI Specification							 */
/* 2.0     Anoop 03/04/05   Integrated win/linux tool,                */
/*               hex dump, description & other enhancements           */
/* 2.1-1   Anoop 04/07/05  Interface/Function Pointers                */
/* 2.1-2   Anoop 08/04/05  Fixed bug in GET_RAID_CONFIG		      */
/* 2.1-3   Anoop 08/16/05  Fixed minor bug in SAS Address Display     */
/*                         for GET_RAID_CONFIG                        */
/* 2.1-3   Vyas  09/19/05  Added support for CC_CSMI_SAS_GET_LOCATION */
/* 			   IOCTL	                              */
/**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include "csmisas.h"
#include "misc.h"
//#include "display.h"
//#include "issue_functions.c"


#ifdef _linux 
	int ostype = LINUX;
	int fd = 0;
	int handle = 0;
#endif

#ifdef _WIN32
	int ostype = WINDOWS;
	int fd = 0;
	HANDLE handle = 0;
	char temp_file_path[MAX_PATH];
	char type_command_string[MAX_PATH + 6];

#endif

#ifdef _NETWARE
	int ostype = NETWARE;
	int fd =0;
	int handle = 0;	
#endif






#define TOOL_MAJOR_VERSION	2
#define TOOL_MINOR_VERSION	2
#define TOOL_RELEASE_NUMBER	3
#define CSMI_VERSION_MAJ    	0
#define CSMI_VERSION_MIN    	90



	


FILE *fp = NULL;
FILE *tempo = NULL;
int hexDumper; // This is for the HEX Dump information
int descr;
int io_controller_number = 0;
int no_print = 0;
//int counter = 0;


//#define printf if(no_print == 0) printf
//#define sysprint if(no_print == 0) system("more /tmp/csmi_temp.txt");
//#define printf counter++; if(counter > 30) { puts("\nPress a key...\n"); getc(stdin); getc(stdin); counter = 0; clearScreen(); }  if(no_print == 0) printf


int main (int argc, char *argv[])
{

	char dev_node[20];
	int get_driver_info = 0, get_ctlr_config = 0, get_ctlr_status = 0;
	int get_raid_info = 0, get_raid_config = 0, get_phy_info = 0;
	int stp_passthru=0, ssp_passthru=0;
	int drive_by_menu = 0;
	int run_all_options = 0;
	char fileOpen = 0;
	char choice;
	int i;
	int turns = 1000;

	/* char tmp[80]; Changed on 24 Aug 2005 - Compatibility*/
	time_t rawtime;
	char wday_name[7][3] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
	char mon_name[12][3] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
								 "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"        };

	struct tm *timeinfo;

	#ifdef _WIN32
		get_temp_file_path();
	#endif

	tempo = fopen(TEMP_FILE_NAME,"w");

	for(i=1;i<argc;i++)
	{
		if(strcmp(argv[i],"-f") == 0)
		{
			fp = fopen(argv[i+1],"w");
			fileOpen = 1;
		/***************ADDED on Aug 19th 05*************/	
			no_print = 1;
			DisplayTitle(ostype,TOOL_MAJOR_VERSION, 
				TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER,
				CSMI_VERSION_MAJ,CSMI_VERSION_MIN
			     );
			no_print = 0; 
			fprintf(fp,"\n \n File Name : %s \n \n",argv[i+1]);
			
			time ( &rawtime );
			timeinfo = localtime (&rawtime);

			fprintf(fp,"Date : %.3s/%.2d/%d  %.2d:%.2d:%.2d\n",
				mon_name[timeinfo->tm_mon],
				timeinfo->tm_mday,
				1900 + timeinfo->tm_year,
			 	timeinfo->tm_hour,
				timeinfo->tm_min,
				timeinfo->tm_sec
				);

			//fprintf(fp,"\n %s",tmp);

			fprintf(fp,"\n _______________________________________________________\n");

		
                         
		}
	}
	/*************************************************************/



	/*if(fileOpen != 1)
	{
		time_t rawtime;
		struct tm * timeinfo;
		char tmp[80];
		char wday_name[7][3] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
		char mon_name[12][3] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
								 "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"        };

		time ( &rawtime );
		timeinfo = localtime (&rawtime);

		sprintf(tmp,"output-%.3s-%.3s-%2d-%.2d-%.2d-%.2d-%d.txt",
				wday_name[timeinfo->tm_wday],
				mon_name[timeinfo->tm_mon],
				timeinfo->tm_mday, timeinfo->tm_hour,
				timeinfo->tm_min, timeinfo->tm_sec,
				1900 + timeinfo->tm_year); 

		sprintf(tmp,"output_%.3s-%.2d-%d_%.2d-%.2d-%.2d.txt",
				mon_name[timeinfo->tm_mon],
				timeinfo->tm_mday,
				1900 + timeinfo->tm_year,
	  		    timeinfo->tm_hour,
				timeinfo->tm_min,
				timeinfo->tm_sec
				);



  		fp = fopen(tmp,"w");

		DisplayTitle(ostype,TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER,CSMI_VERSION_MAJ,CSMI_VERSION_MIN);

		fprintf(fp,"\n \n File Name : %s \n \n",tmp);
		sprintf(tmp,"Date : %.3s/%.2d/%d  %.2d:%.2d:%.2d\n",
				mon_name[timeinfo->tm_mon],
				timeinfo->tm_mday,
				1900 + timeinfo->tm_year,
	  		    timeinfo->tm_hour,
				timeinfo->tm_min,
				timeinfo->tm_sec
				);


		fprintf(fp,"\n %s",tmp);

		fprintf(fp,"\n _______________________________________________________\n");

	}*/




	if(argc == 1)
		goto interactive;
	else if(argc < 5)
	{
		PrintUsage(ostype);
		exit(0);
	}

	if(argc >= 5)
	{
		drive_by_menu = 1;
		hexDumper = 0;
		descr = 0;

		for(i=1;i<argc;i++)
		{
			if(strcmp(argv[i],"-d") == 0)
			{
				strcpy(dev_node,argv[i+1]);
			}

			if(strcmp(argv[i],"-c") == 0)
			{
				io_controller_number = atoi(argv[i+1]);
			}

			if(strcmp(argv[i],"-a") == 0)
			{
				get_driver_info = 0;
				get_ctlr_config = 0;
				get_ctlr_status = 0;
				get_raid_info   = 0;
				get_raid_config = 0;
				get_phy_info    = 1;
				stp_passthru    = 0;
				ssp_passthru    = 1;
				drive_by_menu   = 0;
				run_all_options = 1;	
						
			}

			if(strcmp(argv[i],"-h") == 0)
			{
				hexDumper = 1;
			}

			if(strcmp(argv[i],"-v") == 0)
			{
				descr = 1;
			}

			if(strcmp(argv[i],"-help") == 0)
			{
				PrintUsage(ostype);
				exit(0);
			}

		}
		goto donner;
	}




interactive:
	printf("\n Launching interactive mode.\n");


tryagain:


		DoPreInitRoutine();
/*
		if(ostype == WINDOWS)
		{
			DoWindowsPreInitRoutine();
		}

		if(ostype == LINUX)
		{
			DoLinuxPreInitRoutine();
		}

		if(ostype == NETWARE)
		{
			DoNetwarePreInitRoutine();
		// NETWARE : Any additional inputs/display if required
		} */

		scanf("%s",dev_node);
		if(strcmp(dev_node,"") == 0)
		{
			printf("\n Invalid Input. Please Try again. \n");
			goto tryagain;
		}
        if(ostype != WINDOWS)
		{
			printf("\n Enter the Controller Number : (enter 999 for default) :");
			scanf("%d",&io_controller_number);
			if(io_controller_number == 999)
				io_controller_number = 0;
		}
		else
		{
			io_controller_number = 0;
		}

//		printf("\n Do you want Menu Based Interface(m) or Test All ioctls(a):(m)/(a):");
//		scanf("%s",&choice);
		choice = 'm';

		switch(choice)
		{
			case 'a':
					get_driver_info = 0;
					get_ctlr_config = 0;
					get_ctlr_status = 0;
					get_raid_info   = 0;
					get_raid_config = 0;
					get_phy_info    = 1;
					stp_passthru	= 0;
					ssp_passthru	= 1;
					break;
			case 'm':
					drive_by_menu=1;
					break;
			default :
					printf("\n Invalid Input. Please Try again.\n");
					goto tryagain;

					break;
		}

//		printf("\n Do you want the HEX Dump Debug Information to be printed:(y)/(n): ");
//		scanf("%s",&choice);
		choice = 'n';

		switch(choice)
		{
			case 'y':
			case 'Y':
				hexDumper = 1; break;
			case 'n':
			case 'N':
				hexDumper = 0; break;
			default :
				printf("\n Invalid Input. Please Try again. \n");
				goto tryagain;
				break;
		}

//		printf("\n Do you want Description Information to be printed:(y)/(n): ");
//		scanf("%s",&choice);
		choice = 'n';

		switch(choice)
		{
			case 'y':
			case 'Y':
				descr = 1; break;
			case 'n':
			case 'N':
				descr = 0; break;
			default :
				printf("\n Invalid Input. Please Try again. \n");
				goto tryagain;
				break;
		}



donner:

		DoInitRoutine(dev_node);
/*
	if(ostype == LINUX)
	{
	   DoLinuxInitRoutine(dev_node);
	}


	if(ostype == WINDOWS)
	{
		DoWindowsInitRoutine(dev_node);
	}


	if(ostype == NETWARE)
	{
	    DoNetwareInitRoutine(dev_node);
	} */



	if(drive_by_menu == 1)
	{
		menu_driven_testing();
		no_print = 0;
	}
	/* No O/P to stdout when both -a & -f options are used */
	else  {
		if((run_all_options && fileOpen))
		//printf("Here we go\n");
		no_print = 1;
	}

	while(turns > 0) {
	if(get_driver_info == 1)
		issue_get_driver_info();
	if(get_ctlr_config == 1)
		issue_get_ctlr_config();
	if(get_ctlr_status == 1)
		issue_get_ctlr_status();
	if(get_raid_info == 1)
		issue_get_raid_info();
	if(get_raid_config == 1)
		issue_get_raid_config();
	if(get_phy_info == 1)
		issue_get_phy_info();
	if(stp_passthru == 1)
		issue_sas_stp_passthru();
	if(ssp_passthru == 1)
		issue_sas_ssp_passthru();
	turns--;
}
	if(fp)
		fclose(fp);
	

	
	return 0;

}









void menu_driven_testing()
{
	int HostIndex, PathId, TargetId, LunId;
	int NegLinkRate, MinLinkRate, MaxLinkRate;
	int option=1, PhyId;
	char fname[32];
	char input[32];


	clearScreen();

	while(option != 23){
		printf("                    CSMI IOCTL TESTING                \n");
		printf("_______________________________________________________\n");
		printf(" 1. CC_CSMI_SAS_GET_DRIVER_INFO \n");
		printf(" 2. CC_CSMI_SAS_GET_CNTLR_CONFIG \n");
		printf(" 3. CC_CSMI_SAS_GET_CNTLR_STATUS \n");
		printf(" 4. CC_CSMI_SAS_FIRMWARE_DOWNLOAD \n");
		printf(" 5. CC_CSMI_SAS_GET_RAID_INFO \n");
		printf(" 6. CC_CSMI_SAS_GET_RAID_CONFIG \n");
		printf(" 7. CC_CSMI_SAS_GET_PHY_INFO \n");
		printf(" 8. CC_CSMI_SAS_GET_LINK_ERRORS \n");
		printf(" 9. CC_CSMI_SAS_SMP_PASSTHROUGH \n");
		printf("10. CC_CSMI_SAS_SSP_PASSTHROUGH \n");
		printf("11. CC_CSMI_SAS_STP_PASSTHROUGH \n");
		printf("12. CC_CSMI_SAS_GET_SATA_SIGNATURE \n");
		printf("13. CC_CSMI_SAS_GET_SCSI_ADDRESS \n");
		printf("14. CC_CSMI_SAS_GET_DEVICE_ADDRESS \n");
		printf("15. CC_CSMI_SAS_SET_PHY_INFO \n");
		printf("16. CC_CSMI_SAS_TASK_MANAGEMENT \n");
		printf("17. CC_CSMI_SAS_GET_CONNECTOR_INFO \n");
		printf("18. CC_CSMI_SAS_GET_LOCATION\n");
		printf("19. CC_CSMI_SAS_GET_RAID_FEATURES\n");
		printf("20. CC_CSMI_SAS_SET_RAID_CONTROL\n");
		printf("21. CC_CSMI_SAS_GET_RAID_ELEMENT\n");
		printf("22. CC_CSMI_SAS_SET_RAID_OPERATION\n");
		printf("'d' : Debug  'e' : Description  'q' : Quit  \n");

		printf("\n\n\n\n");
		printf("Enter the IOCTL number: ");
		scanf("%s", &input);

		option = atoi(input);

		if(strcmp(input,"q") == 0 || strcmp(input,"Q") == 0) { 
			option = 99; 
                        fclose(fp); 
		}

		if(strcmp(input,"d") == 0 || strcmp(input,"D") == 0) { 
			option = 97; 
		}

		if(strcmp(input,"e") == 0 || strcmp(input,"E") == 0) { 
			option = 98; 
		}



		clearScreen();



		switch(option){
			case 1:
				issue_get_driver_info();
				break;
			case 2:
				issue_get_ctlr_config();
				break;
			case 3:
				issue_get_ctlr_status();
				break;
			case 4:
				printf("Enter the image name: ");
				scanf("%s", fname);
				issue_firmware_download(fname);
				break;
			case 5:
				issue_get_raid_info();
				break;
			case 6:
				issue_get_raid_config();
				break;
			case 7:
				issue_get_phy_info();
				break;
			case 8:
				printf("Enter the Phy Identifier(decimal): ");
				scanf("%d", &PhyId);
				issue_get_link_error((char)PhyId);
				break;

			case 9:
				issue_sas_smp_passthru();
				break;

			case 10:
				issue_sas_ssp_passthru();
				break;

			case 11:
				issue_sas_stp_passthru();
				break;

			case 12:
				printf("Enter the Phy Identifier(decimal): ");
				scanf("%d", &PhyId);
				issue_get_sata_signature((char)PhyId);
				break;

			case 13:
				printf("Enter the Target ID (decimal): ");
				scanf("%d", &TargetId);
				printf("Enter the LUN ID (decimal): ");
				scanf("%d", &LunId);
				issue_get_scsi_address(TargetId, LunId);
				break;

			case 14:
				printf("Enter the Host Index (decimal): ");
				scanf("%d", &HostIndex);
				printf("Enter the Path ID (decimal): ");
				scanf("%d", &PathId);
				printf("Enter the Target ID (decimal): ");
				scanf("%d", &TargetId);
				printf("Enter the LUN ID (decimal): ");
				scanf("%d", &LunId);
				issue_get_device_address(HostIndex, PathId, TargetId, LunId);
				break;

			case 15:
				printf("Enter the Phy Identifier (decimal): ");
				scanf("%d", &PhyId);
				printf("Enter the Negotiated Link Rate \n");
				printf(" [Negotiate a new link rate (0) / Disable the Phy (1)] : \n");
				scanf("%d", &NegLinkRate);

				printf("Enter the Minimum Link Rate \n");
				printf(" [ Unchanged (0) / 1.5 Gb/s (8) / 3.0 Gb/s (9)] : \n");
				scanf("%d", &MinLinkRate);

				printf("Enter the Maximum Link Rate \n");
				printf(" [ Unchanged (0) / 1.5 Gb/s (8) / 3.0 Gb/s (9)] : \n");
				scanf("%d", &MaxLinkRate);

				issue_set_phy_info(PhyId, NegLinkRate, MinLinkRate,
				    MaxLinkRate);
				break;
			case 16:
                                printf("Enter the Host Index (decimal): ");
                                scanf("%d", &HostIndex);
                                printf("Enter the Path ID (decimal): ");
                                scanf("%d", &PathId);
                                printf("Enter the Target ID (decimal): ");
                                scanf("%d", &TargetId);
                                printf("Enter the LUN ID (decimal): ");
                                scanf("%d", &LunId);
                                issue_sas_task_management( HostIndex, PathId, TargetId, LunId);
                                break;
			case 17:
					issue_get_connector_info();
					break;
			case 18:
				printf("Enter the Host Index	(decimal): ");
				scanf("%d",&HostIndex);
				printf("Enter the Path Id 	(decimal) : ");
				scanf("%d",&PathId);
				printf("Enter the Target Id 	(decimal) : ");
				scanf("%d",&TargetId);
				printf("Enter the LUN Id	(decimal) : ");
				scanf("%d",&LunId);
				issue_sas_get_location(HostIndex,PathId,TargetId , LunId);
				break;
			case 19:
				issue_sas_get_raid_features();
				break;
			case 20:
				issue_sas_set_raid_control();
				break;
				
			case 21:
				issue_sas_get_raid_element();
				break;
			case 22:
				issue_sas_set_raid_operation();
				break;

			case 97:
					 if(hexDumper == 0)
					 {
						 hexDumper = 1;
						 printf("Debug mode is ON....\n");
					 }
					 else
					 {
						 hexDumper = 0;
						 printf("Debug mode is OFF....\n");
					 }
					 break;

			case 98:
				     if(descr == 0)
					 {
						 descr = 1;
						 printf("Description mode is ON....\n");
					 }
					 else
					 {
						 descr = 0;
						 printf("Description mode is OFF....\n");
					 }
					 break;

			case 99:
				_exit(EXIT_SUCCESS);
			default:
				printf("Invalid Option\n");
				break;
		}

		printf("\n Press [ENTER] to continue......... \n");




		while(getc(stdin) != '\n');

//		if(getc(stdin)) continue;

        getc(stdin);




		clearScreen();

	}
}





