#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>

#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include "csmisas.h"
#include "misc.h"

extern int hexDumper;
extern FILE *fp;
extern FILE *tempo;
extern int no_print;
extern int descr;
extern int ostype;
extern int fd;


#ifdef _WIN32
	extern HANDLE handle;
	extern char temp_file_path[];
	extern char type_command_string[];
#else
	extern int handle;
#endif



/* Added on 19th Aug 05
 * Temporary files are now only in /tmp directory*/

//#define TEMP_FILE_NAME "/tmp/csmi_temp.txt"

//#define printf if(no_print == 0) printf
//#define sysprint if(no_print == 0) system("more /tmp/csmi_temp.txt");


//#define printf counter++; if(counter > 30) { puts("\nPress a key...\n"); getc(stdin); getc(stdin); counter = 0; clearScreen(); }  if(no_print == 0) printf

//#define fprintf if(fileOpen) fprintf

void issue_get_driver_info()
{

	CSMI_SAS_DRIVER_INFO_BUFFER *DrvInfo;
	char *buffer;
        int bufferSize = 16384;
	char *s;
	long returnCode;


	tempo = fopen(TEMP_FILE_NAME,"w");
	


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		DrvInfo = (CSMI_SAS_DRIVER_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		sysprint;
		exit(0);
	}

	PrintBefore_issue_get_driver_info(descr);

	set_header(DrvInfo, bufferSize , CC_CSMI_SAS_GET_DRIVER_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(DrvInfo,bufferSize,CC_CSMI_SAS_GET_DRIVER_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	}

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		sysprint;
		return;
	}

	DisplayIoctlHeader(DrvInfo->IoctlHeader);
	///printf("\tIOCTL Specific Data\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\t-------------------\n");
	DisplayDriverInfo(DrvInfo->Information);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	
	sysprint;

	if(buffer)
		free(buffer);

}








void issue_get_ctlr_config()
{

	CSMI_SAS_CNTLR_CONFIG_BUFFER *CtlrConfig;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		CtlrConfig = (CSMI_SAS_CNTLR_CONFIG_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	PrintBefore_issue_get_ctlr_config(descr);

	set_header(CtlrConfig,bufferSize,CC_CSMI_SAS_GET_CNTLR_CONFIG);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(CtlrConfig,bufferSize,CC_CSMI_SAS_GET_CNTLR_CONFIG);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	}

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	DisplayIoctlHeader(CtlrConfig->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\t-------------------\n");
	DisplayCntlrConfig(CtlrConfig->Configuration);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);

}






void issue_get_ctlr_status()
{

	CSMI_SAS_CNTLR_STATUS_BUFFER *CtlrStatus;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		CtlrStatus = (CSMI_SAS_CNTLR_STATUS_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	PrintBefore_issue_get_ctlr_status(descr);

	set_header(CtlrStatus,bufferSize,CC_CSMI_SAS_GET_CNTLR_STATUS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(CtlrStatus,bufferSize,CC_CSMI_SAS_GET_CNTLR_STATUS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	}

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	DisplayIoctlHeader(CtlrStatus->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\t-------------------\n");
	DisplayCntlrStatus(CtlrStatus->Status);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);

}



void issue_get_raid_info()
{

	CSMI_SAS_RAID_INFO_BUFFER *RaidInfo;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		RaidInfo = (CSMI_SAS_RAID_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	PrintBefore_issue_get_raid_info(descr);

	set_header(RaidInfo,bufferSize,CC_CSMI_SAS_GET_RAID_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(RaidInfo,bufferSize,CC_CSMI_SAS_GET_RAID_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	}

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		

		return;
	}

	DisplayIoctlHeader(RaidInfo->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\t-------------------\n");
	DisplayRaidInfo(RaidInfo->Information);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);
}




void issue_get_raid_config()
{
	CSMI_SAS_RAID_CONFIG_BUFFER *raidConfig;
	CSMI_SAS_RAID_INFO_BUFFER *RaidInfo;
	char *buffer;
    int bufferSize = 2<<14;
	char *s;
	long returnCode;
	unsigned long TotalRaidSets, MaxDrivesPerSet;
	int raidIndex = 0, raid_set_count = 0;
	int choice = 0;

	tempo = fopen(TEMP_FILE_NAME,"w");

    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		RaidInfo = (CSMI_SAS_RAID_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	set_header(RaidInfo,bufferSize,CC_CSMI_SAS_GET_RAID_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	
	returnCode = call_ioctl(RaidInfo,bufferSize,CC_CSMI_SAS_GET_RAID_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	} 

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}


	MaxDrivesPerSet = RaidInfo->Information.uMaxDrivesPerSet;
	TotalRaidSets = RaidInfo->Information.uNumRaidSets;

	
	if(buffer)
		free(buffer);

    buffer = (char *)calloc(1,bufferSize);
    //buffer = (char*) malloc(sizeof(CSMI_SAS_RAID_CONFIG_BUFFER) + ((MaxDrivesPerSet -1) * sizeof(CSMI_SAS_RAID_DRIVES) ) + sizeof(IOCTL_HEADER));
    //bufferSize = sizeof(CSMI_SAS_RAID_CONFIG_BUFFER) + ((MaxDrivesPerSet -1 ) * sizeof(CSMI_SAS_RAID_DRIVES) + sizeof(IOCTL_HEADER));
    //memset(buffer,7,bufferSize);


	if(buffer)
	{
		raidConfig = (CSMI_SAS_RAID_CONFIG_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	PrintBefore_issue_get_raid_config(descr);

	raidIndex = 0;
	choice = get_choice();
        raidConfig->Configuration.uFailureCode = 0;

	while(raid_set_count != TotalRaidSets )
    {

		//printf("\n Raid Config Number %d \n", raidIndex);
		print_to_file(fp,"\n Raid Config Number %d \n", raidIndex);
		fprintf(tempo,"\n Raid Config Number %d \n", raidIndex);
		memset(raidConfig,0,bufferSize);


		raidConfig->Configuration.uRaidSetIndex = raidIndex;
		raidConfig->Configuration.bDataType     = choice;

		set_header(raidConfig,bufferSize,CC_CSMI_SAS_GET_RAID_CONFIG);

		if(hexDumper)
			{
				s = buffer;
				DisplayDumpBefore(s);
			}


		returnCode = call_ioctl(raidConfig,bufferSize,CC_CSMI_SAS_GET_RAID_CONFIG);

		if(hexDumper)
		{
			s = buffer;
			DisplayDumpAfter(s);
		}
		

		if(returnCode == 0)
		{
			//printf("\n Error in issuing the ioctl \n");
			print_to_file(fp,"\n Error in issuing the ioctl \n");
			fprintf(tempo,"\n Error in issuing the ioctl \n");
			fclose(tempo);
			sysprint;
			return;
		}

		if(raidConfig->Configuration.bDriveCount == 0) {
			raidIndex++;
			continue;
		}
		else 
			raid_set_count++;
		
		DisplayIoctlHeader(raidConfig->IoctlHeader);
		//printf("\tIOCTL Specific Data\n");
		print_to_file(fp,"\tIOCTL Specific Data\n");
		fprintf(tempo,"\tIOCTL Specific Data\n");
		//printf("\t-------------------\n");
		print_to_file(fp,"\t-------------------\n");
		fprintf(tempo,"\t-------------------\n");
		DisplayRaidConfig(&raidConfig->Configuration);
                Check_ReturnCode_Raid_Config(raidConfig);
		raidIndex++;
	}

	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");


	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);

}

int get_choice()
{
	int choice = 0;
	int selected = 0;
	
	printf("Select a Choice for Info Type For RAID SETS\n");
	printf("1> DRIVES\n");
	printf("2> DEVICE ID\n");
	printf("3> Additional Data\n");

	printf("Enter your choice:");
	scanf("%d",&choice);
	switch(choice){
		case 1:
			return CSMI_SAS_RAID_DATA_DRIVES;
			
		case 2:
			return  CSMI_SAS_RAID_DATA_DEVICE_ID;
			
		case 3:
			return CSMI_SAS_RAID_DATA_ADDITIONAL_DATA;
			
		default:
			print_to_file(fp,"\n Unknown Value : Defaulting to Option 1 \n");
			fprintf(tempo,"\n Unknown Value : Defaulting to option 1 \n");
                        return CSMI_SAS_RAID_DATA_DRIVES; 
	}
	
}


void issue_get_phy_info()
{


	CSMI_SAS_PHY_INFO_BUFFER *PhyInfo;
//	int PhyIndex;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		PhyInfo = (CSMI_SAS_PHY_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	PrintBefore_issue_get_phy_info(descr);

	set_header(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	}

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}


	DisplayIoctlHeader(PhyInfo->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");

	print_to_file(fp,"\tIOCTL Specific Data\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\t-------------------\n");
	DisplayPhyInfo(PhyInfo->Information);

/*		for(PhyIndex = 0; PhyIndex < PhyInfo->Information.bNumberOfPhys; PhyIndex++)
		{
			issue_get_link_error(PhyInfo->Information.Phy[PhyIndex].Identify.bPhyIdentifier);
			issue_get_sata_signature(PhyInfo->Information.Phy[PhyIndex].Identify.bPhyIdentifier);
		} */

	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;


	if(buffer)
		free(buffer);
}





void issue_get_link_error(unsigned char bPhyIdentifier)
{

	CSMI_SAS_LINK_ERRORS_BUFFER *ErrorInfo;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");

    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		ErrorInfo = (CSMI_SAS_LINK_ERRORS_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	PrintBefore_issue_get_link_error(descr);

	set_header(ErrorInfo,bufferSize,CC_CSMI_SAS_GET_LINK_ERRORS);


   // get information for each phy then reset the counts
   ErrorInfo->Information.bPhyIdentifier = bPhyIdentifier;
   ErrorInfo->Information.bResetCounts = CSMI_SAS_LINK_ERROR_RESET_COUNTS;

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(ErrorInfo,bufferSize,CC_CSMI_SAS_GET_LINK_ERRORS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	}

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	DisplayIoctlHeader(ErrorInfo->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	print_to_file(fp,"\t-------------------\n");

	fprintf(tempo,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\t-------------------\n");


	DisplayErrorInfo(ErrorInfo->Information);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;


	if(buffer)
		free(buffer);
}








void issue_sas_ssp_passthru()
{


	CSMI_SAS_SSP_PASSTHRU_BUFFER *PassthruBuff;
	CSMI_SAS_PHY_INFO_BUFFER *PhyInfo;

	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;
	char *buffer2;
    int bufferSize2 = 16384;
	unsigned char *bufferX = 0;
	int bufferSizeX = 0;
	int SectorCount = 1;
	int phy;
	int CommandCount;
	int i;






// This structure is not actually used....

	struct SspCommands SspCommands[] =
   {
	  { "1. Test Unit Ready", 0, 0,  CSMI_SAS_SSP_READ, 0x12, 0xFF, 0x00, 0x00, 0x01},
      { "2. Standard Inquiry", 0, 0,  CSMI_SAS_SSP_READ, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "3. Compaq Specific Inquiry", 0, 0,  CSMI_SAS_SSP_READ, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "4. Serial Number Inquiry", 0, 0,  CSMI_SAS_SSP_READ, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "5. Read Capacity", 0, 0,  CSMI_SAS_SSP_READ, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "6. Used Realloc", 0, 0,  CSMI_SAS_SSP_READ, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "7. Mode Sense - Disk Geometry", 0, 0,  CSMI_SAS_SSP_READ, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "8. Mode Sense - SMART Availability ", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "9. Mode Sense - Autoloader Magazine Size", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "10. Log Sense", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "11. Log Sense - Tape Stuff", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "12. Log Sense - SMART Status", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "13. Log Sense - Write Counters", 0, 0,  CSMI_SAS_SSP_WRITE, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
	  { "14. Log Sense - Read Counters", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
//	  { "15. Proliant Box Alarm Page", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
//	  { "16. Proliant Box Serial Number", 0, 0,  CSMI_SAS_SSP_READ, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
      { 0 }
   };

	 PCDB pCdb;
	BUS_INQUIRY_DATA pdata;
	unsigned long size = sizeof(BUS_INQUIRY_DATA);

	 tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		PhyInfo = (CSMI_SAS_PHY_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	PrintBefore_issue_ssp_passthru(descr);


	set_header(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	//printf("\n Total No of Phys is : %d \n",PhyInfo->Information.bNumberOfPhys);
	print_to_file(fp,"\n Total No of Phys is : %d \n",PhyInfo->Information.bNumberOfPhys);
	fprintf(tempo,"\n Total No of Phys is : %d \n",PhyInfo->Information.bNumberOfPhys);






	for(phy = 0; (phy < PhyInfo->Information.bNumberOfPhys); phy++)
    {
		//printf("\n Phy is : %d \n",phy);
		print_to_file(fp,"\n Phy is : %d \n",phy);
		fprintf(tempo,"\n Phy is : %d \n",phy);
        if( ((PhyInfo->Information.Phy[phy].Attached.bDeviceType == CSMI_SAS_END_DEVICE) &&
             (PhyInfo->Information.Phy[phy].Attached.bTargetPortProtocol &
              (CSMI_SAS_PROTOCOL_SATA |
              CSMI_SAS_PROTOCOL_SSP))))
		{
			//printf("\n The Command can be executed for this Phy \n");
			print_to_file(fp,"\n The Command can be executed for this Phy \n");
			fprintf(tempo,"\n The Command can be executed for this Phy \n");
			for( CommandCount = 0; SspCommands[CommandCount].CommandName; CommandCount++ )
				
            {

		    /*if((strcmp(SspCommands[CommandCount].CommandName , "2. Standard Inquiry") != 0))
			    continue;*/
		
				if( (SspCommands[CommandCount].flags & CSMI_SAS_SSP_UNSPECIFIED) )
                {
                   bufferSizeX = 0;
                   bufferX = NULL;
                }
                else
                {
                    bufferSizeX = SectorCount * 0x200;
                    bufferX = ( unsigned char *)calloc(1,bufferSizeX);
                }

				//printf("\n Command Name : %s ---- Phy %d \n",SspCommands[CommandCount].CommandName,phy);
				print_to_file(fp,"\n Command Name : %s ---- Phy %d \n",SspCommands[CommandCount].CommandName,phy);
				fprintf(tempo,"\n Command Name : %s ---- Phy %d \n",SspCommands[CommandCount].CommandName,phy);


				if( bufferX )
                {
                    memset(bufferX, 0, bufferSizeX);
                    // If this is a write and there is a buffer specified in the table,
                    // then use the data in the table to fill in the buffer.
                    if( (SspCommands[CommandCount].flags & CSMI_SAS_SSP_WRITE ) && SspCommands[CommandCount].String)
                    {
                        memcpy(bufferX, SspCommands[CommandCount].String, SspCommands[CommandCount].stringSize);
                    }
                } // End of if for bufferX



				buffer2 = (char *)calloc(1,(bufferSize2+bufferSizeX));
				memset(buffer2,0,(bufferSize2+bufferSizeX));



				if(buffer2)
				{
					PassthruBuff = (CSMI_SAS_SSP_PASSTHRU_BUFFER *)buffer2;
				}
				else
				{
					//printf("\n Error in allocating the Buffer. \n");
					print_to_file(fp,"\n Error in allocating the Buffer. \n");
					fprintf(tempo,"\n Error in allocating the Buffer. \n");
					exit(0);
				}


				memset(&PassthruBuff->Status,0,sizeof(PassthruBuff->Status));
				PassthruBuff->Parameters.bPhyIdentifier = phy;
				PassthruBuff->Parameters.bPortIdentifier = CSMI_SAS_IGNORE_PORT;
				PassthruBuff->Parameters.bConnectionRate = CSMI_SAS_LINK_RATE_NEGOTIATED;
				memset(&PassthruBuff->Parameters.bReserved,0,sizeof(PassthruBuff->Parameters.bReserved));
				memset(&PassthruBuff->Parameters.bReserved2,0,sizeof(PassthruBuff->Parameters.bReserved2));
//				memcpy(PassthruBuff->Parameters.bLun,PhyInfo->Information.
		         memcpy(&PassthruBuff->Parameters.bDestinationSASAddress[0],
                PhyInfo->Information.Phy[phy].Attached.bSASAddress,8);




				if(CommandCount == 0)
				{
					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->CDB6GENERIC.OperationCode = 0x00;
					pCdb->CDB6GENERIC.LogicalUnitNumber = 0;
				}

				if(CommandCount == 1)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->CDB6INQUIRY.OperationCode = 0x12;
					pCdb->CDB6INQUIRY.AllocationLength =255;
					pCdb->CDB6INQUIRY.LogicalUnitNumber = 0;
					pCdb->CDB6INQUIRY.PageCode = 0;
					pCdb->CDB6GENERIC.Immediate = 0;  // Set bit if page is non-zero*/
				}

				if(CommandCount == 2)
				{
					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->CDB6INQUIRY.OperationCode = 0x12;
					pCdb->CDB6INQUIRY.AllocationLength = 255;
					pCdb->CDB6INQUIRY.LogicalUnitNumber = 0;
					pCdb->CDB6INQUIRY.PageCode = 0;
					pCdb->CDB6GENERIC.Immediate = 0;  // Set bit if page is non-zero
					PassthruBuff->Parameters.bCDB[1] = 0x01;
					PassthruBuff->Parameters.bCDB[2] = 0xCC;
				}

				if(CommandCount == 3)
				{
					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->CDB6INQUIRY.OperationCode = 0x12;
					pCdb->CDB6INQUIRY.AllocationLength = 255;
					pCdb->CDB6INQUIRY.LogicalUnitNumber = 0;
					pCdb->CDB6INQUIRY.PageCode = 0;
					pCdb->CDB6GENERIC.Immediate = 0;  // Set bit if page is non-zero
					PassthruBuff->Parameters.bCDB[1] = 0x01;
					PassthruBuff->Parameters.bCDB[2] = 0x80;
				}

				if(CommandCount == 4)
				{
			      pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
			      pCdb->CDB10.OperationCode = 0x25;
				  pCdb->CDB10.LogicalUnitNumber = 0;
				}

				if(CommandCount == 5)
				{
			      pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
			      pCdb->CDB10.OperationCode = 0x37;
				  pCdb->CDB10.LogicalUnitNumber = 0;
				  PassthruBuff->Parameters.bCDB[1] = 0;
				  PassthruBuff->Parameters.bCDB[2] = 0x15;
				}

				if(CommandCount == 6)
				{
				    pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->MODE_SENSE6.OperationCode = 0x1A;
					pCdb->MODE_SENSE6.LogicalUnitNumber = 0;
					pCdb->MODE_SENSE6.PageCode = 0x04;
					pCdb->MODE_SENSE6.AllocationLength = 0xff;
					pCdb->MODE_SENSE6.Dbd = 1;         // No description block
					pCdb->MODE_SENSE6.Pc = 0;         // Current data only
				}


				if(CommandCount == 7)
				{
				    pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->MODE_SENSE6.OperationCode = 0x1A;
					pCdb->MODE_SENSE6.LogicalUnitNumber = 0;
					pCdb->MODE_SENSE6.PageCode = 0x1C;
					pCdb->MODE_SENSE6.AllocationLength = 0xff;
					pCdb->MODE_SENSE6.Dbd = 1;         // No description block
					pCdb->MODE_SENSE6.Pc = 0;         // Current data only
				}

				if(CommandCount == 8)
				{
				    pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->MODE_SENSE6.OperationCode = 0x1A;
					pCdb->MODE_SENSE6.LogicalUnitNumber = 0;
					pCdb->MODE_SENSE6.PageCode = 0x1D;
					pCdb->MODE_SENSE6.AllocationLength = 0xff;
					pCdb->MODE_SENSE6.Dbd = 1;         // No description block
					pCdb->MODE_SENSE6.Pc = 0;         // Current data only
				}


				if(CommandCount == 9)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->LOGSENSE.OperationCode = 0x4D;
					pCdb->LOGSENSE.LogicalUnitNumber = 0;
					pCdb->LOGSENSE.PageCode = 0;
					pCdb->LOGSENSE.Control = 0;
					pCdb->LOGSENSE.SPBit  = 0;
					pCdb->LOGSENSE.PPCBit = 0;
					pCdb->LOGSENSE.PCBit  = 1;
					pCdb->LOGSENSE.AllocationLength[1] = 0xFF;

				}

				if(CommandCount == 10)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->LOGSENSE.OperationCode = 0x4D;
					pCdb->LOGSENSE.LogicalUnitNumber = 0;
					pCdb->LOGSENSE.PageCode = 0;
					pCdb->LOGSENSE.Control = 0;
					pCdb->LOGSENSE.SPBit  = 0;
					pCdb->LOGSENSE.PPCBit = 0;
					pCdb->LOGSENSE.PCBit  = 1;
					pCdb->LOGSENSE.AllocationLength[1] = 0xFF;
					PassthruBuff->Parameters.bCDB[2] = 0x3E + 0x40;

				}

				if(CommandCount == 11)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->LOGSENSE.OperationCode = 0x4D;
					pCdb->LOGSENSE.LogicalUnitNumber = 0;
					pCdb->LOGSENSE.PageCode = 0;
					pCdb->LOGSENSE.Control = 0;
					pCdb->LOGSENSE.SPBit  = 0;
					pCdb->LOGSENSE.PPCBit = 0;
					pCdb->LOGSENSE.PCBit  = 1;
					pCdb->LOGSENSE.AllocationLength[1] = 0xFF;
					PassthruBuff->Parameters.bCDB[2] = 0x2F + 0x40;

				}

				if(CommandCount == 12)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->LOGSENSE.OperationCode = 0x4D;
					pCdb->LOGSENSE.LogicalUnitNumber = 0;
					pCdb->LOGSENSE.PageCode = 0;
					pCdb->LOGSENSE.Control = 0;
					pCdb->LOGSENSE.SPBit  = 0;
					pCdb->LOGSENSE.PPCBit = 0;
					pCdb->LOGSENSE.PCBit  = 1;
					pCdb->LOGSENSE.AllocationLength[1] = 0xFF;
					PassthruBuff->Parameters.bCDB[2] = 0x02 + 0x40;

				}

				if(CommandCount == 13)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->LOGSENSE.OperationCode = 0x4D;
					pCdb->LOGSENSE.LogicalUnitNumber = 0;
					pCdb->LOGSENSE.PageCode = 0;
					pCdb->LOGSENSE.Control = 0;
					pCdb->LOGSENSE.SPBit  = 0;
					pCdb->LOGSENSE.PPCBit = 0;
					pCdb->LOGSENSE.PCBit  = 1;
					pCdb->LOGSENSE.AllocationLength[1] = 0xFF;
					PassthruBuff->Parameters.bCDB[2] = 0x03 + 0x40;

				}

/*				if(CommandCount == 14)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->LOGSENSE.OperationCode = 0x08;
					pCdb->LOGSENSE.LogicalUnitNumber = 0;
					pCdb->LOGSENSE.PageCode = 0;
					pCdb->LOGSENSE.Control = 0;
					pCdb->LOGSENSE.SPBit  = 0;
					pCdb->LOGSENSE.PPCBit = 0;
					pCdb->LOGSENSE.PCBit  = 1;
					pCdb->LOGSENSE.AllocationLength[1] = 0xFF;
					PassthruBuff->Parameters.bCDB[3] = 0x81;
					PassthruBuff->Parameters.bCDB[4] = 0xFF;


				}

				if(CommandCount == 15)
				{

					pCdb = (PCDB)PassthruBuff->Parameters.bCDB;
					pCdb->LOGSENSE.OperationCode = 0x08;
					pCdb->LOGSENSE.LogicalUnitNumber = 0;
					pCdb->LOGSENSE.PageCode = 0;
					pCdb->LOGSENSE.Control = 0;
					pCdb->LOGSENSE.SPBit  = 0;
					pCdb->LOGSENSE.PPCBit = 0;
					pCdb->LOGSENSE.PCBit  = 1;
					pCdb->LOGSENSE.AllocationLength[1] = 0xFF;
					PassthruBuff->Parameters.bCDB[3] = 0x93;
					PassthruBuff->Parameters.bCDB[4] = 0xFF;

				} */




				 PassthruBuff->Parameters.bCDBLength = 16;

				 PassthruBuff->Parameters.uFlags = SspCommands[CommandCount].flags;


                 if(hexDumper)
				 {
					for(i=0;i<16;i++)
					{
						//printf("CDB %d is %x \n",i,PassthruBuff->Parameters.bCDB[i]);
						print_to_file(fp,"CDB %d is %x \n",i,PassthruBuff->Parameters.bCDB[i]);
						fprintf(tempo,"CDB %d is %x \n",i,PassthruBuff->Parameters.bCDB[i]);
					}
				 }



				// now copy the user buffer if the data is being written or is
				// unspecified, if it is a read then don't bother to copy the
				// buffer, it is already initialized to 0 from the calloc...
				if(bufferSizeX &&
					bufferX &&
					(SspCommands[CommandCount].flags &
					(CSMI_SAS_SSP_WRITE |
					CSMI_SAS_SSP_UNSPECIFIED)))
				{
					memcpy(&PassthruBuff->bDataBuffer,
						bufferX,
						bufferSizeX);

				}



		         // update the data length being requested
				PassthruBuff->Parameters.uDataLength = bufferSizeX;



				set_header(PassthruBuff,bufferSize,CC_CSMI_SAS_SSP_PASSTHRU);

				if(hexDumper)
				{
					s = buffer2;
					DisplayDumpBefore(s);
				}

/*
                fprintf(fp,"\n Before \n");

				fprintf(fp,"\n PassthruBuff->Parameters.bAdditionalCDB[24] \n");
				for(i=0;i<24;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bAdditionalCDB[i]);

				fprintf(fp,"\n PassthruBuff->Parameters.bAdditionalCDBLength %d \n",PassthruBuff->Parameters.bAdditionalCDBLength);

				fprintf(fp,"\n PassthruBuff->Parameters.bCDB[16] \n");

				for(i=0;i<16;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bCDB[i]);


				fprintf(fp,"\n PassthruBuff->Parameters.bCDBLength %d \n",PassthruBuff->Parameters.bCDBLength);

				fprintf(fp,"\n PassthruBuff->Parameters.bConnectionRate %d \n",PassthruBuff->Parameters.bConnectionRate);


				fprintf(fp,"\n PassthruBuff->Parameters.bLun[8] \n");
				for(i=0;i<8;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bLun[i]);

				fprintf(fp,"\n PassthruBuff->Parameters.bPhyIdentifier %d \n",PassthruBuff->Parameters.bPhyIdentifier);

				fprintf(fp,"\n PassthruBuff->Parameters.bPortIdentifier  %d \n",PassthruBuff->Parameters.bPortIdentifier );

				fprintf(fp,"\n PassthruBuff->Parameters.bReserved %d \n",PassthruBuff->Parameters.bReserved );

				fprintf(fp,"\n PassthruBuff->Parameters.uDataLength %d \n",PassthruBuff->Parameters.uDataLength );

				fprintf(fp,"\n PassthruBuff->Parameters.uFlags %d \n",PassthruBuff->Parameters.uFlags);

				fprintf(fp,"\n PassthruBuff->bDataBuffer %x \n",PassthruBuff->bDataBuffer );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.ControlCode %d \n",PassthruBuff->IoctlHeader.ControlCode );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.HeaderLength %d \n",PassthruBuff->IoctlHeader.HeaderLength);

				fprintf(fp,"\n PassthruBuff->IoctlHeader.Length  %d \n",PassthruBuff->IoctlHeader.Length );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.ReturnCode  %d \n",PassthruBuff->IoctlHeader.ReturnCode );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.Signature  %x \n",PassthruBuff->IoctlHeader.Signature );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.Timeout %d \n",PassthruBuff->IoctlHeader.Timeout );


				fprintf(fp,"\n PassthruBuff->Status.bDataPresent  %d \n",PassthruBuff->Status.bDataPresent );

				fprintf(fp,"\n PassthruBuff->Status.bStatus  %d \n",PassthruBuff->Status.bStatus );

				fprintf(fp,"\n PassthruBuff->Status.uDataBytes  %d \n",PassthruBuff->Status.uDataBytes );

				fprintf(fp,"\n PassthruBuff->Status.bConnectionStatus  %d \n",PassthruBuff->Status.bConnectionStatus);

				fprintf(fp,"\n PassthruBuff->Status.bReserved[3] \n");
				for(i=0;i<3;i++)
					fprintf(fp," %d ",PassthruBuff->Status.bReserved[i]);

				fprintf(fp,"\n PassthruBuff->Status.bResponse[256] \n");
				for(i=0;i<256;i++)
					fprintf(fp," %d ",PassthruBuff->Status.bResponse[i]);

				fprintf(fp,"\n PassthruBuff->Status.bResponseLength[2] \n");
				for(i=0;i<2;i++)
					fprintf(fp," %d ",PassthruBuff->Status.bResponseLength[i]);


				fprintf(fp,"\n PassthruBuff->Parameters.bDestinationSASAddress[8] \n");
				for(i=0;i<8;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);

				fprintf(fp,"\n PassthruBuff->Parameters.bReserved2[2] \n");
				for(i=0;i<2;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bReserved2[i]);


*/
				returnCode = call_ioctl(PassthruBuff,bufferSize,CC_CSMI_SAS_SSP_PASSTHRU);


/*

                fprintf(fp,"\n After \n");

				fprintf(fp,"\n PassthruBuff->Parameters.bAdditionalCDB[24] \n");
				for(i=0;i<24;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bAdditionalCDB[i]);

				fprintf(fp,"\n PassthruBuff->Parameters.bAdditionalCDBLength %d \n",PassthruBuff->Parameters.bAdditionalCDBLength);

				fprintf(fp,"\n PassthruBuff->Parameters.bCDB[16] \n");

				for(i=0;i<16;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bCDB[i]);


				fprintf(fp,"\n PassthruBuff->Parameters.bCDBLength %d \n",PassthruBuff->Parameters.bCDBLength);

				fprintf(fp,"\n PassthruBuff->Parameters.bConnectionRate %d \n",PassthruBuff->Parameters.bConnectionRate);

				fprintf(fp,"\n PassthruBuff->Parameters.bLun[8] \n");
				for(i=0;i<8;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bLun[i]);


				fprintf(fp,"\n PassthruBuff->Parameters.bPhyIdentifier %d \n",PassthruBuff->Parameters.bPhyIdentifier);

				fprintf(fp,"\n PassthruBuff->Parameters.bPortIdentifier  %d \n",PassthruBuff->Parameters.bPortIdentifier );

				fprintf(fp,"\n PassthruBuff->Parameters.bReserved %d \n",PassthruBuff->Parameters.bReserved );

				fprintf(fp,"\n PassthruBuff->Parameters.uDataLength %d \n",PassthruBuff->Parameters.uDataLength );

				fprintf(fp,"\n PassthruBuff->Parameters.uFlags %d \n",PassthruBuff->Parameters.uFlags);

				fprintf(fp,"\n PassthruBuff->bDataBuffer %x \n",PassthruBuff->bDataBuffer[1] );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.ControlCode %d \n",PassthruBuff->IoctlHeader.ControlCode );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.HeaderLength %d \n",PassthruBuff->IoctlHeader.HeaderLength);

				fprintf(fp,"\n PassthruBuff->IoctlHeader.Length  %d \n",PassthruBuff->IoctlHeader.Length );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.ReturnCode  %d \n",PassthruBuff->IoctlHeader.ReturnCode );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.Signature  %x \n",PassthruBuff->IoctlHeader.Signature );

				fprintf(fp,"\n PassthruBuff->IoctlHeader.Timeout %d \n",PassthruBuff->IoctlHeader.Timeout );


				fprintf(fp,"\n PassthruBuff->Status.bDataPresent  %d \n",PassthruBuff->Status.bDataPresent );

				fprintf(fp,"\n PassthruBuff->Status.bStatus  %d \n",PassthruBuff->Status.bStatus );

				fprintf(fp,"\n PassthruBuff->Status.uDataBytes  %d \n",PassthruBuff->Status.uDataBytes );

				fprintf(fp,"\n PassthruBuff->Status.bConnectionStatus  %d \n",PassthruBuff->Status.bConnectionStatus);

				fprintf(fp,"\n PassthruBuff->Status.bReserved[3] \n");
				for(i=0;i<3;i++)
					fprintf(fp," %d ",PassthruBuff->Status.bReserved[i]);

				fprintf(fp,"\n PassthruBuff->Status.bResponse[256] \n");
				for(i=0;i<256;i++)
					fprintf(fp," %d ",PassthruBuff->Status.bResponse[i]);

				fprintf(fp,"\n PassthruBuff->Status.bResponseLength[2] \n");
				for(i=0;i<2;i++)
					fprintf(fp," %d ",PassthruBuff->Status.bResponseLength[i]);


				fprintf(fp,"\n PassthruBuff->Parameters.bDestinationSASAddress[8] \n");
				for(i=0;i<8;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);

				fprintf(fp,"\n PassthruBuff->Parameters.bReserved2[2] \n");
				for(i=0;i<2;i++)
					fprintf(fp," %d ",PassthruBuff->Parameters.bReserved2[i]);



*/


				if(hexDumper)
				{
					s = buffer2;
					DisplayDumpAfter(s);
				}

				if(returnCode == 0)
				{
					//printf("\n Error in issuing the ioctl \n");
					print_to_file(fp,"\n Error in issuing the ioctl \n");
					fprintf(tempo,"\n Error in issuing the ioctl \n");

					return;
				}


				//printf("\n Command Name : %s ---- for Phy %d executed Successfully\n",SspCommands[CommandCount].CommandName,phy);
				print_to_file(fp,"\n Command Name : %s ---- for Phy %d executed Successfully\n",SspCommands[CommandCount].CommandName,phy);
				fprintf(tempo,"\n Command Name : %s ---- for Phy %d executed Successfully\n",SspCommands[CommandCount].CommandName,phy);

				DisplayIoctlHeader(PassthruBuff->IoctlHeader);
				//printf("\tIOCTL Specific Data\n");
				//printf("\t-------------------\n");
				print_to_file(fp,"\tIOCTL Specific Data\n");
				print_to_file(fp,"\t-------------------\n");
				fprintf(tempo,"\tIOCTL Specific Data\n");
				fprintf(tempo,"\t-------------------\n");

				DisplaySSPPassthru(PassthruBuff); //Maybe we have to pass &PassthruBuff //CHECK
				//printf("_______________________________________________________\n");
				print_to_file(fp,"_______________________________________________________\n");
				fprintf(tempo,"_______________________________________________________\n");




				if(buffer2)
					free(buffer2);

				}
			}
			else
				{
					//printf("\n Command cannot be executed for this Phy. Not a SAS End Device. \n");
					print_to_file(fp,"\n Command cannot be executed for this Phy. Not a SAS End Device. \n");
					fprintf(tempo,"\n Command cannot be executed for this Phy. Not a SAS End Device. \n");
				}
		
		}



	fclose(tempo);
	sysprint;



	if(buffer)
		free(buffer);
}



void issue_sas_stp_passthru()
{


	CSMI_SAS_STP_PASSTHRU_BUFFER *PassthruBuff;
	CSMI_SAS_PHY_INFO_BUFFER *PhyInfo;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;
	char *buffer2;
    int bufferSize2 = 16384;
	unsigned char *bufferX = 0;
	int bufferSizeX = 0;
	int SectorCount = 1;
	int phy;
	int CommandCount;


	struct StpCommands StpCommands[] =
   {
      { "Identify", 0, 0, CSMI_SAS_STP_PIO | CSMI_SAS_STP_READ, 0x27, 0x80, 0xEC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
      { "WriteBuffer","Writing using WRITE BUFFER Command.", 36, CSMI_SAS_STP_PIO | CSMI_SAS_STP_WRITE, 0x27,0x80,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  },
      { "ReadBuffer", 0, 0, CSMI_SAS_STP_PIO | CSMI_SAS_STP_READ, 0x27, 0x80, 0xE4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
      { "ExecuteDeviceDiagnostic", 0, 0, CSMI_SAS_STP_EXECUTE_DIAG | CSMI_SAS_STP_READ, 0x27, 0x80, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
      { 0 }
   };


	tempo = fopen(TEMP_FILE_NAME,"w");




	buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		PhyInfo = (CSMI_SAS_PHY_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	PrintBefore_issue_stp_passthru(descr);

	set_header(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	//printf("\n Total No of Phys is : %d \n",PhyInfo->Information.bNumberOfPhys);
	print_to_file(fp,"\n Total No of Phys is : %d \n",PhyInfo->Information.bNumberOfPhys);
	fprintf(tempo,"\n Total No of Phys is : %d \n",PhyInfo->Information.bNumberOfPhys);




	for(phy = 0; (phy < PhyInfo->Information.bNumberOfPhys); phy++)
    {
		//printf("\n Phy is : %d \n",phy);
		print_to_file(fp,"\n Phy is : %d \n",phy);
		fprintf(tempo,"\n Phy is : %d \n",phy);
        if( ((PhyInfo->Information.Phy[phy].Attached.bDeviceType == CSMI_SAS_END_DEVICE) &&
             (PhyInfo->Information.Phy[phy].Attached.bTargetPortProtocol &
              (CSMI_SAS_PROTOCOL_SATA |
              CSMI_SAS_PROTOCOL_STP))))
		{
			//printf("\n The Command can be executed for this Phy \n");
			print_to_file(fp,"\n The Command can be executed for this Phy \n");
			fprintf(tempo,"\n The Command can be executed for this Phy \n");
			for( CommandCount = 0; StpCommands[CommandCount].CommandName; CommandCount++ )
            {
				if( (StpCommands[CommandCount].flags & CSMI_SAS_STP_UNSPECIFIED) | (StpCommands[CommandCount].flags & CSMI_SAS_STP_EXECUTE_DIAG))
                {
                   bufferSizeX = 0;
                   bufferX = NULL;
                }
                else
                {
                    bufferSizeX = SectorCount * 0x200;
                    bufferX = ( unsigned char *)calloc(1,bufferSizeX);
                }

				//printf("\n Command Name : %s ---- Phy %d \n",StpCommands[CommandCount].CommandName,phy);
				print_to_file(fp,"\n Command Name : %s ---- Phy %d \n",StpCommands[CommandCount].CommandName,phy);
				fprintf(tempo,"\n Command Name : %s ---- Phy %d \n",StpCommands[CommandCount].CommandName,phy);

				if( bufferX )
                {
                    memset(bufferX, 0, bufferSizeX);
                    // If this is a write and there is a buffer specified in the table,
                    // then use the data in the table to fill in the buffer.
                    if( (StpCommands[CommandCount].flags & CSMI_SAS_STP_WRITE ) && StpCommands[CommandCount].String)
                    {
                        memcpy(bufferX, StpCommands[CommandCount].String, StpCommands[CommandCount].stringSize);
                    }
                } // End of if for bufferX






				buffer2 = (char *)calloc(1,(bufferSize2+bufferSizeX));
				memset(buffer2,0,(bufferSize2+bufferSizeX));


				if(buffer2)
				{
					PassthruBuff = (CSMI_SAS_STP_PASSTHRU_BUFFER *)buffer2;
				}
				else
				{
					//printf("\n Error in allocating the Buffer. \n");
					print_to_file(fp,"\n Error in allocating the Buffer. \n");
					fprintf(tempo,"\n Error in allocating the Buffer. \n");
					exit(0);
				}


				PassthruBuff->Parameters.bPhyIdentifier = phy;
				PassthruBuff->Parameters.bPortIdentifier = CSMI_SAS_IGNORE_PORT;
				PassthruBuff->Parameters.bConnectionRate = PhyInfo->Information.Phy[phy].bNegotiatedLinkRate;
		         memcpy(&PassthruBuff->Parameters.bDestinationSASAddress[0],
                PhyInfo->Information.Phy[phy].Attached.bSASAddress,8);
	          // copy in the command FIS being done

			     memcpy(&PassthruBuff->Parameters.bCommandFIS,
					    StpCommands[CommandCount].commandFIS,
						sizeof(PassthruBuff->Parameters.bCommandFIS));

				 PassthruBuff->Parameters.uFlags = StpCommands[CommandCount].flags;



				// now copy the user buffer if the data is being written or is
				// unspecified, if it is a read then don't bother to copy the
				// buffer, it is already initialized to 0 from the calloc...
				if(bufferSizeX &&
					bufferX &&
					(StpCommands[CommandCount].flags &
					(CSMI_SAS_STP_WRITE |
					CSMI_SAS_STP_UNSPECIFIED)))
				{
					memcpy(&PassthruBuff->bDataBuffer,
						bufferX,
						bufferSizeX);

				}



		         // update the data length being requested
				PassthruBuff->Parameters.uDataLength = bufferSizeX;


				set_header(PassthruBuff,bufferSize,CC_CSMI_SAS_STP_PASSTHRU);

				if(hexDumper)
				{
					s = buffer2;
					DisplayDumpBefore(s);
				}

				returnCode = call_ioctl(PassthruBuff,bufferSize,CC_CSMI_SAS_STP_PASSTHRU);

				if(hexDumper)
				{
					s = buffer2;
					DisplayDumpAfter(s);
				}

				if(returnCode == 0)
				{
					//printf("\n Error in issuing the ioctl \n");
					print_to_file(fp,"\n Error in issuing the ioctl \n");
					fprintf(tempo,"\n Error in issuing the ioctl \n");


					return;
				}

				//printf("\n Command Name : %s ---- for Phy %d executed Successfully\n",StpCommands[CommandCount].CommandName,phy);
				print_to_file(fp,"\n Command Name : %s ---- for Phy %d executed Successfully\n",StpCommands[CommandCount].CommandName,phy);
				fprintf(tempo,"\n Command Name : %s ---- for Phy %d executed Successfully\n",StpCommands[CommandCount].CommandName,phy);

				DisplayIoctlHeader(PassthruBuff->IoctlHeader);
				//printf("\tIOCTL Specific Data\n");
				//printf("\t-------------------\n");
				print_to_file(fp,"\tIOCTL Specific Data\n");
				print_to_file(fp,"\t-------------------\n");
				fprintf(tempo,"\tIOCTL Specific Data\n");
				fprintf(tempo,"\t-------------------\n");
				DisplaySTPPassthru(PassthruBuff); //Maybe we have to pass &PassthruBuff //CHECK
				//printf("_______________________________________________________\n");
				print_to_file(fp,"_______________________________________________________\n");
				fprintf(tempo,"_______________________________________________________\n");



				if(buffer2)
					free(buffer2);

				}
			}
				else
				{
					//printf("\n Command cannot be executed for this Phy. Not a SATA/SAS End Device. \n");
					print_to_file(fp,"\n Command cannot be executed for this Phy. Not a SATA/SAS End Device. \n");
					fprintf(tempo,"\n Command cannot be executed for this Phy. Not a SATA/SAS End Device. \n");
				}
			}



	fclose(tempo);
	sysprint;



	if(buffer)
		free(buffer);
}




void issue_get_sata_signature(unsigned char bPhyIdentifier)
{


	CSMI_SAS_SATA_SIGNATURE_BUFFER *Signature;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");
	






    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		Signature = (CSMI_SAS_SATA_SIGNATURE_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	PrintBefore_issue_get_sata_signature(descr);


	set_header(Signature,bufferSize,CC_CSMI_SAS_GET_SATA_SIGNATURE);


// get the SATA signature information
    Signature->Signature.bPhyIdentifier = bPhyIdentifier;

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(Signature,bufferSize,CC_CSMI_SAS_GET_SATA_SIGNATURE);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	DisplayIoctlHeader(Signature->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\t-------------------\n");
	DisplaySignature(Signature->Signature);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);
}





void issue_firmware_download(char* fname)
{
	tempo = fopen(TEMP_FILE_NAME,"w");

	PrintBefore_issue_firmware_download(descr);

	fclose(tempo);
	sysprint;

}




void issue_sas_smp_passthru()
{
	tempo = fopen(TEMP_FILE_NAME,"w");

	PrintBefore_issue_sas_smp_passthru(descr);

	fclose(tempo);
	sysprint;

}




 void  issue_get_scsi_address(int TargetId , int LunId)
{


	CSMI_SAS_GET_SCSI_ADDRESS_BUFFER *ScsiAddr;
	CSMI_SAS_GET_DEVICE_ADDRESS_BUFFER *DeviceAddress;
	char *buffer;
	char *buffer2;
	    int bufferSize = 16384;
	int buffer2Size = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		DeviceAddress = (CSMI_SAS_GET_DEVICE_ADDRESS_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	PrintBefore_issue_get_scsi_address(descr);



	DeviceAddress->bTargetId = TargetId;
	DeviceAddress->bLun = LunId;


	set_header(DeviceAddress,bufferSize,CC_CSMI_SAS_GET_DEVICE_ADDRESS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(DeviceAddress,bufferSize,CC_CSMI_SAS_GET_DEVICE_ADDRESS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}


    buffer2 = (char *)calloc(1,buffer2Size);
    memset(buffer2,0,buffer2Size);


	if(buffer2)
	{
		ScsiAddr = (CSMI_SAS_GET_SCSI_ADDRESS_BUFFER *)buffer2;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


        memcpy( ScsiAddr->bSASAddress, DeviceAddress->bSASAddress, 8 );
	memcpy( ScsiAddr->bSASLun, DeviceAddress->bSASLun, 8 );

	//removed strcpy(ScsiAddr->bSASAddress, DeviceAddress->bSASAddress);
	//removed strcpy(ScsiAddr->bSASLun, DeviceAddress->bSASLun);

	ScsiAddr->bHostIndex = 0;
	ScsiAddr->bPathId = 0;
	ScsiAddr->bTargetId = 0;
	ScsiAddr->bLun = 0;


	set_header(ScsiAddr,bufferSize,CC_CSMI_SAS_GET_SCSI_ADDRESS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(ScsiAddr,bufferSize,CC_CSMI_SAS_GET_SCSI_ADDRESS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");

		return;
	}


	DisplayIoctlHeader(ScsiAddr->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\t-------------------\n");
	DisplaySCSIAddr(ScsiAddr); //Maybe we have to pass &ScsiAddr //CHECK
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;



	if(buffer)
		free(buffer);

	if(buffer2)
		free(buffer2);
	
}




void issue_get_device_address(int HostIndex, int PathId, int TargetId, int LunId)
{

	CSMI_SAS_GET_DEVICE_ADDRESS_BUFFER *DeviceAddress;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;
	int i;

	tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		DeviceAddress = (CSMI_SAS_GET_DEVICE_ADDRESS_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	PrintBefore_issue_get_device_address(descr);


	DeviceAddress->bHostIndex = HostIndex;
	DeviceAddress->bPathId = PathId;
	DeviceAddress->bTargetId = TargetId;
	DeviceAddress->bLun = LunId;
	for(i=0; i<8; i++)
	{
		DeviceAddress->bSASAddress[i] = 0;
		DeviceAddress->bSASLun[i] = 0;
	}
    
        printf("\n %x %x %x %x \n",DeviceAddress->bHostIndex,DeviceAddress->bPathId,DeviceAddress->bTargetId,DeviceAddress->bLun);


	set_header(DeviceAddress,bufferSize,CC_CSMI_SAS_GET_DEVICE_ADDRESS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

printf("\n %x %x %x %x \n",DeviceAddress->bHostIndex,DeviceAddress->bPathId,DeviceAddress->bTargetId,DeviceAddress->bLun);

	returnCode = call_ioctl(DeviceAddress,sizeof(DeviceAddress),CC_CSMI_SAS_GET_DEVICE_ADDRESS);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");

		return;
	}

	DisplayIoctlHeader(DeviceAddress->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\t-------------------\n");
	DisplayDeviceAddress(DeviceAddress); //Maybe we have to pass &DeviceAddress //CHECK
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");


	fclose(tempo);
	sysprint;


	if(buffer)
		free(buffer);
}




void issue_set_phy_info(int PhyId, int NegLinkRate, int MinLinkRate, int MaxLinkRate)
{
	CSMI_SAS_SET_PHY_INFO_BUFFER *PhyInfo;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

	tempo = fopen(TEMP_FILE_NAME,"w");


    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		PhyInfo = (CSMI_SAS_SET_PHY_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");

		exit(0);
	}

	PrintBefore_issue_set_phy_info(descr);

 	PhyInfo->Information.bPhyIdentifier = PhyId;
	PhyInfo->Information.bNegotiatedLinkRate = NegLinkRate;
	PhyInfo->Information.bProgrammedMinimumLinkRate = MinLinkRate;
	PhyInfo->Information.bProgrammedMaximumLinkRate = MaxLinkRate;

	set_header(PhyInfo,bufferSize,CC_CSMI_SAS_SET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(PhyInfo,bufferSize,CC_CSMI_SAS_SET_PHY_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	DisplayIoctlHeader(PhyInfo->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\t-------------------\n");
	DisplaySetPhyInfo(PhyInfo->Information);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");


	fclose(tempo);
	sysprint;


	if(buffer)
		free(buffer);
}



void issue_sas_task_management(int HostIndex, int PathId, int TargetId, int LunId)
{

/*	CSMI_SAS_SSP_TASK_IU_BUFFER *TaskManBuff;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;

    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		TaskManBuff = (CSMI_SAS_SSP_TASK_IU_BUFFER *)buffer;
	}
	else
	{
		printf("\n Error in allocating the Buffer. \n");
		fprintf(fp,"\n Error in allocating the Buffer. \n");
		exit(0);
	} */

	tempo = fopen(TEMP_FILE_NAME,"w");

	PrintBefore_issue_set_task_management(descr);

	fclose(tempo);
	sysprint;


/*	TaskManBuff->Parameters.bHostIndex = HostIndex;
	TaskManBuff->Parameters.bPathId = PathId;
	TaskManBuff->Parameters.bTargetId = TargetId;
	TaskManBuff->Parameters.bLun = LunId;

	TaskManBuff->Parameters.uFlags = CSMI_SAS_TASK_IU;
	TaskManBuff->Parameters.uQueueTag = 0; // should replace with Linux Tag
	TaskManBuff->Parameters.bTaskManagementFunction = CSMI_SAS_SSP_CLEAR_TASK_SET;
	TaskManBuff->Parameters.uInformation = CSMI_SAS_SSP_TEST;

	memset(&TaskManBuff->Status, 0, sizeof(CSMI_SAS_SSP_PASSTHRU_STATUS));  //CHECK if its &TaskManBuff or just TaskManBuff


	set_header(TaskManBuff,bufferSize,CC_CSMI_SAS_TASK_MANAGEMENT);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(TaskManBuff,bufferSize,CC_CSMI_SAS_TASK_MANAGEMENT);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)
	{
		printf("\n Error in issuing the ioctl \n");
		fprintf(fp,"\n Error in issuing the ioctl \n");
		return;
	}

	DisplayIoctlHeader(TaskManBuff->IoctlHeader);
	printf("\tIOCTL Specific Data\n");
	printf("\t-------------------\n");
	fprintf(fp,"\tIOCTL Specific Data\n");
	fprintf(fp,"\t-------------------\n");
	DisplayTaskManagement(TaskManBuff->Status);
	printf("_______________________________________________________\n");
	fprintf(fp,"_______________________________________________________\n"); */
}



void issue_get_connector_info()
{


	CSMI_SAS_PHY_INFO_BUFFER *PhyInfo;
	char *bufferP;
    int bufferSizeP = 16384;
	char *s;
	long returnCode;

	CSMI_SAS_CONNECTOR_INFO_BUFFER *Connector;
	char *buffer;
    int bufferSize = 16384;


	tempo = fopen(TEMP_FILE_NAME,"w");



    bufferP = (char *)calloc(1,bufferSizeP);
    memset(bufferP,0,bufferSizeP);

	if(bufferP)
	{
		PhyInfo = (CSMI_SAS_PHY_INFO_BUFFER *)bufferP;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	set_header(PhyInfo,bufferSizeP,CC_CSMI_SAS_GET_PHY_INFO);

	returnCode = call_ioctl(PhyInfo,bufferSizeP,CC_CSMI_SAS_GET_PHY_INFO);

    if(returnCode == 0)
	{
		//printf("\n Error in issuing PHY_INFO ioctl \n");
		print_to_file(fp,"\n Error in issuing PHY_INFO ioctl \n");
		fprintf(tempo,"\n Error in issuing PHY_INFO ioctl \n");
		return;
	}



    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		Connector = (CSMI_SAS_CONNECTOR_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	PrintBefore_issue_get_connector_info(descr);

	set_header(Connector,bufferSize,CC_CSMI_SAS_GET_CONNECTOR_INFO);

	memset(Connector->Reference,0,sizeof(Connector->Reference));

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(Connector,bufferSize,CC_CSMI_SAS_GET_CONNECTOR_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	}

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}

	DisplayIoctlHeader(Connector->IoctlHeader);
	//printf("\tIOCTL Specific Data\n");
	print_to_file(fp,"\tIOCTL Specific Data\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");
	//printf("\t-------------------\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\t-------------------\n");
	DisplayConnectorInfo(Connector,PhyInfo->Information.bNumberOfPhys);
	//printf("_______________________________________________________\n");
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");

	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);
	if(bufferP)
		free(bufferP);

}

void issue_sas_get_location(int HostIndex , int PathId,int TargetId,int LunId)
{
	CSMI_SAS_GET_LOCATION_BUFFER *location;
	CSMI_SAS_GET_SCSI_ADDRESS_BUFFER *ScsiAddr;
	
	char *buffer,*dump;
	int buffer_size =  (2 << 14); /* 32k recommended */
	long returncode;

	

	tempo = fopen(TEMP_FILE_NAME ,"w");
	
	//get_address(&ScsiAddr , TargetId , LunId);




	buffer = calloc(1 , buffer_size);
	memset( buffer , 0 , buffer_size);

	if(buffer)
		location = (CSMI_SAS_GET_LOCATION_BUFFER *)buffer;
	else {
		print_to_file(fp , "\n Error in allocating buffer. \n");
		fprintf(tempo,"\n Error in allocating buffer. \n");
		exit(EXIT_FAILURE);
	}

	PrintBefore_issue_get_location(descr);
	
	set_header(location , buffer_size , CC_CSMI_SAS_GET_LOCATION);
	
	
	if(hexDumper) {
		dump = buffer;
		DisplayDumpBefore(dump);
	}
	

	location->bHostIndex 			= HostIndex;
	location->bPathId 			= PathId;
	location->bTargetId			= TargetId;
	location->bLun				= LunId;
	location->bIdentify			= CSMI_SAS_LOCATE_FORCE_ON;
	location->bNumberOfLocationIdentifiers	= 0;
	location->bLengthOfLocationIdentifier	= sizeof(CSMI_SAS_LOCATION_IDENTIFIER);	
	


	returncode = call_ioctl(location , buffer_size , CC_CSMI_SAS_GET_LOCATION);

	if(hexDumper) {
		dump = buffer;
		DisplayDumpAfter(dump);
	}

	if(returncode == 0) {
		print_to_file(fp,"Error in issuing IOCTL.\n");
		fprintf(tempo , "Error in issuing IOCTL.\n");
		return;
	}
	
	DisplayIoctlHeader(location->IoctlHeader);
	print_to_file(fp , "\tIOCTL SPECIFIC DATA\n");
	fprintf(tempo , "\tIOCTL SPECIFIC DATA\n");
	print_to_file(fp,"\t-------------------\n");
	fprintf(tempo,"\t-------------------\n");
	
	if(returncode == CSMI_SAS_NOT_AN_END_DEVICE) {
		print_to_file(fp,"\tThe OS specific platform address cannot\n"
				  "\t be returned because the device is not an end device\n");
		fprintf(tempo,"\tThe OS specific platform address cannot\n"
                                  "\t be returned because the device is not an end device\n");
		return;
	}
	else if(returncode == CSMI_SAS_NO_SCSI_ADDRESS) {
		print_to_file(fp,"\tNo OS specific platform address was found for this SAS address");
		fprintf(tempo,"\tNo OS specific platform address was found for this SAS address");
	}
	else if(returncode == CSMI_SAS_STATUS_INVALID_PARAMETER){
		print_to_file(fp,"\t Invalid Parameters supplied\n");
		fprintf(tempo,"\t Invalid Parameters supplied\n");
		return;
	}
	else {
		DisplayLocation(location);
	}
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,   "_______________________________________________________\n");
	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);
}



CSMI_SAS_RAID_INFO_BUFFER * call_raid_info()
{
	CSMI_SAS_RAID_INFO_BUFFER *raid_info;
	char *buffer;
	int size = 2 <<14 , rc;

	buffer = calloc(1 , size);
	if(buffer == NULL){
		print_to_file(fp , "\n Error in allocating buffer. \n");
		fprintf(tempo,"\n Error in allocating buffer. \n");
		fclose(tempo);
		sysprint;
		exit(EXIT_FAILURE);
	}
	else{
		memset(buffer , 0 , size);
		raid_info = (CSMI_SAS_RAID_INFO_BUFFER *)buffer;
		
	}
	set_header(raid_info , size , CC_CSMI_SAS_GET_RAID_INFO);
	
	rc = call_ioctl(raid_info , size , CC_CSMI_SAS_GET_RAID_INFO);

	if(rc == 0){
		print_to_file(fp , "Error in issuing IOCTL.\n");
		fprintf(tempo , "Error in issuing IOCTL.\n");
		fclose(tempo);
		sysprint;
		return NULL;
	}
	return raid_info;
	
	
}

void issue_sas_get_raid_features()
{

	CSMI_SAS_RAID_FEATURES_BUFFER *raid_features;
	CSMI_SAS_RAID_INFO_BUFFER *raid_info;
	char *buffer , *dump;
	

	int buffer_size = 2 << 14;
	long rc;
	
	tempo = fopen(TEMP_FILE_NAME ,"w");

	if((raid_info= call_raid_info()) == NULL) {
		return;
	}
	
        raid_features->Information.uFailureCode = 0; 
	buffer = calloc(1 , buffer_size);

	if(buffer == NULL) {
		 print_to_file(fp , "\n Error in allocating buffer. \n");
		 fprintf(tempo,"\n Error in allocating buffer. \n");
		 fclose(tempo);
		 sysprint;
		 exit(EXIT_FAILURE);
		 
	}
	else {
		memset(buffer , 0 , buffer_size);
		raid_features = (CSMI_SAS_RAID_FEATURES_BUFFER *) buffer;
	}

	PrintBefore_issue_get_raid_features(descr);

	set_header(raid_features , buffer_size , CC_CSMI_SAS_GET_RAID_FEATURES);
	raid_features->Information.uChangeCount = raid_info->Information.uChangeCount;
	
	if(hexDumper) {
		dump = buffer;
		DisplayDumpBefore(dump);
	}

	rc = call_ioctl(raid_features , buffer_size , CC_CSMI_SAS_GET_RAID_FEATURES);

	if(hexDumper){
		dump = buffer;
		DisplayDumpAfter(dump);
	}

	if(rc == 0) {
		print_to_file(fp , "Error in issuing IOCTL.\n");
		fprintf(tempo , "Error in issuing IOCTL.\n");
		printf("%d\n",no_print);
		fclose(tempo);
		sysprint;
		return;
	}

	

	DisplayIoctlHeader(raid_features->IoctlHeader);
	print_to_file(fp , "\tIOCTL SPECIFIC DATA\n");
	fprintf(tempo , "\tIOCTL SPECIFIC DATA\n");	
	print_to_file(fp ,"\t-------------------\n");
	fprintf(tempo , "\t-------------------\n");

	Display_raid_features(&(raid_features->Information));
        Check_ReturnCode_Raid_Features( raid_features);
	
	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");
	fclose(tempo);
	sysprint;
}

void issue_sas_set_raid_control()
{
	CSMI_SAS_RAID_CONTROL_BUFFER *raid_control;
	CSMI_SAS_RAID_INFO_BUFFER *raid_info;
	char *buffer , *dump;
	int buffer_size = 2 << 14;
	long rc;

	tempo = fopen(TEMP_FILE_NAME , "w");
        buffer = calloc( buffer_size , 1);

	if(buffer == NULL) {
		print_to_file(fp , "\n Error in allocating buffer. \n");
                fprintf(tempo    , "\n Error in allocating buffer. \n");
                fclose(tempo);
                sysprint;
	        exit(EXIT_FAILURE);
	}

	memset(buffer , 0 , buffer_size);
	raid_control = (CSMI_SAS_RAID_CONTROL_BUFFER *) buffer;
	inputs_raid_control(&(raid_control->Information));
	
	set_header(raid_control , buffer_size , CC_CSMI_SAS_SET_RAID_CONTROL);
	
	if(hexDumper) {
		dump = buffer;
		DisplayDumpBefore(dump);
	}

	rc = call_ioctl(raid_control , buffer_size , CC_CSMI_SAS_SET_RAID_CONTROL);

	if(rc == 0) {
		print_to_file( fp , "Error in Issuing IOCTL\n");
		fprintf(tempo     , "Error in Issuing IOCTL\n");
		fclose(tempo);
		sysprint;
	}

		
	DisplayIoctlHeader(raid_control->IoctlHeader);
        if((raid_control->IoctlHeader.ReturnCode) != CSMI_SAS_STATUS_SUCCESS);
	 	check_return_code(raid_control);

}

		
void check_return_code(CSMI_SAS_RAID_CONTROL_BUFFER *raid_control)
{
	if((raid_control->IoctlHeader.ReturnCode) == CSMI_SAS_STATUS_INVALID_PARAMETER){
		switch(raid_control->IoctlHeader.ReturnCode){
		case CSMI_SAS_FAIL_CODE_OK:
			print_to_file(fp , "\tOperation SuccessFull\n");
			fprintf(tempo     , "\tOperation SuccessFull\n");
			break;
		case CSMI_SAS_FAIL_CODE_TRANSFORM_PRIORITY_INVALID:
  		     	print_to_file(fp , "\tTransform Priority Invalid: %s\n" ,raid_control->Information.bFailureDescription );
			fprintf(tempo     , "\tTransform Priority Invalid: %s\n" ,raid_control->Information.bFailureDescription );
			break;
		case CSMI_SAS_FAIL_CODE_REBUILD_PRIORITY_INVALID:
			print_to_file(fp , "\tRebuild Priority Invalid: %s\n" , raid_control->Information.bFailureDescription );
			fprintf(tempo     , "\tRebuild Priority Invalid: %s\n" , raid_control->Information.bFailureDescription );
			break;
						
		case CSMI_SAS_FAIL_CODE_CACHE_RATIO_INVALID:
			print_to_file(fp , "\tCache Ratio Invalid: %s\n" , raid_control->Information.bFailureDescription );
			fprintf(tempo     , "\tCache Ratio Invalid: %s\n" , raid_control->Information.bFailureDescription );
			break;
		case CSMI_SAS_FAIL_CODE_SURFACE_SCAN_INVALID:
			print_to_file(fp , "\tSurfaceScan Priority Invalid: %s\n",raid_control->Information.bFailureDescription );
			fprintf(tempo     , "\tSurfaceScan Priority Invalid: %s\n",raid_control->Information.bFailureDescription );
			break;
		case CSMI_SAS_FAIL_CODE_CLEAR_CONFIGURATION_INVALID:
			print_to_file(fp , "\tClearConfiguration Invalid: %s\n",raid_control->Information.bFailureDescription );
			fprintf(tempo     , "\tClearConfiguration Invalid: %s\n",raid_control->Information.bFailureDescription );
			break;
															                }
	}
}
	
															

void check_return_code_element(CSMI_SAS_RAID_ELEMENT_BUFFER *raid_element_buffer)
{
	
	if((raid_element_buffer->IoctlHeader.ReturnCode) == CSMI_SAS_STATUS_INVALID_PARAMETER){
		switch(raid_element_buffer->IoctlHeader.ReturnCode){
			case CSMI_SAS_FAIL_CODE_OK:
				print_to_file(fp , "\tOperation SuccessFull\n");
				fprintf(tempo     , "\tOperation SuccessFull\n");
				break;
			case CSMI_SAS_FAIL_CODE_ELEMENT_INDEX_INVALID:
				print_to_file(fp , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				fprintf(tempo     , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				break;
			case CSMI_SAS_FAIL_CODE_SUBELEMENT_INDEX_INVALID:
				print_to_file(fp , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				fprintf(tempo     , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				break;
		}
	}
}




void issue_sas_get_raid_element()
{

	CSMI_SAS_RAID_ELEMENT_BUFFER *raid_element;
	//CSMI_SAS_RAID_ELEMENT *raid_ele;
	CSMI_SAS_RAID_INFO_BUFFER *raid_info;
	char *buffer , *dump;

	int buffer_size = 2 << 14;
	long rc;
	
	tempo = fopen(TEMP_FILE_NAME ,"w");

	/*if((raid_info= call_raid_info()) == NULL) {
		return;
	}*/
	

	buffer = calloc(1 , buffer_size);

	if(buffer == NULL) {
		 print_to_file(fp , "\n Error in allocating buffer. \n");
		 fprintf(tempo,"\n Error in allocating buffer. \n");
		 fclose(tempo);
		 sysprint;
		 exit(EXIT_FAILURE);
		 
	}
		
	memset(buffer , 0 , buffer_size);
	raid_element = (CSMI_SAS_RAID_ELEMENT_BUFFER *) buffer;
	inputs_raid_element(&(raid_element->Information));
	
	if((raid_info = call_raid_info()) == NULL) {
		return;
	}
	
	set_header(raid_element , buffer_size , CC_CSMI_SAS_GET_RAID_ELEMENT);
	
	if(hexDumper) {
		dump = buffer;
		DisplayDumpBefore(dump);
	}

	rc = call_ioctl(raid_element , buffer_size , CC_CSMI_SAS_GET_RAID_ELEMENT);

	if(hexDumper){
		dump = buffer;
		DisplayDumpAfter(dump);
	}

	if(rc == 0) {
		print_to_file(fp , "Error in issuing IOCTL.\n");
		fprintf(tempo , "Error in issuing IOCTL.\n");
		printf("%d\n",no_print);
		fclose(tempo);
		sysprint;
		return;
	}

	

	DisplayIoctlHeader(raid_element->IoctlHeader);
	print_to_file(fp , "\tIOCTL SPECIFIC DATA\n");
	fprintf(tempo , "\tIOCTL SPECIFIC DATA\n");	
	print_to_file(fp ,"\t-------------------\n");
	fprintf(tempo , "\t-------------------\n");

	if((raid_element->IoctlHeader.ReturnCode) != CSMI_SAS_STATUS_SUCCESS){
		check_return_code_element(raid_element);
        }
       
	else{
        Display_raid_element(&(raid_element->Information));
	}

	print_to_file(fp,"_______________________________________________________\n");
	fprintf(tempo,"_______________________________________________________\n");
	fclose(tempo);
	sysprint;
}

															
void inputs_raid_control(CSMI_SAS_RAID_CONTROL *raid_control)
{
	int selected = 0 , choice = 0;
	__u8 cache_ratio = 0;

	while(!selected){
		printf("Select a Transform priority\n");
		printf("1> AUTO\n");
		printf("2> OFF\n");
		printf("3> LOW\n");
		printf("4> MEDIUM\n");
		printf("5> HIGH\n");
		printf("Enter your Option:(1 - 5):");

		scanf("%d", &choice);
		switch(choice){
			case 1:
				raid_control->bTransformPriority = CSMI_SAS_PRIORITY_AUTO;
				selected = 1;
				break;
			case 2:
				raid_control->bTransformPriority = CSMI_SAS_PRIORITY_OFF;
				selected = 1;
				break;
			case 3:
				raid_control->bTransformPriority = CSMI_SAS_PRIORITY_LOW;
				selected = 1;
				break;
			case 4:
				raid_control->bTransformPriority = CSMI_SAS_PRIORITY_MEDIUM;
				selected = 1;
			case 5:
				raid_control->bTransformPriority = CSMI_SAS_PRIORITY_HIGH;
				selected = 1;
				break;
			default:
				printf("\nInvalid Option\n Leaving it unchanged.......");
				raid_control->bTransformPriority = CSMI_SAS_PRIORITY_UNCHANGED;
				selected = 1;
				break;
		}
	}

	selected = 0;
	choice   = 0;

	while(!selected) {
		printf("Select a REBUILD PRIORITY\n");
		printf("1> AUTO\n");
		printf("2> OFF\n");
		printf("3> LOW\n");
		printf("4> MEDIUM\n");
		printf("5> HIGH\n");
		printf("Enter your Option:(1 - 5):");
		
		scanf("%d", &choice);
		switch(choice) {
			case 1:
				raid_control->bRebuildPriority = CSMI_SAS_PRIORITY_AUTO;
				selected = 1;
				break;
			case 2:
				raid_control->bRebuildPriority = CSMI_SAS_PRIORITY_OFF;
				selected = 1;
				break;
			case 3:
				raid_control->bRebuildPriority = CSMI_SAS_PRIORITY_LOW;
				selected = 1;
				break;
			case 4:
				raid_control->bRebuildPriority = CSMI_SAS_PRIORITY_MEDIUM;
				selected = 1;
				break;
			case 5:
				raid_control->bRebuildPriority = CSMI_SAS_PRIORITY_HIGH;
				selected = 1;
				break;
			default:
				printf("\nInvalid Option\n Leaving it unchanged.......");
				raid_control->bRebuildPriority = CSMI_SAS_PRIORITY_UNCHANGED;
				selected = 1;
				break;
		}
		
	}

	selected = choice = 0;

	while(!selected) {
		printf("Enter Option For CACHE RATIO\n");
		printf("1> ENABLE\n");
		printf("2> DISABLE\n");
		printf("Enter your Option:(1 - 2):");

		scanf("%d",&choice);
		switch(choice) {
			case 1:
				printf("Enter the cache ratio (0 - 100)\n");
				scanf("%d", &cache_ratio);
				if(/*(cache_ratio < 0) ||*/ (cache_ratio > 100)) {
					printf("Invalid value\nLeaving it Unchanged.....\n");
					raid_control->bCacheRatioFlag = CSMI_SAS_RAID_CACHE_RATIO_DISABLE;
				}
				else {
					raid_control->bCacheRatioFlag = CSMI_SAS_RAID_CACHE_RATIO_ENABLE;
					raid_control->bCacheRatio     = cache_ratio;
				}
				selected = 1;
				break;
			case 2:
				raid_control->bCacheRatioFlag = CSMI_SAS_RAID_CACHE_RATIO_DISABLE;
				selected = 1;
				break;
			default:
				printf("Invalid Option\nLeaving unchanged........\n");
				raid_control->bCacheRatioFlag = CSMI_SAS_RAID_CACHE_RATIO_DISABLE;
				selected = 1;
				break;
		}
	}
	selected = choice = 0;
	//raid_control->uSurfaceScanDelay = CSMI_SAS_RAID_SURFACE_SCAN_UNCHANGED;

	while(!selected){
		printf("Select a Surface Scan  priority\n");
		printf("1> AUTO\n");
		printf("2> OFF\n");
		printf("3> LOW\n");
		printf("4> MEDIUM\n");
		printf("5> HIGH\n");
		printf("Enter your Option:(1 - 5):");

		scanf("%d", &choice);
		switch(choice){
			case 1:
				raid_control->bSurfaceScanPriority = CSMI_SAS_PRIORITY_AUTO;
				selected = 1;
				break;
			case 2:
				raid_control->bSurfaceScanPriority = CSMI_SAS_PRIORITY_OFF;
				selected = 1;
				break;
			case 3:
				raid_control->bSurfaceScanPriority = CSMI_SAS_PRIORITY_LOW;
				selected = 1;
				break;
			case 4:
				raid_control->bSurfaceScanPriority = CSMI_SAS_PRIORITY_MEDIUM;
				selected = 1;
			case 5:
				raid_control->bSurfaceScanPriority = CSMI_SAS_PRIORITY_HIGH;
				selected = 1;
				break;
			default:
				printf("\nInvalid Option\n Leaving it unchanged.......");
				raid_control->bSurfaceScanPriority = CSMI_SAS_PRIORITY_UNCHANGED;
				selected = 1;
				break;
		}
	}
	while(!selected) {
		printf("Enter Your choice for clear configuration flag(Destructive)\n");
		printf("1> CLEAR Configuration(Delete all RAID SETS & Restore Factory Defaults)\n");
		printf("2> UNCHANGED\n");
		printf("Enter your Option:(1 - 2):");

		scanf("%d",&choice);

		switch(choice){
			case 1:
				strcpy(raid_control->bClearConfiguration , "RAIDCLR\0");
				selected = 1;
				break;
			case 2:
				strcpy(raid_control->bClearConfiguration , "NO");
				selected = 1;
				break;
			default:
				strcpy(raid_control->bClearConfiguration , "NO");
				selected = 1;
				break;
		}
					
				
	}

	
}




void inputs_raid_element(CSMI_SAS_RAID_ELEMENT *raid_element )
{
	int selected = 0 , choice = 0;
	__u8 cache_ratio = 0;
//	__u32 uFailurCode;
    
	while(!selected){
		printf("Select the Enumeration Type \n");
		printf("1> RAID ELEMENT TYPE DRIVE\n");
		printf("2> RAID ELEMENT TYPE MODULE\n");
		printf("3> RAID ELEMENT TYPE DRIVE RAID SET\n");
		printf("4> RAID ELEMENT TYPE EXTENT DRIVE\n");
		printf("Enter your Option:(1 - 4):");

		scanf("%d", &choice);
		switch(choice){
			case 1:
				raid_element->uEnumerationType = CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE;
				selected = 1;
				break;
			case 2:
				raid_element->uEnumerationType = CSMI_SAS_RAID_ELEMENT_TYPE_MODULE;
				selected = 1;
				break;
			case 3:
				raid_element->uEnumerationType = CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE_RAID_SET;
				selected = 1;
				break;
			case 4:
				raid_element->uEnumerationType = CSMI_SAS_RAID_ELEMENT_TYPE_EXTENT_DRIVE;
				selected = 1;
				break;
			default:
				printf("\nDefault Option is Selected.......");
				raid_element->uEnumerationType = CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE;
				selected = 1;
				break;
		}
	}

        
     	printf("Enter the index number of the element  [Range 0 - 0x7FFFFFFF]\n");
	scanf("%d", &raid_element->uElementIndex);
    	
     	if( raid_element->uEnumerationType == CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE_RAID_SET || raid_element->uEnumerationType ==
	    CSMI_SAS_RAID_ELEMENT_TYPE_EXTENT_DRIVE){	       	
	
	printf("Enter the Relative index number of the element [Range 0 - 0x7FFFFFFF]\n");
	scanf("%d", &raid_element->uSubElementIndex);
	
 	}
}






void issue_sas_set_raid_operation()
{

	CSMI_SAS_RAID_SET_OPERATION_BUFFER *raid_operation;
	//CSMI_SAS_RAID_INFO_BUFFER *raid_info;
	char *buffer , *dump;
	int buffer_size = 2 << 14;
	long rc;

	
	tempo = fopen(TEMP_FILE_NAME , "w");

	
	buffer = calloc( buffer_size , 1);

	if(buffer == NULL) {
		print_to_file(fp , "\n Error in allocating buffer. \n");
		fprintf(tempo    , "\n Error in allocating buffer. \n");
		fclose(tempo);
		sysprint;
		exit(EXIT_FAILURE);
	}

	
	memset(buffer , 0 , buffer_size);
	raid_operation = (CSMI_SAS_RAID_SET_OPERATION_BUFFER *) buffer;

	if (!inputs_set_raid_operation(&(raid_operation->Information))){
		return;		
	}
			
	set_header(raid_operation, buffer_size , CC_CSMI_SAS_SET_RAID_OPERATION);

	if(hexDumper) {
		dump = buffer;
		DisplayDumpBefore(dump);
	}
	
	rc = call_ioctl(raid_operation, buffer_size, 
				CC_CSMI_SAS_SET_RAID_OPERATION);

	if(rc == 0) {
		print_to_file( fp , "Error in Issuing raid_operation IOCTL\n");
		fprintf(tempo     , "Error in Issuing raid_operation IOCTL\n");
		fclose(tempo);
		sysprint;
	}

	DisplayIoctlHeader(raid_operation->IoctlHeader);
/*	if((raid_operation->IoctlHeader.ReturnCode) != CSMI_SAS_STATUS_SUCCESS);
		check_return_code(raid_operation);*/

}

int inputs_set_raid_operation(CSMI_SAS_RAID_SET_OPERATION *raid_operation)
{
	int choice = 0;
	CSMI_SAS_RAID_SET_DRIVE_LIST *DriveList;
	int uDriveCount=0;	

	printf("Select RAID set operation\n");
	printf("1> CREATE\n");
	printf("2> SET LABEL\n");
	printf("3> SET CACHE\n");
	printf("4> SET WRITE PROTECT\n");
	printf("5> SET ONLINE STATE\n");
	printf("6> SET SPARE\n");
	printf("7> TRANSFORM\n");
	printf("8> DELETE\n");
	printf("Enter your Option:(1 - 5):");

	scanf("%d", &choice);

	switch(choice){
		case 1:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_CREATE;

			inputs_raid_operation_create( 
					&(raid_operation->Operation.Create));

			DriveList = input_physical_drive_info( &uDriveCount, raid_operation->Operation.Create.bRaidType); 

			if ( !DriveList ) {
					printf("Physical Drives not available to create RaidSet\n");
					return 0;
			}

			memcpy(raid_operation->Parameters.DriveList, DriveList, 
							(uDriveCount * sizeof(CSMI_SAS_RAID_SET_DRIVE_LIST)) );
			raid_operation->Operation.Create.uDriveCount = uDriveCount;

			break;
		case 2:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_LABEL;

			inputs_raid_operation_set_label( &(raid_operation->Operation.Label) );

			printf("Label:%s\n", raid_operation->Operation.Label.bLabel);
			break;
		case 3:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_CACHE;

			inputs_raid_operation_set_cache( &(raid_operation->Operation.Cache) );
			break;
		case 4:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_WRITE_PROTECT;

			inputs_raid_operation_set_writeprotect( &(raid_operation->Operation.Protect) );
			break;
		case 5:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_ONLINE_STATE;

			inputs_raid_operation_set_onlinestate( &(raid_operation->Operation.State) );
			break;
		case 6:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_SPARE;

			inputs_raid_operation_set_spare( &(raid_operation->Operation.Spare) );

			DriveList = input_physical_drive_info( &uDriveCount, -1); 

			if ( !DriveList ) {
					printf("Physical Drives not available to create RaidSet\n");
					return 0;
			}

			memcpy(raid_operation->Parameters.DriveList, DriveList, 
							(uDriveCount * sizeof(CSMI_SAS_RAID_SET_DRIVE_LIST)) );
			raid_operation->Operation.Spare.uDriveCount = uDriveCount;
			break;
		case 7:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_TRANSFORM;

			inputs_raid_operation_set_transform( &(raid_operation->Operation.Transform) );

			if ( raid_operation->Operation.Transform.bTransformType == CSMI_SAS_RAID_SET_TRANSFORM_RAID_SET) {
				DriveList = input_physical_drive_info_modify( &uDriveCount, 
								raid_operation->Operation.Transform.Modify.bRaidType,
								raid_operation->Operation.Transform.uRaidSetIndex); 

				if ( !DriveList ) {
					printf("Physical Drives not available to create RaidSet\n");
					return 0;
				}

				memcpy(raid_operation->Parameters.DriveList, DriveList, 
							(uDriveCount * sizeof(CSMI_SAS_RAID_SET_DRIVE_LIST)) );
				raid_operation->Operation.Transform.Modify.uDriveCount = uDriveCount;
			}


			break;
		case 8:
			raid_operation->uOperationType = CSMI_SAS_RAID_SET_DELETE;

			inputs_raid_operation_set_delete( &(raid_operation->Operation.Delete) );
			break;
		default:
			printf("\nInvalid Option.......");
			break;
	}

	return 1;
}

void inputs_raid_operation_create( CSMI_SAS_RAID_SET_CREATE_INFO *Create)
{

	Create->bRaidType             = input_raid_operation_create_raidtype();
	Create->uStripeSize           = input_raid_operation_create_stripesize(Create->bRaidType);

	Create->uTrackSectorCount     = input_raid_operation_create_tSectorCnt();
	Create->ulRaidSetBlocks.uLowPart = 0; 
	Create->ulRaidSetBlocks.uHighPart = 0; 
	Create->ulRaidSetExtentOffset.uLowPart = 0;
	Create->ulRaidSetExtentOffset.uHighPart = 0;

	input_raid_operation_create_label(Create->bLabel) ;

	Create->uRaidSetIndex 	      = 0;
	input_raid_operation_create_scratchpad( Create->bApplicationScratchPad) ;

        printf("Enter Number Of Heads\n");
        scanf("%d", &Create->uNumberOfHeads);
 
        printf("Enter Number Of Tracks\n");
        scanf("%d", &Create->uNumberOfTracks);

	
}

void inputs_raid_operation_set_label( CSMI_SAS_RAID_SET_LABEL_INFO *Label)
{
	char bLabel[16];
	int raid_set_index;

	printf("Enter the Raid set index:");
	scanf("%d", &raid_set_index);	
	printf("Enter Raid set Label:");
	scanf("%s", bLabel);

	Label->uRaidSetIndex = raid_set_index;
	strcpy( Label->bLabel, bLabel);
}

void inputs_raid_operation_set_cache( CSMI_SAS_RAID_SET_CACHE_INFO *Cache)
{
	int raid_set_index;
	int cache_set_choice;
	int cache_ratio_choice;
	int cache_ratio;

	printf("Enter the Raid set index:");
	scanf("%d", &raid_set_index);	

	printf("Select the Raid set Cache setting:\n");
	printf("1. CACHE ENABLE\n");
	printf("2. CACHE DISABLE\n");
	printf("3. UNCHANGE\n");
	
	printf("Enter the choice, cache option:");
	scanf("%d", &cache_set_choice);	

	Cache->uRaidSetIndex = raid_set_index;

	switch (cache_set_choice) {
		case 1:
			Cache->bCacheSetting = CSMI_SAS_RAID_SET_CACHE_ENABLED;		
			break;
		case 2:
			Cache->bCacheSetting = CSMI_SAS_RAID_SET_CACHE_DISABLED;		
			break;
		case 3:
			Cache->bCacheSetting = CSMI_SAS_RAID_SET_CACHE_UNCHANGED;		
			break;
		default:
			printf("Invalid Cache setting option\n");
			break;	
	}

	printf("Select the Raid set Cache Ratio Falg\n");
	printf("1. CACHE RATIO ENABLE\n");
	printf("2. CACHE RATION DISABLE\n");

	printf("Enter the choice, cache raio:");
	scanf("%d", &cache_ratio_choice);

	switch(cache_ratio_choice) {
			case 1:
				Cache->bCacheRatioFlag = CSMI_SAS_RAID_CACHE_RATIO_ENABLE;
				break;
			case 2:
				Cache->bCacheRatioFlag = CSMI_SAS_RAID_CACHE_RATIO_DISABLE;
				break;
			default:
				printf("Invaid Cache Ration flag option\n");
				break;		
	}	
	
	printf("Select the Raid set Cache Ratio ( 0-100, -1 for AUTO):");
	scanf("%d", &cache_ratio);

	if ( cache_ratio <= -1 ) {
		Cache->bCacheRatio	= CSMI_SAS_RAID_CACHE_RATIO_AUTO;
	} else if ( cache_ratio >= 0 || cache_ratio <= 100 ) {
		Cache->bCacheRatio	= cache_ratio;
	} else {
		printf("Invalid Cache Ration. Setting to CACHE_RATIO_AUTO\n");
		Cache->bCacheRatio	= CSMI_SAS_RAID_CACHE_RATIO_AUTO;
	}	
}

void inputs_raid_operation_set_writeprotect( CSMI_SAS_RAID_SET_WRITE_PROTECT_INFO *WriteProtect)
{
	int raid_set_index;
	int write_protect_flag;

	printf("Enter the Raid set index:");
	scanf("%d", &raid_set_index);	

	WriteProtect->uRaidSetIndex = raid_set_index;

	printf("Select the Raid set Write Protect Falg\n");
	printf("1. WRITE PROTECT ENABLE\n");
	printf("2. WRITE PROTECT DISABLE\n");

	printf("Enter the choice, Write Protect Falg:");
	scanf("%d", &write_protect_flag);

	switch(write_protect_flag) {
			case 1:
				WriteProtect->bWriteProtectSetting = CSMI_SAS_RAID_SET_WRITE_PROTECT_ENABLED;
				break;
			case 2:
				WriteProtect->bWriteProtectSetting = CSMI_SAS_RAID_SET_WRITE_PROTECT_DISABLED;
				break;
			case 3:
				WriteProtect->bWriteProtectSetting = CSMI_SAS_RAID_SET_WRITE_PROTECT_UNCHANGED;
				break;
			default:
				printf("Invaid Write Protect flag option\n");
				break;		
	}	
}

void inputs_raid_operation_set_onlinestate( CSMI_SAS_RAID_SET_ONLINE_STATE_INFO *OnlineState)
{
	int raid_set_index;
	int online_state;

	printf("Enter the Raid set index:");
	scanf("%d", &raid_set_index);	

	OnlineState->uRaidSetIndex = raid_set_index;

	printf("Select the Raid set Online State Falg\n");
	printf("1. UNKNOWN\n");
	printf("2. ONLINE\n");
	printf("3. OFFLINE\n");

	printf("Enter the choice, Online State Falg:");
	scanf("%d", &online_state);

	switch(online_state) {
			case 1:
				OnlineState->bOnlineState = CSMI_SAS_RAID_SET_STATE_UNKNOWN;
				break;
			case 2:
				OnlineState->bOnlineState = CSMI_SAS_RAID_SET_STATE_ONLINE;
				break;
			case 3:
				OnlineState->bOnlineState = CSMI_SAS_RAID_SET_STATE_OFFLINE;
				break;
			default:
				printf("Invaid STATE flag option\n");
				break;		
	}	
}

void inputs_raid_operation_set_spare( CSMI_SAS_RAID_SET_SPARE_INFO *Spare)
{
	int raid_set_index;

	printf("Enter the Raid set index:");
	scanf("%d", &raid_set_index);	

	Spare->uRaidSetIndex = raid_set_index;
}

void inputs_raid_operation_set_delete( CSMI_SAS_RAID_SET_DELETE_INFO *Delete)
{
	int raid_set_index;

	printf("Enter the Raid set index:");
	scanf("%d", &raid_set_index);	

	Delete->uRaidSetIndex = raid_set_index;
}

void inputs_raid_operation_set_transform( CSMI_SAS_RAID_SET_TRANSFORM_INFO *Transform)
{
	int raid_set_index, raid_set_additional_index;
	int raid_set_transform_type;

	printf("Enter the Raid set Transform type:\n");
	printf("1. SPLIT MIRROR\n");
	printf("2. MERGE MIRROR\n");
	printf("3. LUN RENUMBER\n");
	printf("4. TRANSFORM\n");
	printf("Enter the choice:");
	scanf("%d", &raid_set_transform_type);

	switch ( raid_set_transform_type ) {
		case 1:
			Transform->bTransformType = CSMI_SAS_RAID_SET_TRANSFORM_SPLIT_MIRROR;
			break;	
		case 2:
			Transform->bTransformType = CSMI_SAS_RAID_SET_TRANSFORM_MERGE_RAID_0;
			break;	
		case 3:
			Transform->bTransformType = CSMI_SAS_RAID_SET_TRANSFORM_LUN_RENUMBER;
			break;	
		case 4:
			Transform->bTransformType = CSMI_SAS_RAID_SET_TRANSFORM_RAID_SET;
			break;	
		default:
			printf("Invalid Transform type option\n");
			break;		
	}

	printf("Enter the Raid set index:");
	scanf("%d", &raid_set_index);	

	Transform->uRaidSetIndex = raid_set_index;

	if (Transform->bTransformType == CSMI_SAS_RAID_SET_TRANSFORM_MERGE_RAID_0) {
		printf("Enter the Additional Raid set index:");
		scanf("%d", &raid_set_additional_index);	

		Transform->uAdditionalRaidSetIndex = raid_set_additional_index;
	}

	if (Transform->bTransformType == CSMI_SAS_RAID_SET_TRANSFORM_RAID_SET) {
		Transform->Modify.bRaidType             = input_raid_operation_create_raidtype();
		Transform->Modify.uStripeSize           = input_raid_operation_create_stripesize(Transform->Modify.bRaidType);
		Transform->Modify.ulRaidSetBlocks.uLowPart        = 0;
		Transform->Modify.ulRaidSetBlocks.uHighPart       = 0;
		Transform->Modify.ulRaidSetExtentOffset.uLowPart  = 0;
		Transform->Modify.ulRaidSetExtentOffset.uHighPart = 0;
	}

	input_raid_operation_create_scratchpad(Transform->bApplicationScratchPad);
}

int input_raid_operation_create_raidtype()
{
	CSMI_SAS_RAID_FEATURES_BUFFER *raid_features;
	int raid_type, i;

	if ( (raid_features = call_raid_features()) == NULL ) {
		return -1;
	}


	printf("Select RAID type\n");

	for(i=0; i < 24; i++) {

		if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_NONE ) {
			printf("0. NONE\n");
		}	
		else if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_0 ) {
			printf("1. RAID 0\n");
		}	
		else if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_1 ) {
			printf("2. RAID 1\n");
		}	
		else if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_10 ) {
			printf("3. RAID 0+1\n");
		}	
		else if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_5 ) {
			printf("4. RAID 5\n");
		}	
		else if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_15 ) {
			printf("5. RAID 1+5\n");
		}	
		else if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_6 ) {
			printf("6. RAID 6\n");
		}	
		else if ( raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_OTHER)	{
			printf("255. OTHER\n");
		}	
		else if (raid_features->Information.RaidType[i].bRaidType == CSMI_SAS_RAID_TYPE_END)
			break;
	}

	printf("Enter raid_type choice:");
	scanf("%d", &raid_type);

	return raid_type;
}

int input_raid_operation_create_stripesize(int bRaidType)
{
	CSMI_SAS_RAID_FEATURES_BUFFER *raid_features;
	unsigned int stripeSizeMap;
	int i=31, j=0, k=0;
	int stripeChoice;
	int stripeSizes[32];

	if ( (raid_features = call_raid_features()) == NULL ) {
		return -1;
	}

	stripeSizeMap = raid_features->Information.RaidType[bRaidType].uSupportedStripeSizeMap;

	if (stripeSizeMap == 0 ) {
		printf("Selecting default stripe size\n");
		return 0;
	} else { 
		
		printf("Select Stripe Size\n");
		do {
			if ( (stripeSizeMap << i >> 31) == 1 ) {
				stripeSizes[k++] = (1 << j ) ;
			};
			i--; j++;
		} while ( i > 0 ); 
		
	}

	for(i=0; i < k; i++) {
		printf("%d. %d\n", i, stripeSizes[i]);
	}

	do {

		printf("Enter stripe_size choice:");
		scanf("%d", &stripeChoice);
	
		if ( stripeChoice >= 0 && stripeChoice < i)
				return ( stripeSizes[stripeChoice]);

		printf("Invalid Option\n");
	} while(1);
		
}

int input_raid_operation_create_tSectorCnt()
{
	int choice;

	printf("Select Sector count per Track\n");

	printf("0. 0 (default size)\n");
	printf("1. 32\n");
	printf("2. 64 (MAX Boot)\n");


	do {
		printf("Enter the choice:");
		scanf("%d", &choice);
		switch (choice) {
			case 0:
				return 0;
			case 1:
				return 32;
			case 2:
				return 63;
			default:
				printf("Invalid Option\n");
		}
	} while(1);

}	

void input_raid_operation_create_label(char *pLabel)
{
	char bLabel[16];

	printf("Enter Raid set Label:");
	scanf("%s", bLabel);

	strcpy( pLabel, bLabel);
}

void input_raid_operation_create_scratchpad(char *pScratchPad)
{
	char bScratchPad[16] = "time 0";

	strcpy( pScratchPad, bScratchPad);
}

CSMI_SAS_RAID_SET_DRIVE_LIST * input_physical_drive_info(int *uDriveCount, int bRaidType)
{
//	CSMI_SAS_SSP_PASSTHRU_BUFFER *PassthruBuff;
	CSMI_SAS_PHY_INFO_BUFFER *PhyInfo;
	CSMI_SAS_RAID_ELEMENT *raid_element;
	CSMI_SAS_RAID_SET_DRIVE_LIST *DriveList;
	int available_physical_devices=0;
	int num_phy_devices	;
	int phy_index;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;
	int phy;
	int CommandCount;
	int i;
//	PCDB pCdb;

    buffer = (char *)calloc(1,bufferSize);

	if(buffer) {
		PhyInfo = (CSMI_SAS_PHY_INFO_BUFFER *)buffer;
	}
	else {
		printf("\n Error in allocating the Buffer. \n");
		exit(0);
	}

	set_header(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper) {
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper) {
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)	{
		printf("\n Error in issuing the ioctl \n");
		return;
	}

	printf("Physical Drive Information\n");
	printf("Index No.of Blks SAS_Address\n");
	printf("----- ---------- -----------\n");
	for(phy = 0; (phy < PhyInfo->Information.bNumberOfPhys); phy++) {
        
		raid_element = call_get_raid_drive_info(phy);

		if ( ( raid_element->Element.Drive.Device.bDriveUsage == CSMI_SAS_DRIVE_CONFIG_NOT_USED )  &&
		  	( PhyInfo->Information.Phy[phy].Attached.bDeviceType == CSMI_SAS_END_DEVICE ) ) {
			available_physical_devices++;		
			printf("%5d %10ld (LOW)", raid_element->Element.Drive.Device.uDriveIndex, 
					raid_element->Element.Drive.Device.ulTotalUserBlocks.uLowPart);
			printf("%5d %10ld (HIGH)", raid_element->Element.Drive.Device.uDriveIndex, 
					raid_element->Element.Drive.Device.ulTotalUserBlocks.uHighPart);
			
			printf(" %2x:%2x:%2x:%2x:%2x:%2x:%2x:%2x\n",
					raid_element->Element.Drive.Device.bSASAddress[0],
					raid_element->Element.Drive.Device.bSASAddress[1],
					raid_element->Element.Drive.Device.bSASAddress[2],
					raid_element->Element.Drive.Device.bSASAddress[3],
					raid_element->Element.Drive.Device.bSASAddress[4],
					raid_element->Element.Drive.Device.bSASAddress[5],
					raid_element->Element.Drive.Device.bSASAddress[6],
					raid_element->Element.Drive.Device.bSASAddress[7]);
		}	
	}

	if ( available_physical_devices <= 0 )
			return NULL;

	if ( bRaidType == -1 ) {
		printf("Enter no.of spare drives to configure:");
	} else
		printf("Enter no.of phy devices to configure:");

	scanf ("%d", &num_phy_devices);

	if ( num_phy_devices < 1 )
		return NULL;

	if ( bRaidType != -1 ) {
		if ( bRaidType == CSMI_SAS_RAID_TYPE_NONE ){
			printf("Error: Invalid RAID Type selected to create RAID set\n");
			return NULL;
		} else if ( bRaidType == CSMI_SAS_RAID_TYPE_0) {
			if ( num_phy_devices < 1 )
				return NULL;		
		} else if (  (bRaidType == CSMI_SAS_RAID_TYPE_1) || (bRaidType == CSMI_SAS_RAID_TYPE_10) ) {
			if (  (num_phy_devices % 2 ) != 0 )
				return NULL;		
		} else if ( bRaidType == CSMI_SAS_RAID_TYPE_5) {
			if (  num_phy_devices  < 3 )
				return NULL;		
		} else if ( bRaidType == CSMI_SAS_RAID_TYPE_6) {
			if (  num_phy_devices  < 4 )
				return NULL;		
		}
	}
			
	*uDriveCount = num_phy_devices;	

	if ( !(DriveList = calloc(num_phy_devices, sizeof(CSMI_SAS_RAID_SET_DRIVE_LIST)) ) )
		return NULL;

	for(i=0; i < num_phy_devices; i++) {
			printf("Enter %d index:", i+1);
			scanf ("%d", &phy_index);
			DriveList[i].uDriveIndex = phy_index;	
	}

	if(buffer)
		free(buffer);

	return DriveList;
}

CSMI_SAS_RAID_ELEMENT *call_get_raid_drive_info(int element_index)
{

	CSMI_SAS_RAID_ELEMENT_BUFFER *raid_element;
	CSMI_SAS_RAID_INFO_BUFFER *raid_info;
	char *buffer , *dump;

	int buffer_size = 2 << 14;
	long rc;
	
	tempo = fopen(TEMP_FILE_NAME ,"w");

	/*if((raid_info= call_raid_info()) == NULL) {
		return;
	}*/
	

	buffer = calloc(1 , buffer_size);

	if(buffer == NULL) {
		 print_to_file(fp , "\n Error in allocating buffer. \n");
		 fprintf(tempo,"\n Error in allocating buffer. \n");
		 fclose(tempo);
		 sysprint;
		 exit(EXIT_FAILURE);
		 
	}
		
	memset(buffer , 0 , buffer_size);
	raid_element = (CSMI_SAS_RAID_ELEMENT_BUFFER *) buffer;
	
	if((raid_info = call_raid_info()) == NULL) {
		return;
	}
	
	set_header(raid_element , buffer_size , CC_CSMI_SAS_GET_RAID_ELEMENT);
	
	if(hexDumper) {
		dump = buffer;
		DisplayDumpBefore(dump);
	}

	raid_element->Information.uElementIndex = element_index;
	raid_element->Information.uSubElementIndex = 0;

	rc = call_ioctl(raid_element , buffer_size , CC_CSMI_SAS_GET_RAID_ELEMENT);

	if(hexDumper){
		dump = buffer;
		DisplayDumpAfter(dump);
	}

	if(rc == 0){
		print_to_file(fp , "Error in issuing raid_element IOCTL(prerequisit).\n");
		fprintf(tempo , "Error in issuing raid_element IOCTL(prerequisit).\n");
		sysprint;
		return NULL;
	}

	return (&raid_element->Information);

	
}


CSMI_SAS_RAID_SET_DRIVE_LIST * input_physical_drive_info_modify(int *uDriveCount, int bRaidType, int bRaidSetIndex)
{
	CSMI_SAS_SSP_PASSTHRU_BUFFER *PassthruBuff;
	CSMI_SAS_PHY_INFO_BUFFER *PhyInfo;
	CSMI_SAS_RAID_ELEMENT *raid_element;
	CSMI_SAS_RAID_SET_DRIVE_LIST *DriveList;
	int available_physical_devices=0;
	int num_phy_devices	;
	int phy_index;
	char *buffer;
    int bufferSize = 16384;
	char *s;
	long returnCode;
	int phy;
	int CommandCount;
	int i;
	PCDB pCdb;
	int drive_raid_set_index;

    buffer = (char *)calloc(1,bufferSize);

	if(buffer) {
		PhyInfo = (CSMI_SAS_PHY_INFO_BUFFER *)buffer;
	}
	else {
		printf("\n Error in allocating the Buffer. \n");
		exit(0);
	}

	set_header(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper) {
		s = buffer;
		DisplayDumpBefore(s);
	}

	returnCode = call_ioctl(PhyInfo,bufferSize,CC_CSMI_SAS_GET_PHY_INFO);

	if(hexDumper) {
		s = buffer;
		DisplayDumpAfter(s);
	}

	if(returnCode == 0)	{
		printf("\n Error in issuing the ioctl \n");
		return;
	}

	printf("Physical Drive Information\n");
	printf("Index No.of Blks RAID_SET     SAS_Address\n");
	printf("----- ---------- ----------   -----------\n");
	for(phy = 0; (phy < PhyInfo->Information.bNumberOfPhys); phy++) {
        
		raid_element = call_get_raid_drive_info(phy);

		if ( PhyInfo->Information.Phy[phy].Attached.bDeviceType == CSMI_SAS_END_DEVICE )  {

			drive_raid_set_index = get_raid_set_index_for_drive(raid_element->Element.Drive.Device.bSASAddress);

			if ( drive_raid_set_index != bRaidSetIndex )
				continue;				

			printf("%5d %10ld (LOW)", raid_element->Element.Drive.Device.uDriveIndex, 
							raid_element->Element.Drive.Device.ulTotalUserBlocks.uLowPart);
			printf("%5d %10ld (HIGH)", raid_element->Element.Drive.Device.uDriveIndex, 
							raid_element->Element.Drive.Device.ulTotalUserBlocks.uHighPart);

			if ( drive_raid_set_index == -1 )
				printf(" UN_USED    ");
			else 
				printf(" %10d", drive_raid_set_index);
			
			printf("   %2x:%2x:%2x:%2x:%2x:%2x:%2x:%2x\n",
					raid_element->Element.Drive.Device.bSASAddress[0],
					raid_element->Element.Drive.Device.bSASAddress[1],
					raid_element->Element.Drive.Device.bSASAddress[2],
					raid_element->Element.Drive.Device.bSASAddress[3],
					raid_element->Element.Drive.Device.bSASAddress[4],
					raid_element->Element.Drive.Device.bSASAddress[5],
					raid_element->Element.Drive.Device.bSASAddress[6],
					raid_element->Element.Drive.Device.bSASAddress[7]);

			available_physical_devices++;		
		}	
	}

	if ( available_physical_devices <= 0 )
			return NULL;

	if ( bRaidType == -1 ) {
		printf("Enter no.of spare drives to configure:");
	} else
		printf("Enter no.of phy devices to configure:");

	scanf ("%d", &num_phy_devices);

	if ( num_phy_devices < 1 )
		return NULL;

	if ( bRaidType != -1 ) {
		if ( bRaidType == CSMI_SAS_RAID_TYPE_NONE ){
			printf("Error: Invalid RAID Type selected to create RAID set\n");
			return NULL;
		} else if ( bRaidType == CSMI_SAS_RAID_TYPE_0) {
			if ( num_phy_devices < 1 )
				return NULL;		
		} else if (  (bRaidType == CSMI_SAS_RAID_TYPE_1) || (bRaidType == CSMI_SAS_RAID_TYPE_10) ) {
			if (  (num_phy_devices % 2 ) != 0 )
				return NULL;		
		} else if ( bRaidType == CSMI_SAS_RAID_TYPE_5) {
			if (  num_phy_devices  < 3 )
				return NULL;		
		} else if ( bRaidType == CSMI_SAS_RAID_TYPE_6) {
			if (  num_phy_devices  < 4 )
				return NULL;		
		}
	}
			
	*uDriveCount = num_phy_devices;	

	if ( !(DriveList = calloc(num_phy_devices, sizeof(CSMI_SAS_RAID_SET_DRIVE_LIST)) ) )
		return NULL;

	for(i=0; i < num_phy_devices; i++) {
			printf("Enter %d index:", i+1);
			scanf ("%d", &phy_index);
			DriveList[i].uDriveIndex = phy_index;	
	}

	if(buffer)
		free(buffer);

	return DriveList;
}

int get_raid_set_index_for_drive( char * bSASAddress)
{
	CSMI_SAS_RAID_DRIVES *Drives;
	CSMI_SAS_RAID_CONFIG_BUFFER *raidConfig;
	CSMI_SAS_RAID_INFO_BUFFER *RaidInfo;
	char *buffer;
    int bufferSize = 2<<14;
	char *s;
	long returnCode;
	unsigned long TotalRaidSets, MaxDrivesPerSet;
	int raidIndex = 0, raid_set_count = 0;
	int index;

	tempo = fopen(TEMP_FILE_NAME,"w");

    buffer = (char *)calloc(1,bufferSize);
    memset(buffer,0,bufferSize);

	if(buffer)
	{
		RaidInfo = (CSMI_SAS_RAID_INFO_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}


	set_header(RaidInfo,bufferSize,CC_CSMI_SAS_GET_RAID_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpBefore(s);
	}

	
	returnCode = call_ioctl(RaidInfo,bufferSize,CC_CSMI_SAS_GET_RAID_INFO);

	if(hexDumper)
	{
		s = buffer;
		DisplayDumpAfter(s);

	} 

    if(returnCode == 0)
	{
		//printf("\n Error in issuing the ioctl \n");
		print_to_file(fp,"\n Error in issuing the ioctl \n");
		fprintf(tempo,"\n Error in issuing the ioctl \n");
		return;
	}


	MaxDrivesPerSet = RaidInfo->Information.uMaxDrivesPerSet;
	TotalRaidSets = RaidInfo->Information.uNumRaidSets;

	
	if(buffer)
		free(buffer);

    buffer = (char *)calloc(1,bufferSize);

	if(buffer)
	{
		raidConfig = (CSMI_SAS_RAID_CONFIG_BUFFER *)buffer;
	}
	else
	{
		//printf("\n Error in allocating the Buffer. \n");
		print_to_file(fp,"\n Error in allocating the Buffer. \n");
		fprintf(tempo,"\n Error in allocating the Buffer. \n");
		exit(0);
	}

	raidIndex = 0;

	while(raid_set_count != TotalRaidSets )
    {

		memset(raidConfig,0,bufferSize);


		raidConfig->Configuration.uRaidSetIndex = raidIndex;
		raidConfig->Configuration.bDataType     = CSMI_SAS_RAID_DATA_DRIVES;

		set_header(raidConfig,bufferSize,CC_CSMI_SAS_GET_RAID_CONFIG);

		if(hexDumper)
			{
				s = buffer;
				DisplayDumpBefore(s);
			}


		returnCode = call_ioctl(raidConfig,bufferSize,CC_CSMI_SAS_GET_RAID_CONFIG);

		if(hexDumper)
		{
			s = buffer;
			DisplayDumpAfter(s);
		}
		

		if(returnCode == 0)
		{
			//printf("\n Error in issuing the ioctl \n");
			print_to_file(fp,"\n Error in issuing the ioctl \n");
			fprintf(tempo,"\n Error in issuing the ioctl \n");
			fclose(tempo);
			sysprint;
			return;
		}

		if(raidConfig->Configuration.bDriveCount == 0) {
			raidIndex++;
			continue;
		}
		else 
			raid_set_count++;
		
		Drives = (CSMI_SAS_RAID_DRIVES *)&raidConfig->Configuration.Drives;
	
		if(raidConfig->Configuration.bDataType == CSMI_SAS_RAID_DATA_DRIVES)
		{
			for(index=0;(index < raidConfig->Configuration.bDriveCount) && (index < 240) ;index++) {
				if ( memcmp(Drives[index].bSASAddress, bSASAddress, 8) == 0 ) {
					return raidIndex;
				}
			}
		}
		raidIndex++;
	}

	fclose(tempo);
	sysprint;

	if(buffer)
		free(buffer);

	return -1;
}


CSMI_SAS_RAID_FEATURES_BUFFER * call_raid_features()
{
	CSMI_SAS_RAID_FEATURES_BUFFER *raid_features;
	char *buffer;
	int size = 2 <<14 , rc;

	buffer = calloc(1 , size);
	if(buffer == NULL){
		print_to_file(fp , "\n Error in allocating buffer. \n");
		fprintf(tempo,"\n Error in allocating buffer. \n");
		fclose(tempo);
		sysprint;
		exit(EXIT_FAILURE);
	}
	else{
		memset(buffer , 0 , size);
		raid_features = (CSMI_SAS_RAID_FEATURES_BUFFER *)buffer;
		
	}
	set_header(raid_features , size , CC_CSMI_SAS_GET_RAID_FEATURES);
	
	rc = call_ioctl(raid_features , size , CC_CSMI_SAS_GET_RAID_FEATURES);

	if(rc == 0){
		print_to_file(fp , "Error in issuing raid_features IOCTL(prerequisit).\n");
		fprintf(tempo , "Error in issuing raid_features IOCTL(prerequisit).\n");
		sysprint;
		return NULL;
	}
	return raid_features;
	
	
}


void  Check_ReturnCode_Raid_Config( CSMI_SAS_RAID_CONFIG_BUFFER *raidConfig)
    {
	if(raidConfig->IoctlHeader.ReturnCode == CSMI_SAS_STATUS_INVALID_PARAMETER){
	switch(raidConfig->Configuration.uFailureCode){
				case CSMI_SAS_FAIL_CODE_OK:
					print_to_file(fp, "Operation Was Successfull\n");
					fprintf(tempo   , "Operation Was Successfull\n");
					break;
				case CSMI_SAS_FAIL_CODE_ENUMERATION_TYPE_INVALID:
					print_to_file(fp, "bDatatype Value Provided is Invalid Or Unsupported\n");
					fprintf(tempo   , "bDatatype VAlue Provided is Invalid or unsupported\n");
					break;
				case CSMI_SAS_FAIL_CODE_CHANGE_COUNT_INVALID:
					print_to_file(fp,"uChangeCountValue Provided was Invalid or Unsupported\n");
					fprintf(tempo   ,"uChangeCountVAlue Provided was Invalid or Unsupported\n");
					break;
	}

     }
}



void  Check_ReturnCode_Raid_Features( CSMI_SAS_RAID_FEATURES_BUFFER *raid_features)
   {
	if(raid_features->IoctlHeader.ReturnCode == CSMI_SAS_STATUS_INVALID_PARAMETER){
	switch(raid_features->Information.uFailureCode){
				case CSMI_SAS_FAIL_CODE_OK:
					print_to_file(fp, "Operation Was Successfull\n");
					fprintf(tempo   , "Operation Was Successfull\n");
					break;
				case CSMI_SAS_FAIL_CODE_ENUMERATION_TYPE_INVALID:
					print_to_file(fp, "bDatatype Value Provided is Invalid Or Unsupported\n");
					fprintf(tempo   , "bDatatype VAlue Provided is Invalid or unsupported\n");
					break;
				case CSMI_SAS_FAIL_CODE_CHANGE_COUNT_INVALID:
					print_to_file(fp,"uChangeCountValue Provided was Invalid or Unsupported\n");
					fprintf(tempo   ,"uChangeCountVAlue Provided was Invalid or Unsupported\n");
					break;
	}
    }
}
