#include <sys/errno.h>
#include <getopt.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include "csmisas.h"
#include "misc.h"


extern int fd;
extern int io_controller_number;
extern FILE *fp;
//extern int counter;



/* Dummy Functions so as to avoide compiler warnings */
//void DoWindowsPreInitRoutine() { };
//void DoNetwarePreInitRoutine() { };

//void DoWindowsInitRoutine(char* dev_node) { };
//void DoNetwareInitRoutine(char* dev_node) { };

//void set_windows_header(void *HeaderInfo, int bufferSize, int cmdType) { };
//long call_windows_ioctl(void *IoctlBuffer, int bufferSize, int cmdType) { return 0; } ;

//void set_netware_header(void *HeaderInfo, int bufferSize, int cmdType) { };
//long call_netware_ioctl(void *IoctlBuffer, int bufferSize, int cmdType) { return 0; } ;
/* Dummy Functions so as to avoide compiler warnings */



//void DoLinuxPreInitRoutine()
void DoPreInitRoutine()
{
	printf("\n Enter the path to Device Node : ");
}


//void DoLinuxInitRoutine(char* dev_node)
void DoInitRoutine(char* dev_node)
{
	
	/* 
	 * Changed on 19th Aug 05
	 * /dev should not be assumed
	 * full pathname must be given
	*/

	/*char tmp_Name[20];
	strcpy(tmp_Name,"/dev/");
	strcat(tmp_Name,dev_node);
	strcpy(dev_node,tmp_Name);*/

	fd = open(dev_node, O_RDWR);
	if (fd < 0){
		
			printf("Open of device node <%s> failed with errno=%d\n", dev_node, errno);
		print_to_file(fp,"Open of device node <%s> failed with errno=%d\n", dev_node, errno);
		exit(EXIT_FAILURE);
	}

}





/* Generalized Header for Linux */

//void set_linux_header(void* HeaderInfo,int bufferSize,int cmdType)
void set_header(void* HeaderInfo,int bufferSize,int cmdType)
{
  IOCTL_HEADER *IoctlHeader = HeaderInfo;
  IoctlHeader->Length = 20000;
  IoctlHeader->Timeout = CSMI_ALL_TIMEOUT;
  IoctlHeader->Direction = CSMI_SAS_DATA_READ;
  IoctlHeader->IOControllerNumber = io_controller_number;
}

/* Generalized Header for Linux */




/* Generalized IOCTL Call for Linux */

//long call_linux_ioctl(void* IoctlBuffer, int bufferSize, int cmdType)
long call_ioctl(void* IoctlBuffer, int bufferSize, int cmdType)
{
	long returnCode = 0;

	returnCode = ioctl(fd, cmdType, IoctlBuffer); //CHECK

	return !returnCode;
}

/* Generalized IOCTL Call for Linux */


void clearScreen()
{
	system("clear");
}

