
// Function declaration
void DisplayIoctlHeader(IOCTL_HEADER Hdr);
void DisplayFirmwareDownload(CSMI_SAS_FIRMWARE_DOWNLOAD);
void DisplayDriverInfo(CSMI_SAS_DRIVER_INFO Info);
void DisplayCntlrConfig(CSMI_SAS_CNTLR_CONFIG Config);
void DisplayCntlrStatus(CSMI_SAS_CNTLR_STATUS Status);
void DisplayRaidInfo(CSMI_SAS_RAID_INFO Info);
void DisplayRaidConfig(CSMI_SAS_RAID_CONFIG *raidConfig);
void DisplayPhyInfo(CSMI_SAS_PHY_INFO Info);
void DisplaySASIdentify(CSMI_SAS_IDENTIFY Identify);
void DisplayErrorInfo(CSMI_SAS_LINK_ERRORS Info);
void DisplaySignature(CSMI_SAS_SATA_SIGNATURE Signature);
void DisplaySCSIAddr(CSMI_SAS_GET_SCSI_ADDRESS_BUFFER *ScsiAddrBuff);
void DisplayDeviceAddress(CSMI_SAS_GET_DEVICE_ADDRESS_BUFFER *DeviceAddress);
void DisplaySMPPassthru(CSMI_SAS_SMP_PASSTHRU_BUFFER *PassthruBuff);
void DisplaySSPPassthru(CSMI_SAS_SSP_PASSTHRU_BUFFER *PassthruBuff);
void DisplaySTPPassthru(CSMI_SAS_STP_PASSTHRU_BUFFER *PassthruBuff);
void DisplayTaskManagement(CSMI_SAS_SSP_PASSTHRU_STATUS);  
void DisplayConnectorInfo(CSMI_SAS_CONNECTOR_INFO_BUFFER *Connector,int no_of_phys);      
void display_additional_config_data(CSMI_SAS_RAID_SET_ADDITIONAL_DATA*);
void display_device_id(CSMI_SAS_RAID_CONFIG *);
char *display_raid_type(CSMI_SAS_RAID_TYPE_DESCRIPTION *);
void  Check_ReturnCode_Raid_Config( CSMI_SAS_RAID_CONFIG_BUFFER *raidConfig);
void  Check_ReturnCode_Raid_Features( CSMI_SAS_RAID_FEATURES_BUFFER *raid_features);
int get_choice();




//void PrintUsage(void);
void PrintDirection(int Direction);
void PrintReturnCode(int ReturnCode);
void PrintRaidType(unsigned char bRaidType);
void PrintRaidStatus(unsigned char bStatus);
void PrintRaidStatusMoreInfo(unsigned char bStatus, unsigned char bInfo);
void PrintDriveStatus(unsigned char bDriveStatus);
void PrintDriveUsage(unsigned char bDriveUsage);
void PrintProtocol(unsigned char bProtocol);
void PrintLinkRate(unsigned char bLinkRate);
void PrintAutoDiscoverState(unsigned char bAutoDiscover);
void PrintBefore_issue_get_connector_info(int descr);

void issue_firmware_download(char* fname);
void issue_get_driver_info();
void issue_get_ctlr_config();
void issue_get_ctlr_status();
void issue_get_raid_info();
void issue_get_raid_config();
void issue_get_phy_info();
void issue_get_link_error(unsigned char bPhyIdentifier);
void issue_sas_smp_passthru();
void issue_sas_ssp_passthru();
void issue_sas_stp_passthru();
void issue_get_sata_signature(unsigned char bPhyIdentifier);
void issue_get_scsi_address(int TargetId, int LunId);
void issue_get_device_address(int HostId, int PathId, int TargetId, int LunId);
void issue_set_phy_info(int PhyId, int NegLinkRate, int MinLinkRate, int MaxLinkRate);
void issue_sas_task_management(int HostId, int PathId, int TargetId, int LunId);
void issue_get_connector_info();
void issue_get_sas_location(int HostIndex, int PathId,int TargetId, int LunId);
void issue_set_raid_control();
void check_return_code(CSMI_SAS_RAID_CONTROL_BUFFER *);
void check_return_code1(CSMI_SAS_RAID_ELEMENT_BUFFER *);
void inputs_raid_control(CSMI_SAS_RAID_CONTROL *);

void issue_sas_get_location();
void issue_sas_set_raid_operation();
void issue_sas_get_raid_features();
void issue_sas_set_raid_control();
void issue_sas_get_raid_element();
int inputs_set_raid_operation(CSMI_SAS_RAID_SET_OPERATION *raid_operation);
void inputs_raid_operation_create( CSMI_SAS_RAID_SET_CREATE_INFO *Create);
void inputs_raid_operation_set_label( CSMI_SAS_RAID_SET_LABEL_INFO *Label);
void inputs_raid_operation_set_cache( CSMI_SAS_RAID_SET_CACHE_INFO *Cache);
void inputs_raid_operation_set_writeprotect( CSMI_SAS_RAID_SET_WRITE_PROTECT_INFO *WriteProtect);
void inputs_raid_operation_set_onlinestate( CSMI_SAS_RAID_SET_ONLINE_STATE_INFO *OnlineState);
void inputs_raid_operation_set_spare( CSMI_SAS_RAID_SET_SPARE_INFO *Spare);
void inputs_raid_operation_set_delete( CSMI_SAS_RAID_SET_DELETE_INFO *Delete);
void inputs_raid_operation_set_transform( CSMI_SAS_RAID_SET_TRANSFORM_INFO *Transform);
void inputs_raid_operation_driveList( CSMI_SAS_RAID_SET_DRIVE_LIST *DriveList);
int input_raid_operation_create_raidtype();
int input_raid_operation_create_stripesize(int bRaidType);
int input_raid_operation_create_tSectorCnt();
void input_raid_operation_create_label(char *);
void input_raid_operation_create_scratchpad(char *);
CSMI_SAS_RAID_SET_DRIVE_LIST * input_physical_drive_info(int *uDriveCount, int bRaidType);
CSMI_SAS_RAID_SET_DRIVE_LIST * input_physical_drive_info_modify(int *uDriveCount, int bRaidType, int bRaidSetIndex);
CSMI_SAS_RAID_ELEMENT *call_get_raid_drive_info(int element_index);
CSMI_SAS_RAID_FEATURES_BUFFER * call_raid_features();


CSMI_SAS_RAID_INFO_BUFFER *call_raid_info();

void menu_driven_testing();
void inputs_raid_element(CSMI_SAS_RAID_ELEMENT *);



void clearScreen();


void get_temp_file_path();


void set_header (void* HeaderInfo, int bufferSize, int cmdType);
long call_ioctl (void* IoctlBuffer, int bufferSize, int cmdType);

void DoPreInitRoutine();
void DoInitRoutine(char* dev_node);





/* Dummy Functions so as to avoide compiler warnings */
//void DoLinuxPreInitRoutine();
//void DoNetwarePreInitRoutine();
//void DoWindowsPreInitRoutine();

//void DoLinuxInitRoutine(char* dev_node);
//void DoNetwareInitRoutine(char* dev_node);
//void DoWindowsInitRoutine(char* dev_node);

//void set_linux_header(void *HeaderInfo, int bufferSize, int cmdType);
//long call_linux_ioctl(void *IoctlBuffer, int bufferSize, int cmdType);

//void set_netware_header(void *HeaderInfo, int bufferSize, int cmdType);
//long call_netware_ioctl(void *IoctlBuffer, int bufferSize, int cmdType);

//void set_windows_header(void *HeaderInfo, int bufferSize, int cmdType);
//long call_windows_ioctl(void *IoctlBuffer, int bufferSize, int cmdType);
/* Dummy Functions so as to avoide compiler warnings */




void DisplayTitle(int ostype,int TOOL_MAJOR_VERSION, int TOOL_MINOR_VERSION, int TOOL_RELEASE_NUMBER,int CSMI_VERSION_MAJ,int CSMI_VERSION_MIN);
void PrintUsage();
void PrintDirection(int Direction);
void PrintReturnCode(int ReturnCode);
void PrintRaidType(unsigned char bRaidType);
void PrintRaidStatus(unsigned char bStatus);
void PrintRaidStatusMoreInfo(unsigned char bStatus, unsigned char bInfo);
void PrintDriveStatus(unsigned char bDriveStatus);
void PrintDriveUsage(unsigned char bDriveUsage);
void PrintProtocol(unsigned char bProtocol);
void PrintLinkRate(unsigned char bLinkRate);
void PrintAutoDiscoverState(unsigned char bAutoDiscover);
void DisplayIoctlHeader(IOCTL_HEADER Hdr);
void DisplayTaskManagement(CSMI_SAS_SSP_PASSTHRU_STATUS status);
void DisplayFirmwareDownload(CSMI_SAS_FIRMWARE_DOWNLOAD Info);
void PrintBefore_issue_get_driver_info(int descr);
void PrintBefore_issue_get_ctlr_config(int descr);
void PrintBefore_issue_get_ctlr_status(int descr);
void PrintBefore_issue_get_raid_info(int descr);
void PrintBefore_issue_get_raid_config(int descr);
void PrintBefore_issue_get_phy_info(int descr);
void PrintBefore_issue_get_link_error(int descr);
void PrintBefore_issue_ssp_passthru(int descr);
void PrintBefore_issue_stp_passthru(int descr);
void PrintBefore_issue_get_sata_signature(int descr);
void PrintBefore_issue_get_scsi_address(int descr);
void PrintBefore_issue_get_device_address(int descr);
void PrintBefore_issue_set_phy_info(int descr);
void PrintBefore_issue_set_task_management(int descr);
void PrintBefore_issue_firmware_download(int descr);
void PrintBefore_issue_sas_smp_passthru(int descr);
void PrintBefore_issue_sas_get_location(int descr);
void DisplayDumpBefore(char *s);
void DisplayDumpAfter(char* s);
void DisplaySMPPassthru(CSMI_SAS_SMP_PASSTHRU_BUFFER *PassthruBuff);
void DisplayDriverInfo(CSMI_SAS_DRIVER_INFO Info);
void DisplayCntlrConfig(CSMI_SAS_CNTLR_CONFIG Config);
void DisplayCntlrStatus(CSMI_SAS_CNTLR_STATUS Status);
void DisplayRaidInfo(CSMI_SAS_RAID_INFO Info);
void DisplayRaidConfig(CSMI_SAS_RAID_CONFIG *raidConfig);
void DisplaySASIdentify(CSMI_SAS_IDENTIFY Identify);
void DisplayPhyInfo(CSMI_SAS_PHY_INFO Info);
void DisplaySetPhyInfo(CSMI_SAS_SET_PHY_INFO PhyInfo);
void DisplayErrorInfo(CSMI_SAS_LINK_ERRORS Info);
void DisplaySignature(CSMI_SAS_SATA_SIGNATURE Signature);
void DisplaySCSIAddr(CSMI_SAS_GET_SCSI_ADDRESS_BUFFER *ScsiAddrBuff);
void DisplayDeviceAddress(CSMI_SAS_GET_DEVICE_ADDRESS_BUFFER *DeviceAddress);
void DisplaySTPPassthru(CSMI_SAS_STP_PASSTHRU_BUFFER *PassthruBuff);
void DisplaySSPPassthru(CSMI_SAS_SSP_PASSTHRU_BUFFER *PassthruBuff);

typedef unsigned char UCHAR;


typedef union _CDB {

   // Generic 6-Byte CDB
   struct _CDB6GENERIC {
      UCHAR  OperationCode;
      UCHAR  Immediate : 1;
      UCHAR  CommandUniqueBits : 4;
      UCHAR  LogicalUnitNumber : 3;
      UCHAR  CommandUniqueBytes[3];
      UCHAR  Link : 1;
      UCHAR  Flag : 1;
      UCHAR  Reserved : 4;
      UCHAR  VendorUnique : 2;
   } CDB6GENERIC, *PCDB6GENERIC;

   // SCSI Inquiry CDB
   struct _CDB6INQUIRY {
       UCHAR OperationCode;
       UCHAR Reserved1 : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR PageCode;
       UCHAR IReserved;
       UCHAR AllocationLength;
       UCHAR Control;
   } CDB6INQUIRY, *PCDB6INQUIRY;

   // Standard 6-byte CDB
   struct _CDB6READWRITE {
       UCHAR OperationCode;
       UCHAR LogicalBlockMsb1 : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR LogicalBlockMsb0;
       UCHAR LogicalBlockLsb;
       UCHAR TransferBlocks;
       UCHAR Control;
   } CDB6READWRITE, *PCDB6READWRITE;

   // SCSI Format CDB
   struct _CDB6FORMAT {
       UCHAR OperationCode;
       UCHAR FormatControl : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR FReserved1;
       UCHAR InterleaveMsb;
       UCHAR InterleaveLsb;
       UCHAR FReserved2;
   } CDB6FORMAT, *PCDB6FORMAT;

   // Standard 10-byte CDB
  struct _CDB10 {
       UCHAR OperationCode;
       UCHAR RelativeAddress : 1;
       UCHAR Reserved1 : 2;
       UCHAR ForceUnitAccess : 1;
       UCHAR DisablePageOut : 1;
       UCHAR LogicalUnitNumber : 3;
       UCHAR LogicalBlockByte0;
       UCHAR LogicalBlockByte1;
       UCHAR LogicalBlockByte2;
       UCHAR LogicalBlockByte3;
       UCHAR Reserved2;
       UCHAR TransferBlocksMsb;
       UCHAR TransferBlocksLsb;
       UCHAR Control;
   } CDB10, *PCDB10;

   // CD Rom Audio CDBs
   struct _PAUSE_RESUME {
       UCHAR OperationCode;
       UCHAR Reserved1 : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2[6];
       UCHAR Action;
       UCHAR Control;
   } PAUSE_RESUME, *PPAUSE_RESUME;

   // Read Table of Contents
   struct _READ_TOC {
       UCHAR OperationCode;
       UCHAR Reserved0 : 1;
       UCHAR Msf : 1;
       UCHAR Reserved1 : 3;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2[4];
       UCHAR StartingTrack;
       UCHAR AllocationLength[2];
       UCHAR Control : 6;
       UCHAR Format : 2;
   } READ_TOC, *PREAD_TOC;

   struct _PLAY_AUDIO_MSF {
       UCHAR OperationCode;
       UCHAR Reserved1 : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2;
       UCHAR StartingM;
       UCHAR StartingS;
       UCHAR StartingF;
       UCHAR EndingM;
       UCHAR EndingS;
       UCHAR EndingF;
       UCHAR Control;
   } PLAY_AUDIO_MSF, *PPLAY_AUDIO_MSF;

  // Read SubChannel Data
   struct _SUBCHANNEL {
       UCHAR OperationCode;
       UCHAR Reserved0 : 1;
       UCHAR Msf : 1;
       UCHAR Reserved1 : 3;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2 : 6;
       UCHAR SubQ : 1;
       UCHAR Reserved3 : 1;
       UCHAR Format;
       UCHAR Reserved4[2];
       UCHAR TrackNumber;
       UCHAR AllocationLength[2];
       UCHAR Control;
   } SUBCHANNEL, *PSUBCHANNEL;

   // Mode sense
   struct _MODE_SENSE6 {
       UCHAR OperationCode;
       UCHAR Reserved1 : 3;
       UCHAR Dbd : 1;
       UCHAR Reserved2 : 1;
       UCHAR LogicalUnitNumber : 3;
       UCHAR PageCode : 6;
       UCHAR Pc : 2;
       UCHAR Reserved3;
       UCHAR AllocationLength;
       UCHAR Control;
   } MODE_SENSE6, *PMODE_SENSE6;

   struct _MODE_SENSE10 {
       UCHAR OperationCode;
       UCHAR Reserved1 : 3;
       UCHAR Dbd : 1;
       UCHAR Reserved2 : 1;
       UCHAR LogicalUnitNumber : 3;
       UCHAR PageCode : 6;
       UCHAR Pc : 2;
       UCHAR Reserved3;
       UCHAR Reserved4;
       UCHAR Reserved5;
       UCHAR Reserved6;
       UCHAR AllocationLength[2];
       UCHAR Control;
   } MODE_SENSE10, *PMODE_SENSE10;

   // Mode select
   struct _MODE_SELECT {
       UCHAR OperationCode;
       UCHAR SPBit : 1;
       UCHAR Reserved1 : 3;
       UCHAR PFBit : 1;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2[2];
       UCHAR ParameterListLength;
       UCHAR Control;
   } MODE_SELECT, *PMODE_SELECT;
  struct _LOCATE {
       UCHAR OperationCode;
       UCHAR Immediate : 1;
       UCHAR CPBit : 1;
       UCHAR BTBit : 1;
       UCHAR Reserved1 : 2;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved3;
       UCHAR LogicalBlockAddress[4];
       UCHAR Reserved4;
       UCHAR Partition;
       UCHAR Control;
   } LOCATE, *PLOCATE;

   struct _LOGSENSE {
       UCHAR OperationCode;
       UCHAR SPBit : 1;
       UCHAR PPCBit : 1;
       UCHAR Reserved1 : 3;
       UCHAR LogicalUnitNumber : 3;
       UCHAR PageCode : 6;
       UCHAR PCBit : 2;
       UCHAR Reserved2;
       UCHAR Reserved3;
       UCHAR ParameterPointer[2];  // [0]=MSB, [1]=LSB
       UCHAR AllocationLength[2];  // [0]=MSB, [1]=LSB
       UCHAR Control;
   } LOGSENSE, *PLOGSENSE;

   struct _PRINT {
       UCHAR OperationCode;
       UCHAR Reserved : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR TransferLength[3];
       UCHAR Control;
   } PRINT, *PPRINT;

   struct _SEEK {
       UCHAR OperationCode;
       UCHAR Reserved1 : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR LogicalBlockAddress[4];
       UCHAR Reserved2[3];
       UCHAR Control;
   } SEEK, *PSEEK;

   struct _ERASE {
       UCHAR OperationCode;
       UCHAR Long : 1;
       UCHAR Immediate : 1;
       UCHAR Reserved1 : 3;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2[3];
       UCHAR Control;
   } ERASE, *PERASE;
  struct _START_STOP {
       UCHAR OperationCode;
       UCHAR Immediate: 1;
       UCHAR Reserved1 : 4;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2[2];
       UCHAR Start : 1;
       UCHAR LoadEject : 1;
       UCHAR Reserved3 : 6;
       UCHAR Control;
   } START_STOP, *PSTART_STOP;

   struct _MEDIA_REMOVAL {
       UCHAR OperationCode;
       UCHAR Reserved1 : 5;
       UCHAR LogicalUnitNumber : 3;
       UCHAR Reserved2[2];
       UCHAR Prevent;
       UCHAR Control;
   } MEDIA_REMOVAL, *PMEDIA_REMOVAL;

   // Tape CDBs
   struct _SEEK_BLOCK {
       UCHAR OperationCode;
       UCHAR Immediate : 1;
       UCHAR Reserved1 : 7;
       UCHAR BlockAddress[3];
       UCHAR Link : 1;
       UCHAR Flag : 1;
       UCHAR Reserved2 : 4;
       UCHAR VendorUnique : 2;
   } SEEK_BLOCK, *PSEEK_BLOCK;

   struct _REQUEST_BLOCK_ADDRESS {
       UCHAR OperationCode;
       UCHAR Reserved1[3];
       UCHAR AllocationLength;
       UCHAR Link : 1;
       UCHAR Flag : 1;
       UCHAR Reserved2 : 4;
       UCHAR VendorUnique : 2;
   } REQUEST_BLOCK_ADDRESS, *PREQUEST_BLOCK_ADDRESS;

   struct _PARTITION {
       UCHAR OperationCode;
       UCHAR Immediate : 1;
       UCHAR Sel: 1;
       UCHAR PartitionSelect : 6;
       UCHAR Reserved1[3];
       UCHAR Control;
   } PARTITION, *PPARTITION;
   struct _WRITE_TAPE_MARKS {
       UCHAR OperationCode;
       UCHAR Immediate : 1;
       UCHAR WriteSetMarks: 1;
       UCHAR Reserved : 3;
       UCHAR LogicalUnitNumber : 3;
       UCHAR TransferLength[3];
       UCHAR Control;
   } WRITE_TAPE_MARKS, *PWRITE_TAPE_MARKS;

   struct _SPACE_TAPE_MARKS {
       UCHAR OperationCode;
       UCHAR Code : 3;
       UCHAR Reserved : 2;
       UCHAR LogicalUnitNumber : 3;
       UCHAR NumMarksMSB ;
       UCHAR NumMarks;
       UCHAR NumMarksLSB;
       union {
           UCHAR value;
           struct {
               UCHAR Link : 1;
               UCHAR Flag : 1;
               UCHAR Reserved : 4;
               UCHAR VendorUnique : 2;
           } Fields;
       } Byte6;
   } SPACE_TAPE_MARKS, *PSPACE_TAPE_MARKS;

   // Read tape position
   struct _READ_POSITION {
       UCHAR Operation;
       UCHAR BlockType:1;
       UCHAR Reserved1:4;
       UCHAR Lun:3;
       UCHAR Reserved2[7];
       UCHAR Control;
   } READ_POSITION, *PREAD_POSITION;

   // ReadWrite for Tape
   struct _CDB6READWRITETAPE {
       UCHAR OperationCode;
       UCHAR VendorSpecific : 5;
       UCHAR Reserved : 3;
       UCHAR TransferLenMSB;
       UCHAR TransferLen;
       UCHAR TransferLenLSB;
       UCHAR Link : 1;
       UCHAR Flag : 1;
       UCHAR Reserved1 : 4;
       UCHAR VendorUnique : 2;
    } CDB6READWRITETAPE, *PCDB6READWRITETAPE;
   struct _READELEMENTSTATUS {
       UCHAR OperationCode;
       UCHAR ElementTypeCode : 4;
       UCHAR Voltag: 1;
       UCHAR Reserved : 3;
       UCHAR StartElemAddrMSB;
       UCHAR StartElemAddrLSB;
       UCHAR NumElementsMSB;
       UCHAR NumElementsLSB;
       UCHAR Reserved1;
       UCHAR AllocationLenMSB;
       UCHAR AllocationLen;
       UCHAR AllocationLenLSB;
       UCHAR Reserved2;
       UCHAR ControlByte;
    } READELEMENTSTATUS, *PREADELEMENTSTATUS;

} CDB, *PCDB;



typedef struct {
   __i8 bPeripheralType;            // Peripheral device type
   __i8 bRmb;                       // RMB
   __i8 bVersions;                  // ISO, ECMA and ANSI versions
   __i8 bMisc;                      // AENC, TrmIOP, and Rsp Data Format
   __i8 bAdditionalLength;          // Additional length
   __i8 bReserved[2];               // Reserved bytes
   __i8 bSupportBits;               // Support bits
   __i8 bVendorId[8];               // Vendor Id (COMPAQ)
   __i8 bProductId[16];             // Product Id
   __i8 bProductRevision[4];        // Product revision level (firmware)
} BUS_INQUIRY_DATA, *PBUS_INQUIRY_DATA;






struct SspCommands
{
	char *CommandName;
	char *String;
	int stringSize;
	unsigned long flags;
	unsigned char commandFIS[20];
};


struct StpCommands
{
	char *CommandName;
	char *String;
	int stringSize;
	unsigned long flags;
	unsigned char commandFIS[20];
};


/* Moved this from csmitest.c on Aug 22nd */



#define WINDOWS 1
#define LINUX 2
#define NETWARE 3

#ifdef _linux 
	
	#define TEMP_FILE_NAME		"/tmp/csmi_test.txt"
	#define sysprint			if(no_print == 0) system("cat /tmp/csmi_test.txt")

#endif


#ifdef _WIN32

	#define TEMP_FILE_NAME		temp_file_path
	#define sysprint			if(no_print == 0) system(type_command_string)

#endif


#ifdef _NETWARE
	#define TEMP_FILE_NAME		"csmi_test.txt"
	#define sysprint			if(no_print == 0) system("more csmi_test.txt")

// NETWARE : Global Variable like the Handle/File descriptor whichever is applicable
#endif

/* Added this on Aug 22nd to avoid printing to a file if fp is NULL
 * It will be used instead of fprintf only when printing to a file 
 * specified by the user using -f option
 */

#define print_to_file if(fp) fprintf
