#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include "csmisas.h"
#include "misc.h"


extern FILE *fp;
extern FILE *tempo;
extern int no_print;
extern int ostype;
extern int fd;


#ifdef _WIN32
	extern HANDLE handle;
	extern char temp_file_path[];
	extern char type_command_string[];
#else
	extern int handle;
#endif


//extern int counter;

//#define fprintf if(fileOpen) fprintf



#define printf if(no_print == 0) printf
//#define sysprint if(no_print == 0) system("more /tmp/csmi_temp.txt");
//#define printf counter++; if(counter > 30) { puts("\nPress a key...\n"); getc(stdin); getc(stdin); counter = 0; clearScreen(); }  if(no_print == 0) printf






void DisplayTitle(int ostype,int TOOL_MAJOR_VERSION, int TOOL_MINOR_VERSION, int TOOL_RELEASE_NUMBER,int CSMI_VERSION_MAJ,int CSMI_VERSION_MIN)
{
/*	if(ostype == WINDOWS)
	{
		printf("\n"
		"\t\t\t Common Serial Attached SCSI Management IOCTL Test for Windows \n"
		"Version %2d.%02d-%02d \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
		print_to_file(fp,"\n"
		"\t\t\t Common Serial Attached SCSI Management IOCTL Test for Windows \n"
		"Version %2d.%02d-%02d \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
	}

	if(ostype == LINUX)
	{
		printf("\n"
		"\t\t\t Common Serial Attached SCSI Management IOCTL Test for Linux \n"
		"Version %2d.%02d-%02d \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
		print_to_file(fp,"\n"
		"\t\t\t Common Serial Attached SCSI Management IOCTL Test for Linux \n"
		"Version %2d.%02d-%02d \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
	}

	if(ostype == NETWARE)
	{
		printf("\n"
		"\t\t\t Common Serial Attached SCSI Management IOCTL Test for Netware \n"
		"Version %2d.%02d-%02d \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
		print_to_file(fp,"\n"
		"\t\t\t Common Serial Attached SCSI Management IOCTL Test for Netware \n"
		"Version %2d.%02d-%02d \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
	} */

/* Chaged as per demo point suggestions */

	if(ostype == WINDOWS)
	{
		printf("\n"
		"\t\t\t CSMI Test Tool for Windows Version  %2d.%02d-%02d  \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
		print_to_file(fp,"\n"
		"\t\t\t CSMI Test Tool for Windows Version  %2d.%02d-%02d  \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);

		printf("\n"
		"\t\t\t     Supporting CSMI Spec version  %2d.%02d  \n",CSMI_VERSION_MAJ,CSMI_VERSION_MIN);
		print_to_file(fp,"\n"
		"\t\t\t     Supporting CSMI Spec version  %2d.%02d  \n",CSMI_VERSION_MAJ,CSMI_VERSION_MIN);

	}

	if(ostype == LINUX)
	{
		
		printf("\n"
		"\t\t\t CSMI Test Tool for Linux Version  %2d.%02d-%02d  \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
		print_to_file(fp,"\n"
		"\t\t\t CSMI Test Tool for Linux Version  %2d.%02d-%02d  \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);

		printf("\n"
		"\t\t\t     Supporting CSMI Spec version  %2d.%02d  \n",CSMI_VERSION_MAJ,CSMI_VERSION_MIN);
		print_to_file(fp,"\n"
		"\t\t\t     Supporting CSMI Spec version  %2d.%02d  \n",CSMI_VERSION_MAJ,CSMI_VERSION_MIN);

	}

	if(ostype == NETWARE)
	{
		printf("\n"
		"\t\t\t CSMI Test Tool for NetWare Version  %2d.%02d-%02d  \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);
		print_to_file(fp,"\n"
		"\t\t\t CSMI Test Tool for NetWare Version  %2d.%02d-%02d  \n",
		TOOL_MAJOR_VERSION, TOOL_MINOR_VERSION, TOOL_RELEASE_NUMBER);

		printf("\n"
		"\t\t\t     Supporting CSMI Spec version  %2d.%02d  \n",CSMI_VERSION_MAJ,CSMI_VERSION_MIN);
		print_to_file(fp,"\n"
		"\t\t\t     Supporting CSMI Spec version  %2d.%02d  \n",CSMI_VERSION_MAJ,CSMI_VERSION_MIN);

	}




}









void PrintUsage(int ostype)
{
    if(ostype == WINDOWS)
	{
		printf("\n Tool to test the CSMI IOCTLS \n");
		printf("Usage : csmitest <options> \n");
		printf("\tIn the Options it is mandatory to have -d <device name> -c <controller no>\n");
		printf("\tOther options are optional \n");
		printf("Options are : \n");
		printf("\t-d <scsi value>  Example : -d 6 for scsi.6 \n");
		printf("\t-c <controller no> Example : -c 0 \n");
		printf("\t-f <filename> : Specify the file to dump the output. (default is output<date/time>.txt)\n");
		printf("\t-a : This option will run all the ioctls. Default mode is Manual \n");
		printf("\t-v : Print description of each ioctl (default is off) \n");
		printf("\t-h : Print the Hex Dump information before & after each ioctl (default is off)\n");
		printf("\t-help : Print this help screen \n");
	}

	if(ostype == LINUX)
	{
		printf("\n Tool to test the CSMI IOCTLS \n");
		printf("Usage : ./csmitest <options>\n");
		printf("\tOptions are : \n");
		printf("\t-d <device name> Example : -d /dev/aac \n");
		printf("\t-c <controller no> Example : -c 0   \n");
		printf("\t-f <filename> : Specify the file to dump the output. (default is output<date/time>.txt)\n");
		printf("\t-a : This option will run all the ioctls. Default mode is Manual \n");
		printf("\t-v : Print description of each ioctl (default is off) \n");
		printf("\t-h : Print the Hex Dump information before & after each ioctl (default is off)\n");
		printf("\t-help : Print this help screen \n");
		printf("\tIn the Options it is mandatory to have -d <device name> -c <controller no>\n");
		printf("\tOther options are optional. \n");
	}

	if(ostype == NETWARE)
	{
		//Help Screen
		printf("\n Tool to test the CSMI IOCTLS \n");
		printf("Usage : ./csmiTest <options>\n");
		printf("In the Options it is mandatory to have -d <device name> -c <controller no>\n");
		printf("Other options are optional \n");
		printf("Options are : \n");
		printf("-d <device name> / <device no (windows)  Example : -d aac \n");
		printf("-c <controller no> Example : -c 0   \n");
		printf("-m : This will launch the menu mode (default is menu mode) \n");
		printf("-f <filename> : Specify the file to dump the output. (default is output.txt)\n");
		printf("-a : This option will run all the ioctls \n");
		printf("-v : Print description of each ioctl (default is off) \n");
		printf("-h : Print the Hex Dump information before & after each ioctl (default is off)\n");
		printf("-help : Print this help screen \n");

	}
}



void PrintDirection(int Direction)
{
	switch(Direction){
		case CSMI_SAS_DATA_READ:
//			printf("Data Read [%d] \n",Direction);
			fprintf(tempo,"Data Read  [%d] \n",Direction);
			print_to_file(fp,"Data Read  [%d] \n",Direction);
			break;
		case CSMI_SAS_DATA_WRITE:
			//printf("Data Write [%d]  \n",Direction);
			fprintf(tempo,"Data Write [%d] \n",Direction);
			print_to_file(fp,"Data Write [%d] \n",Direction);
			break;
		default:
			//printf("Not Defined [%d] \n",Direction);
			fprintf(tempo,"Not Defined [%d] \n",Direction);
			print_to_file(fp,"Not Defined [%d] \n",Direction);
			break;
	}
}






void PrintReturnCode(int ReturnCode)
{
	switch(ReturnCode){
		case CSMI_SAS_PHY_INFO_CHANGED:
//			printf("Success [%d] \n",ReturnCode);
			print_to_file(fp,"Success [%d] \n",ReturnCode);
			fprintf(tempo,"Success [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_PHY_INFO_NOT_CHANGEABLE:
//			printf("SAS Phy Info Not Changeable [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Phy Info Not Changeable [%d] \n",ReturnCode);
			fprintf(tempo,"SAS Phy Info Not Changeable [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_LINK_RATE_OUT_OF_RANGE:
//			printf("SAS Link Rate out of range [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Link Rate out of range [%d] \n",ReturnCode);
			fprintf(tempo,"SAS Link Rate out of range [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_PHY_DOES_NOT_EXIST:
//			printf("SAS Phy Does not exist [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Phy Does not exist [%d] \n",ReturnCode);
			fprintf(tempo,"SAS Phy Does not exist [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_PHY_DOES_NOT_MATCH_PORT:
//			printf("SAS Phy does not match port [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Phy does not match port [%d] \n",ReturnCode);
			fprintf(tempo,"SAS Phy does not match port [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_PHY_CANNOT_BE_SELECTED:
//			printf("SAS Phy cannot be selected [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Phy cannot be selected [%d] \n",ReturnCode);
			fprintf(tempo,"SAS Phy cannot be selected [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_SELECT_PHY_OR_PORT:
//			printf("Select SAS Phy or port [%d] \n",ReturnCode);
			print_to_file(fp,"Select SAS Phy or port [%d] \n",ReturnCode);
			fprintf(tempo,"Select SAS Phy or port [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_PORT_DOES_NOT_EXIST:
//			printf("SAS Port does not exist [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Port does not exist [%d] \n",ReturnCode);
			fprintf(tempo,"SAS Port does not exist [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_PORT_CANNOT_BE_SELECTED:
//			printf("SAS Port cannot be selected [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Port cannot be selected  [%d]\n",ReturnCode);
			fprintf(tempo,"SAS Port cannot be selected  [%d]\n",ReturnCode);
			break;
		case CSMI_SAS_CONNECTION_FAILED:
//			printf("SAS Connection failed [%d] \n",ReturnCode);
			print_to_file(fp,"SAS Connection failed [%d] \n",ReturnCode);
			fprintf(tempo,"SAS Connection failed [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_NO_SATA_DEVICE:
//			printf("No SATA Device [%d] \n",ReturnCode);
			print_to_file(fp,"No SATA Device [%d] \n",ReturnCode);
			fprintf(tempo,"No SATA Device [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_NO_SATA_SIGNATURE:
//			printf("No SATA Signature [%d] \n",ReturnCode);
			print_to_file(fp,"No SATA Signature [%d] \n",ReturnCode);
			fprintf(tempo,"No SATA Signature [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_SCSI_EMULATION:
//			printf("SCSI Emulation [%d] \n",ReturnCode);
			print_to_file(fp,"SCSI Emulation [%d] \n",ReturnCode);
			fprintf(tempo,"SCSI Emulation [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_NOT_AN_END_DEVICE:
//			printf("Not an end device [%d] \n",ReturnCode);
			print_to_file(fp,"Not an end device [%d] \n",ReturnCode);
			fprintf(tempo,"Not an end device [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_NO_SCSI_ADDRESS:
//			printf("No SCSI Address [%d] \n",ReturnCode);
			print_to_file(fp,"No SCSI Address [%d] \n",ReturnCode);
			fprintf(tempo,"No SCSI Address [%d] \n",ReturnCode);
			break;
		case CSMI_SAS_NO_DEVICE_ADDRESS:
//			printf("No device address [%d] \n",ReturnCode);
			print_to_file(fp,"No device address [%d] \n",ReturnCode);
			fprintf(tempo,"No device address [%d] \n",ReturnCode);
			break;
		default:
//			printf("Not Defined [%d] \n",ReturnCode);
			print_to_file(fp,"Not Defined [%d] \n",ReturnCode);
			fprintf(tempo,"Not Defined [%d] \n",ReturnCode);
			break;


	}
}

void PrintRaidType(unsigned char bRaidType)
{
	switch(bRaidType){
		case CSMI_SAS_RAID_TYPE_NONE:
			//printf("Raid set is composed of a single drive [%d] \n",bRaidType);
			print_to_file(fp,"Raid set is composed of a single drive [%d] \n",bRaidType);
			fprintf(tempo,"Raid set is composed of a single drive [%d] \n",bRaidType);
			break;
		case CSMI_SAS_RAID_TYPE_0:
			//printf("No Fault Tolerance [%d] \n",bRaidType);
			print_to_file(fp,"No Fault Tolerance [%d] \n",bRaidType);
			fprintf(tempo,"No Fault Tolerance [%d] \n",bRaidType);
			break;
		case CSMI_SAS_RAID_TYPE_1:
			//printf("RAID 1. Mirrored Set. [%d] \n",bRaidType);
			print_to_file(fp,"RAID 1. Mirrored Set. [%d] \n",bRaidType);
			fprintf(tempo,"RAID 1. Mirrored Set. [%d] \n",bRaidType);
			break;
		case CSMI_SAS_RAID_TYPE_10:
			//printf("RAID 1+0. Striped Mirrored Set. [%d] \n",bRaidType);
			print_to_file(fp,"RAID 1+0. Striped Mirrored Set. [%d] \n",bRaidType);
			fprintf(tempo,"RAID 1+0. Striped Mirrored Set. [%d] \n",bRaidType);
			break;
		case CSMI_SAS_RAID_TYPE_5:
			//printf("RAID 5. Parity Set. [%d] \n",bRaidType);
			print_to_file(fp,"RAID 5. Parity Set. [%d] \n",bRaidType);
			fprintf(tempo,"RAID 5. Parity Set. [%d] \n",bRaidType);
			break;
		case CSMI_SAS_RAID_TYPE_15:
			//printf("Advanced Parity Set. [%d] \n",bRaidType);
			print_to_file(fp,"Advanced Parity Set. [%d] \n",bRaidType);
			fprintf(tempo,"Advanced Parity Set. [%d] \n",bRaidType);
			break;
		case CSMI_SAS_RAID_TYPE_OTHER:
			//printf("Non-Standard RAID type.[%d] \n",bRaidType);
			print_to_file(fp,"Non-Standard RAID type. [%d] \n",bRaidType);
			fprintf(tempo,"Non-Standard RAID type. [%d] \n",bRaidType);
			break;
		default:
			//printf("Undefined: Invalid RAID type. [%d] \n",bRaidType);
			print_to_file(fp,"Undefined: Invalid RAID type. [%d] \n",bRaidType);
			fprintf(tempo,"Undefined: Invalid RAID type. [%d] \n",bRaidType);
			break;
	}
}

void PrintRaidStatus(unsigned char bStatus)
{
	switch(bStatus){
		case CSMI_SAS_RAID_SET_STATUS_OK:
			//printf("OK. [%d] \n",bStatus);
			print_to_file(fp,"OK. [%d] \n",bStatus);
			fprintf(tempo,"OK. [%d] \n",bStatus);
			break;
		case CSMI_SAS_RAID_SET_STATUS_DEGRADED:
			//printf("Degraded. [%d] \n",bStatus);
			print_to_file(fp,"Degraded. [%d] \n",bStatus);
			fprintf(tempo,"Degraded. [%d] \n",bStatus);
			break;
		case CSMI_SAS_RAID_SET_STATUS_REBUILDING:
			//printf("Rebuilding. [%d] \n",bStatus);
			print_to_file(fp,"Rebuilding. [%d] \n",bStatus);
			fprintf(tempo,"Rebuilding. [%d] \n",bStatus);
			break;
		case CSMI_SAS_RAID_SET_STATUS_FAILED:
			//printf("Failed. [%d] \n",bStatus);
			print_to_file(fp,"Failed. [%d] \n",bStatus);
			fprintf(tempo,"Failed. [%d] \n",bStatus);
			break;
		default:
			//printf("Undefined: Invalid RAID Status. [%d] \n",bStatus);
			print_to_file(fp,"Undefined: Invalid RAID Status. [%d] \n",bStatus);
			fprintf(tempo,"Undefined: Invalid RAID Status. [%d] \n",bStatus);
			break;
	}
}

void PrintRaidStatusMoreInfo(unsigned char bStatus, unsigned char bInfo)
{
	switch(bStatus){
		case CSMI_SAS_RAID_SET_STATUS_OK:
			//printf("%d (No Info)\n", bInfo);
			print_to_file(fp,"%d (No Info)\n", bInfo);
			fprintf(tempo,"%d (No Info)\n", bInfo);
			break;
		case CSMI_SAS_RAID_SET_STATUS_DEGRADED:
			//printf("Drive #%d Failed.\n", bInfo);
			print_to_file(fp,"Drive #%d Failed.\n", bInfo);
			fprintf(tempo,"Drive #%d Failed.\n", bInfo);
			break;
		case CSMI_SAS_RAID_SET_STATUS_REBUILDING:
			//printf("%d rebuild complete.\n", bInfo);
			print_to_file(fp,"%d rebuild complete.\n", bInfo);
			fprintf(tempo,"%d rebuild complete.\n", bInfo);
			break;
		case CSMI_SAS_RAID_SET_STATUS_FAILED:
			//printf("%d (Vendor specific)\n", bInfo);
			print_to_file(fp,"%d (Vendor specific)\n", bInfo);
			fprintf(tempo,"%d (Vendor specific)\n", bInfo);
			break;
		default:
			//printf("Undefined. [%d] \n",bInfo);
			print_to_file(fp,"Undefined. [%d] \n",bInfo);
			fprintf(tempo,"Undefined. [%d] \n",bInfo);
			break;
	}
}

void PrintDriveStatus(unsigned char bDriveStatus)
{
	switch(bDriveStatus){
		case CSMI_SAS_DRIVE_STATUS_OK:
			//printf("OK. [%d] \n",bDriveStatus);
			print_to_file(fp,"OK. [%d] \n",bDriveStatus);
			fprintf(tempo,"OK. [%d] \n",bDriveStatus);
			break;
		case CSMI_SAS_DRIVE_STATUS_REBUILDING:
			//printf("Rebuilding. [%d] \n",bDriveStatus);
			print_to_file(fp,"Rebuilding. [%d] \n",bDriveStatus);
			fprintf(tempo,"Rebuilding. [%d] \n",bDriveStatus);
			break;
		case CSMI_SAS_DRIVE_STATUS_FAILED:
			//printf("Failed. [%d] \n",bDriveStatus);
			print_to_file(fp,"Failed. [%d] \n",bDriveStatus);
			fprintf(tempo,"Failed. [%d] \n",bDriveStatus);
			break;
		case CSMI_SAS_DRIVE_STATUS_DEGRADED:
			//printf("Degraded. [%d] \n",bDriveStatus);
			print_to_file(fp,"Degraded. [%d] \n",bDriveStatus);
			fprintf(tempo,"Degraded. [%d] \n",bDriveStatus);
			break;
		default:
			//printf("Undefined. [%d] \n",bDriveStatus);
			print_to_file(fp,"Undefined. [%d] \n",bDriveStatus);
			fprintf(tempo,"Undefined. [%d] \n",bDriveStatus);
			break;
	}
}

void PrintDriveUsage(unsigned char bDriveUsage)
{
	switch(bDriveUsage){
		case CSMI_SAS_DRIVE_CONFIG_NOT_USED:
			//printf("Unconfigured. [%d] \n",bDriveUsage);
			print_to_file(fp,"Unconfigured. [%d] \n",bDriveUsage);
			fprintf(tempo,"Unconfigured. [%d] \n",bDriveUsage);
			break;
		case CSMI_SAS_DRIVE_CONFIG_MEMBER:
			//printf("Part of this RAID set. [%d] \n",bDriveUsage);
			print_to_file(fp,"Part of this RAID set. [%d] \n",bDriveUsage);
			print_to_file(tempo,"Part of this RAID set. [%d] \n",bDriveUsage);
			break;
		case CSMI_SAS_DRIVE_CONFIG_SPARE:
			//printf("Hot swap spare of this RAID set. [%d] \n",bDriveUsage);
			print_to_file(fp,"Hot swap spare of this RAID set. [%d] \n",bDriveUsage);
			fprintf(tempo,"Hot swap spare of this RAID set. [%d] \n",bDriveUsage);
			break;
		default:
			//printf("Undefined. [%d] \n",bDriveUsage);
			print_to_file(fp,"Undefined. [%d] \n",bDriveUsage);
			fprintf(tempo,"Undefined. [%d] \n",bDriveUsage);
			break;
	}
}

void PrintProtocol(unsigned char bProtocol)
{

	if(bProtocol & CSMI_SAS_PROTOCOL_SATA)
	{
		//printf("SATA Protocol [%d]  ",bProtocol);
		print_to_file(fp,"SATA Protocol [%d]  ",bProtocol);
		fprintf(tempo,"SATA Protocol [%d]  ",bProtocol);
	}

	if(bProtocol & CSMI_SAS_PROTOCOL_SMP)
	{
		//printf("SMP Protocol [%d]  ",bProtocol);
		print_to_file(fp,"SMP Protocol [%d]  ",bProtocol);
		fprintf(tempo,"SMP Protocol [%d]  ",bProtocol);
	}

	if(bProtocol & CSMI_SAS_PROTOCOL_STP)
	{
		//printf("STP Protocol [%d]  ",bProtocol);
		print_to_file(fp,"STP Protocol [%d]  ",bProtocol);
		fprintf(tempo,"STP Protocol [%d]  ",bProtocol);
	}

	if(bProtocol & CSMI_SAS_PROTOCOL_SSP)
	{
		//printf("SSP Protocol [%d]  ",bProtocol);
		print_to_file(fp,"SSP Protocol [%d]  ",bProtocol);
		fprintf(tempo,"SSP Protocol [%d]  ",bProtocol);
	}

	if(bProtocol == 0)
	{
	    //printf("Undefined [%d]  ",bProtocol);
		print_to_file(fp,"Undefined [%d]  ",bProtocol);
		fprintf(tempo,"Undefined [%d]  ",bProtocol);
	}

	//printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");

}

void PrintLinkRate(unsigned char bLinkRate)
{
	switch(bLinkRate){
		case CSMI_SAS_LINK_RATE_UNKNOWN:
		// Same value as above CSMI_SAS_PROGRAMMED_LINK_RATE_UNCHANGED:
			//printf("Unchanged / Not Connected / Link Rate does not apply. [%d] \n",bLinkRate);
			print_to_file(fp,"Unchanged / Not Connected / Link Rate does not apply. [%d] \n",bLinkRate);
			fprintf(tempo,"Unchanged / Not Connected / Link Rate does not apply. [%d] \n",bLinkRate);
			break;
		case CSMI_SAS_PHY_DISABLED:
			//printf("Phy disabled. [%d] \n",bLinkRate);
			print_to_file(fp,"Phy disabled. [%d] \n",bLinkRate);
			fprintf(tempo,"Phy disabled. [%d] \n",bLinkRate);
			break;
		case CSMI_SAS_LINK_RATE_FAILED:
			//printf("Link Rate Failed. [%d] \n",bLinkRate);
			print_to_file(fp,"Link Rate Failed. [%d] \n",bLinkRate);
			fprintf(tempo,"Link Rate Failed. [%d] \n",bLinkRate);
			break;
		case CSMI_SAS_SATA_SPINUP_HOLD:
			//printf("Link detected, but in a wait state to release spin-up hold. [%d] \n",bLinkRate);
			print_to_file(fp,"Link detected, but in a wait state to release spin-up hold. [%d] \n",bLinkRate);
			fprintf(tempo,"Link detected, but in a wait state to release spin-up hold. [%d] \n",bLinkRate);
			break;
		case CSMI_SAS_LINK_RATE_1_5_GBPS:
		// Same vale as above CSMI_SAS_PROGRAMMED_LINK_RATE_1_5_GBPS:
			//printf("1.5 Gb/s. [%d] \n",bLinkRate);
			print_to_file(fp,"1.5 Gb/s. [%d] \n",bLinkRate);
			fprintf(tempo,"1.5 Gb/s. [%d] \n",bLinkRate);
			break;
		case CSMI_SAS_LINK_RATE_3_0_GBPS:
		// Same value as above CSMI_SAS_PROGRAMMED_LINK_RATE_3_0_GBPS:
			//printf("3.0 Gb/s. [%d] \n",bLinkRate);
			print_to_file(fp,"3.0 Gb/s. [%d] \n",bLinkRate);
			fprintf(tempo,"3.0 Gb/s. [%d] \n",bLinkRate);
			break;
		default:
			//printf("Undefined [%d] \n",bLinkRate);
			print_to_file(fp,"Undefined [%d] \n",bLinkRate);
			fprintf(tempo,"Undefined [%d] \n",bLinkRate);
			break;
	}
}

void PrintAutoDiscoverState(unsigned char bAutoDiscover)
{
	switch(bAutoDiscover){
		case CSMI_SAS_DISCOVER_NOT_SUPPORTED:
			//printf("Not Supported. [%d] \n",bAutoDiscover);
			print_to_file(fp,"Not Supported. [%d] \n",bAutoDiscover);
			fprintf(tempo,"Not Supported. [%d] \n",bAutoDiscover);
			break;
		case CSMI_SAS_DISCOVER_NOT_STARTED:
			//printf("Not Started. [%d] \n",bAutoDiscover);
			print_to_file(fp,"Not Started. [%d] \n",bAutoDiscover);
			fprintf(tempo,"Not Started. [%d] \n",bAutoDiscover);
			break;
		case CSMI_SAS_DISCOVER_IN_PROGRESS:
			//printf("In Progress. [%d] \n",bAutoDiscover);
			print_to_file(fp,"In Progress. [%d] \n",bAutoDiscover);
			fprintf(tempo,"In Progress. [%d] \n",bAutoDiscover);
			break;
		case CSMI_SAS_DISCOVER_COMPLETE:
			//printf("Complete. [%d] \n",bAutoDiscover);
			print_to_file(fp,"Complete. [%d] \n",bAutoDiscover);
			fprintf(tempo,"Complete. [%d] \n",bAutoDiscover);
			break;
		case CSMI_SAS_DISCOVER_ERROR:
			//printf("Error. [%d] \n",bAutoDiscover);
			print_to_file(fp,"Error. [%d] \n",bAutoDiscover);
			fprintf(tempo,"Error. [%d] \n",bAutoDiscover);
			break;
		default:
			//printf("Undefined [%d] \n",bAutoDiscover);
			print_to_file(fp,"Undefined [%d] \n",bAutoDiscover);
			fprintf(tempo,"Undefined [%d] \n",bAutoDiscover);
			break;
	}
}

void DisplayIoctlHeader(IOCTL_HEADER Hdr)
{

//	printf("\tIOCTL Header\n");
//	printf("\t------------\n");
//	printf("\tLength\t\t: %d \n", Hdr.Length);
//	printf("\tTimeout\t\t: %d \n", Hdr.Timeout);

	print_to_file(fp,"\tIOCTL Header\n");
	print_to_file(fp,"\t------------\n");
	print_to_file(fp,"\tLength\t\t: %d \n", Hdr.Length);
	print_to_file(fp,"\tTimeout\t\t: %d \n", Hdr.Timeout);


	fprintf(tempo,"\tIOCTL Header\n");
	fprintf(tempo,"\t------------\n");
	fprintf(tempo,"\tLength\t\t: %d \n", Hdr.Length);
	fprintf(tempo,"\tTimeout\t\t: %d \n", Hdr.Timeout);



/* WinCompat */
#ifdef _linux
//	printf("\tDirection\t: ");
	print_to_file(fp,"\tDirection\t: ");
	fprintf(tempo,"\tDirection\t: ");
	PrintDirection(Hdr.Direction);
#endif


#ifdef _NETWARE
	/* NETWARE : Any other Print routines for the Netware Header to be included here */
#endif

//	printf("\tReturn Code\t: ");
	fprintf(tempo,"\tReturn Code\t: ");
	print_to_file(fp,"\tReturn Code\t: ");
	PrintReturnCode(Hdr.ReturnCode);
//	printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");
}




void DisplayTaskManagement(CSMI_SAS_SSP_PASSTHRU_STATUS status)
{
/*	printf("\tConnection Status\t: %d\n", status.bConnectionStatus);
	printf("\tData Present\t\t: %d\n", status.bDataPresent);
	printf("\tSCSI Status Code\t: %d\n", status.bStatus);
	printf("\tResponse Length\t: %d %d\n", status.bResponseLength[0], status.bResponseLength[1]); */
	print_to_file(fp,"\tConnection Status\t: %d\n", status.bConnectionStatus);
	print_to_file(fp,"\tData Present\t\t: %d\n", status.bDataPresent);
	print_to_file(fp,"\tSCSI Status Code\t: %d\n", status.bStatus);
	print_to_file(fp,"\tResponse Length\t: %d %d\n", status.bResponseLength[0], status.bResponseLength[1]);


	fprintf(tempo,"\tConnection Status\t: %d\n", status.bConnectionStatus);
	fprintf(tempo,"\tData Present\t\t: %d\n", status.bDataPresent);
	fprintf(tempo,"\tSCSI Status Code\t: %d\n", status.bStatus);
	fprintf(tempo,"\tResponse Length\t: %d %d\n", status.bResponseLength[0], status.bResponseLength[1]);


}




void DisplayFirmwareDownload(CSMI_SAS_FIRMWARE_DOWNLOAD Info)
{
/*	printf("\tFirmwareDownload\n");
	printf("\t----------------\n");
	printf("\tBufferLength\t\t: %d \n", Info.uBufferLength);
	printf("\tDownloadFlags\t\t: %d \n", Info.uDownloadFlags);
	printf("\tStatus\t\t: %d \n", Info.usStatus);
	printf("\tSeverity\t\t: %d \n", Info.usSeverity);
	printf("\n"); */

	print_to_file(fp,"\tFirmwareDownload\n");
	print_to_file(fp,"\t----------------\n");
	print_to_file(fp,"\tBufferLength\t\t: %d \n", Info.uBufferLength);
	print_to_file(fp,"\tDownloadFlags\t\t: %d \n", Info.uDownloadFlags);
	print_to_file(fp,"\tStatus\t\t: %d \n", Info.usStatus);
	print_to_file(fp,"\tSeverity\t\t: %d \n", Info.usSeverity);
	print_to_file(fp,"\n");


	fprintf(tempo,"\tFirmwareDownload\n");
	fprintf(tempo,"\t----------------\n");
	fprintf(tempo,"\tBufferLength\t\t: %d \n", Info.uBufferLength);
	fprintf(tempo,"\tDownloadFlags\t\t: %d \n", Info.uDownloadFlags);
	fprintf(tempo,"\tStatus\t\t: %d \n", Info.usStatus);
	fprintf(tempo,"\tSeverity\t\t: %d \n", Info.usSeverity);
	fprintf(tempo,"\n");


}




void PrintBefore_issue_get_driver_info(int descr)
{



//		printf("\tIOCTL : CC_CSMI_SAS_GET_DRIVER_INFO (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_DRIVER_INFO (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_DRIVER_INFO (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");





	if(descr)
	{

/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior requests descriptive and version information\n"
			" for the driver associated with a storage controller. The information returned \n"
			" should be consistent with any file information provided on the platform OS for \n "
			"the driver. Any driver that implements this specification must support this behavior.\n");


		printf("\n Name :  Name of the binary driver. Eg : aac \n");
		printf("Description : Description of the driver. Eg : Adaptec RAID Miniport Driver \n");
		printf("MajorRevision : Major revision of the driver. Eg : 4 \n");
		printf("MinorRevision : Minor revision of the driver. Eg : 2 \n");
		printf("BuildRevision : Build revision of the driver. Eg : 7350 \n");
		printf("ReleaseRevision : Release revision of the driver. Eg : 1 \n");
		printf("CSMIRevision : Revision of the CSMI specification that the driver supports.Eg:0,82\n"); */


		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior requests descriptive and version information\n"
			" for the driver associated with a storage controller. The information returned \n"
			" should be consistent with any file information provided on the platform OS for \n"
			"the driver. Any driver that implements this specification must support this behavior.\n");





		fprintf(tempo,"Name :  Name of the binary driver. Eg : aac \n");
		fprintf(tempo,"Description : Description of the driver. Eg : Adaptec RAID Miniport Driver \n");
		fprintf(tempo,"MajorRevision : Major revision of the driver. Eg : 4 \n");
		fprintf(tempo,"MinorRevision : Minor revision of the driver. Eg : 2 \n");
		fprintf(tempo,"BuildRevision : Build revision of the driver. Eg : 7350 \n");
		fprintf(tempo,"ReleaseRevision : Release revision of the driver. Eg : 1 \n");
		fprintf(tempo,"CSMIRevision : Revision of the CSMI specification that the driver supports. Eg : 0,82 \n");





		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior requests descriptive and version information\n"
			" for the driver associated with a storage controller. The information returned \n"
			" should be consistent with any file information provided on the platform OS for \n"
			"the driver. Any driver that implements this specification must support this behavior.\n");





		print_to_file(fp,"Name :  Name of the binary driver. Eg : aac \n");
		print_to_file(fp,"Description : Description of the driver. Eg : Adaptec RAID Miniport Driver \n");
		print_to_file(fp,"MajorRevision : Major revision of the driver. Eg : 4 \n");
		print_to_file(fp,"MinorRevision : Minor revision of the driver. Eg : 2 \n");
		print_to_file(fp,"BuildRevision : Build revision of the driver. Eg : 7350 \n");
		print_to_file(fp,"ReleaseRevision : Release revision of the driver. Eg : 1 \n");
		print_to_file(fp,"CSMIRevision : Revision of the CSMI specification that the driver supports. Eg : 0,82 \n");


	}


}





void PrintBefore_issue_get_ctlr_config(int descr)
{




//	printf("\tIOCTL : CC_CSMI_SAS_GET_CNTLR_CONFIG (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_CNTLR_CONFIG (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_CNTLR_CONFIG (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");




		if(descr)
	{

/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior requests descriptive and version information \n"
			   "for the hardware, firmware and boot BIOS associated with a storage controller. \n"
			   "Any driver that implements this specification must support this behavior. \n");

		printf("BaseIoAddress : Base I/O Address of the controller. Eg : 0x0 \n");
		printf("BaseMemoryAddress : Base memory address of the controller. Eg : (Low): 0xf4000000 \n");
		printf("BoardID : 32-bit subsystem ID from the controllers PCI configuration space Eg : 0x3227103c \n");
		printf("SlotNumber : The physical slot number of the controller in the system. Eg : 5 \n");
		printf("ControllerClass : Specify the class of the controller. A Constant. Eg : 5 \n");
		printf("IoBusType : System I/O bus type of the controller. Eg : 3 \n");
		printf("SerialNumber : Controller serial number. Eg : BD9F3B \n");
		printf("Revision : Major/Minor Revision of Firmware and Release Revision Eg : Build Rev : 7361 \n");
		printf("ControllerFlags : Controller sub class definition. Eg : 0x8 \n");  */


		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior requests descriptive and version information \n"
			   " for the hardware, firmware and boot BIOS associated with a storage controller. \n"
			   "\n Any driver that implements this specification must support this behavior. \n");

		print_to_file(fp,"BaseIoAddress : Base I/O Address of the controller. Eg : 0x0 \n");
		print_to_file(fp,"BaseMemoryAddress : Base memory address of the controller. Eg : (Low): 0xf4000000 \n");
		print_to_file(fp,"BoardID : 32-bit subsystem ID from the controllers PCI configuration space Eg : 0x3227103c \n");
		print_to_file(fp,"SlotNumber : The physical slot number of the controller in the system. Eg : 5 \n");
		print_to_file(fp,"ControllerClass : Specify the class of the controller. A Constant. Eg : 5 \n");
		print_to_file(fp,"IoBusType : System I/O bus type of the controller. Eg : 3 \n");
		print_to_file(fp,"SerialNumber : Controller serial number. Eg : BD9F3B \n");
		print_to_file(fp,"Revision : Major/Minor Revision of Firmware and Release Revision Eg : Build Rev : 7361 \n");
		print_to_file(fp,"ControllerFlags : Controller sub class definition. Eg : 0x8 \n");


		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior requests descriptive and version information \n"
			   " for the hardware, firmware and boot BIOS associated with a storage controller. \n"
			   "\n Any driver that implements this specification must support this behavior. \n");

		fprintf(tempo,"BaseIoAddress : Base I/O Address of the controller. Eg : 0x0 \n");
		fprintf(tempo,"BaseMemoryAddress : Base memory address of the controller. Eg : (Low): 0xf4000000 \n");
		fprintf(tempo,"BoardID : 32-bit subsystem ID from the controllers PCI configuration space Eg : 0x3227103c \n");
		fprintf(tempo,"SlotNumber : The physical slot number of the controller in the system. Eg : 5 \n");
		fprintf(tempo,"ControllerClass : Specify the class of the controller. A Constant. Eg : 5 \n");
		fprintf(tempo,"IoBusType : System I/O bus type of the controller. Eg : 3 \n");
		fprintf(tempo,"SerialNumber : Controller serial number. Eg : BD9F3B \n");
		fprintf(tempo,"Revision : Major/Minor Revision of Firmware and Release Revision Eg : Build Rev : 7361 \n");
		fprintf(tempo,"ControllerFlags : Controller sub class definition. Eg : 0x8 \n");



	}




}





void PrintBefore_issue_get_ctlr_status(int descr)
{


//	printf("\tIOCTL : CC_CSMI_SAS_GET_CNTLR_STATUS (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_CNTLR_STATUS (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_CNTLR_STATUS (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");




	if(descr)
	{

/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior requests the current status of the controller. \n"
			   "Any driver thatmplements this specification must support this behavior. \n");

		printf("Status. Current status of the controller. Eg : Good,Failed etc \n");
		printf("Reason for Offline : Reason for the controller to be Offline. Eg : No Reason, Degraded.. \n"); */


		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior requests the current status of the controller. \n"
			   "Any driver thatmplements this specification must support this behavior. \n");

		print_to_file(fp,"Status. Current status of the controller. Eg : Good,Failed etc \n");

		print_to_file(fp,"Reason for Offline : Reason for the controller to be Offline. Eg : No Reason, Degraded. \n");


		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior requests the current status of the controller. \n"
			   "Any driver thatmplements this specification must support this behavior. \n");

		fprintf(tempo,"Status. Current status of the controller. Eg : Good,Failed etc \n");

		fprintf(tempo,"Reason for Offline : Reason for the controller to be Offline. Eg : No Reason, Degraded. \n");



	}



}



void PrintBefore_issue_get_raid_info(int descr)
{
//		printf("\tIOCTL : CC_CSMI_SAS_GET_RAID_INFO (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_RAID_INFO (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_RAID_INFO (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{

/*		printf("\n 	This CSMI functional behavior requests information on the number of RAID volumes \n"
			   " and number of physical drives on a controller. The RAID solution may be implemented \n"
			   " within the driver or as firmware on the controller. \n");

		printf("\n NumRaidSets : Number of logical RAID volumes (or sets) currently defined. Eg : 2 \n");

		printf("\n MaxDrivesPerSet : Maximum number of physical drives within a logical RAID \n"
			   " volume. This may be an absolute maximum or the actual maximum currently defined for \n"
			   " all volumes.  Eg : 128 \n"); */



		print_to_file(fp,"\n 	This CSMI functional behavior requests information on the number of RAID volumes \n"
			   " and number of physical drives on a controller. The RAID solution may be implemented \n"
			   " within the driver or as firmware on the controller. \n");

		print_to_file(fp,"\n NumRaidSets : Number of logical RAID volumes (or sets) currently defined. Eg : 2 \n");

		print_to_file(fp,"\n MaxDrivesPerSet : Maximum number of physical drives within a logical RAID \n"
			   " volume. This may be an absolute maximum or the actual maximum currently defined for \n"
			   " all volumes.  Eg : 128 \n");


		fprintf(tempo,"\n 	This CSMI functional behavior requests information on the number of RAID volumes \n"
			   " and number of physical drives on a controller. The RAID solution may be implemented \n"
			   " within the driver or as firmware on the controller. \n");

		fprintf(tempo,"\n NumRaidSets : Number of logical RAID volumes (or sets) currently defined. Eg : 2 \n");

		fprintf(tempo,"\n MaxDrivesPerSet : Maximum number of physical drives within a logical RAID \n"
			   " volume. This may be an absolute maximum or the actual maximum currently defined for \n"
			   " all volumes.  Eg : 128 \n");

	}


}



void PrintBefore_issue_get_raid_config(int descr)
{

//	printf("\tIOCTL : CC_CSMI_SAS_GET_RAID_CONFIG (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_RAID_CONFIG (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_RAID_CONFIG (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");




	if(descr)
	{

/*		printf("\n SATA, SAS \n");

		printf("This CSMI functional behavior requests information for a specified RAID set on \n"
			   "a controller that supports RAID. To obtain the information for all the logical RAID sets \n"
			   "defined; this CSMI functional behavior must be called for each RAID set of the controller.\n"
			   "If the uControllerFlags in the CSMI_SAS_CNTLR_CONFIG structure indicates that the controller \n"
			   "supports RAID; then the driver that implements this specification must support this CSMI \n"
			   "functional behavior; otherwise the driver may respond to this control code with a generic \n"
			   "IO error.\n");


		printf("Capacity : Contains the capacity of the RAID set in megabytes \n"
			   "(MB = 1024 * 1024 bytes). Eg : 305172 \n");

		printf("StripSize : Contains the stripsize of the RAID set in kilobytes \n"
			   "(KB = 1024 bytes) \n");

		printf("RaidType : Contains the basic RAID type of the RAID set. Eg : 5 indicates a parity set \n");
		printf("Status : Contains the status of the RAID set. Eg : OK, Degraded ...etc \n");
		printf("Information : Contains clarifying information for bStatus results. If its 0 the bStatus = ok \n");
		printf("DriveCount :  Contains the number of drives in the RAID set. Eg : 3 \n");

		printf("Model : Contains the Drive model information Eg : Maxtor  6Y160M0 \n");
		printf("Firmware : Contains the Firmware designation. Eg : YAR5 \n");
		printf("Serial Number : Contains the Serial number of the Drive. Eg : FS4T4F \n");
		printf("SAS Address/SAS LUN : SAS Address and SAS LUN of the Physical Drive. \n");
		printf("Drive Status :  Contains the status of the physical drive. Eg : OK, DEGRADED etc \n");
		printf("Drive Usage : Contains whether the physical drive is part of the RAID set.  \n"); */



		print_to_file(fp,"\n 	This CSMI functional behavior requests information for a specified RAID set on \n"
			   "a controller that supports RAID. To obtain the information for all the logical RAID sets \n"
			   "defined; this CSMI functional behavior must be called for each RAID set of the controller.\n"
			   "If the uControllerFlags in the CSMI_SAS_CNTLR_CONFIG structure indicates that the controller \n"
			   "supports RAID; then the driver that implements this specification must support this CSMI \n"
			   "functional behavior; otherwise the driver may respond to this control code with a generic \n"
			   "IO error.\n");


		print_to_file(fp,"Capacity : Contains the capacity of the RAID set in megabytes \n"
			   "(MB = 1024 * 1024 bytes). Eg : 305172 \n");

		print_to_file(fp,"StripSize : Contains the stripsize of the RAID set in kilobytes \n"
			   "(KB = 1024 bytes) \n");

		print_to_file(fp,"RaidType : Contains the basic RAID type of the RAID set. Eg : 5 indicates a parity set \n");
		print_to_file(fp,"Status : Contains the status of the RAID set. Eg : OK, Degraded ...etc \n");
		print_to_file(fp,"Information : Contains clarifying information for bStatus results. If its 0 the bStatus = ok \n");
		print_to_file(fp,"DriveCount :  Contains the number of drives in the RAID set. Eg : 3 \n");

		print_to_file(fp,"Model : Contains the Drive model information Eg : Maxtor  6Y160M0 \n");
		print_to_file(fp,"Firmware : Contains the Firmware designation. Eg : YAR5 \n");
		print_to_file(fp,"Serial Number : Contains the Serial number of the Drive. Eg : FS4T4F \n");
		print_to_file(fp,"SAS Address/SAS LUN : SAS Address and SAS LUN of the Physical Drive. \n");
		print_to_file(fp,"Drive Status :  Contains the status of the physical drive. Eg : OK, DEGRADED etc \n");
		print_to_file(fp,"Drive Usage : Contains whether the physical drive is part of the RAID set.  \n");


		fprintf(tempo,"\n 	This CSMI functional behavior requests information for a specified RAID set on \n"
			   "a controller that supports RAID. To obtain the information for all the logical RAID sets \n"
			   "defined; this CSMI functional behavior must be called for each RAID set of the controller.\n"
			   "If the uControllerFlags in the CSMI_SAS_CNTLR_CONFIG structure indicates that the controller \n"
			   "supports RAID; then the driver that implements this specification must support this CSMI \n"
			   "functional behavior; otherwise the driver may respond to this control code with a generic \n"
			   "IO error.\n");


		fprintf(tempo,"Capacity : Contains the capacity of the RAID set in megabytes \n"
			   "(MB = 1024 * 1024 bytes). Eg : 305172 \n");

		fprintf(tempo,"StripSize : Contains the stripsize of the RAID set in kilobytes \n"
			   "(KB = 1024 bytes) \n");

		fprintf(tempo,"RaidType : Contains the basic RAID type of the RAID set. Eg : 5 indicates a parity set \n");
		fprintf(tempo,"Status : Contains the status of the RAID set. Eg : OK, Degraded ...etc \n");
		fprintf(tempo,"Information : Contains clarifying information for bStatus results. If its 0 the bStatus = ok \n");
		fprintf(tempo,"DriveCount :  Contains the number of drives in the RAID set. Eg : 3 \n");

		fprintf(tempo,"Model : Contains the Drive model information Eg : Maxtor  6Y160M0 \n");
		fprintf(tempo,"Firmware : Contains the Firmware designation. Eg : YAR5 \n");
		fprintf(tempo,"Serial Number : Contains the Serial number of the Drive. Eg : FS4T4F \n");
		fprintf(tempo,"SAS Address/SAS LUN : SAS Address and SAS LUN of the Physical Drive. \n");
		fprintf(tempo,"Drive Status :  Contains the status of the physical drive. Eg : OK, DEGRADED etc \n");
		fprintf(tempo,"Drive Usage : Contains whether the physical drive is part of the RAID set.  \n");

	}


}



void PrintBefore_issue_get_phy_info(int descr)
{

//		printf("\tIOCTL : CC_CSMI_SAS_GET_PHY_INFO (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");




	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_PHY_INFO (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_PHY_INFO (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{

/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior requests information about the physical characteristics \n"
			   "and interconnect to the SATA or SAS domain. Any driver that implements this specification \n"
			   "must support this behavior. \n");

		printf("NumberOfPhys :  Contains the number of phys (real or virtual) supported by \n"
			   "this controller.  It is possible for a controller and/or driver to contain a virtual \n"
			   " phy that supports one or more of the SAS protocols. A management or test application \n"
			   "should not assume that all phys are real. Eg : 6 \n");

		printf("DeviceType :  Contains the SAS device type. Eg : UNUSED - Indicates phy cannot be attached \n"
			   " to a physical device. END_DEVICE - Indicates that phy will have charactersitcs of SAS end device \n");

		printf("InitiatorPortProtocol : Contains information on which SAS initiator protocols are \n"
			   "supported by this initiator on this phy. \n");

		printf("TargetPortProtocol : Contains information on which SAS target protocols are \n"
			   "supported by this initiator on this phy. \n");

		printf("PhyIdentifier  :  Contains the phy identifier of this phy. \n");
		printf("PortIdentifier : Contains the port identifier associated with this phy. \n"
			   "The range of the value must be from 0 to (bNumberOfPhys - 1). Multiple phys may be \n"
			   "associated with the same port, because of wide links in SAS. For example, a 4 wide link \n"
			   "(phys 0 - 3) from an initiator to an expander would all reference one port (port 0). \n");

		printf("NegotiatedLinkRate. Contains the current link rate of this phy. Eg : UNKNOWN, 1.5Gb/s etc \n");
		printf("MinimumLinkRate :Contains the minimum link rate for this phy \n");
		printf("MaximumLinkRate : Contains the minimum link rate for this phy \n");
		printf("PhyChangeCount  : Contains the current count of BROADCAST(CHANGE) primitives received on this phy \n");
		printf("AutoDiscover :  Contains the current state of the discover process for \n"
			   "the SAS Domain. The auto-discover process may begin at power on or may be initiated \n"
			   "by an OS platform specific method. Eg: Not Supported, Not Started etc \n");

		printf("DeviceType : Contains the SAS device type attached to this phy. Eg : No Device Attached, End Device etc \n");
		printf("InitiatorPortProtocol :  Contains information on which SAS initiator protocols are supported by the attached device. \n"); */



		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior requests information about the physical characteristics \n"
			   "and interconnect to the SATA or SAS domain. Any driver that implements this specification \n"
			   "must support this behavior. \n");

		print_to_file(fp,"NumberOfPhys :  Contains the number of phys (real or virtual) supported by \n"
			   "this controller.  It is possible for a controller and/or driver to contain a virtual \n"
			   " phy that supports one or more of the SAS protocols. A management or test application \n"
			   "should not assume that all phys are real. Eg : 6 \n");

		print_to_file(fp,"DeviceType :  Contains the SAS device type. Eg : UNUSED - Indicates phy cannot be attached \n"
			   " to a physical device. END_DEVICE - Indicates that phy will have charactersitcs of SAS end device \n");

		print_to_file(fp,"InitiatorPortProtocol : Contains information on which SAS initiator protocols are \n"
			   "supported by this initiator on this phy. \n");

		print_to_file(fp,"TargetPortProtocol : Contains information on which SAS target protocols are \n"
			   "supported by this initiator on this phy. \n");

		print_to_file(fp,"PhyIdentifier  :  Contains the phy identifier of this phy. \n");
		print_to_file(fp,"PortIdentifier : Contains the port identifier associated with this phy. \n"
			   "The range of the value must be from 0 to (bNumberOfPhys - 1). Multiple phys may be \n"
			   "associated with the same port, because of wide links in SAS. For example, a 4 wide link \n"
			   "(phys 0 - 3) from an initiator to an expander would all reference one port (port 0). \n");

		print_to_file(fp,"NegotiatedLinkRate. Contains the current link rate of this phy. Eg : UNKNOWN, 1.5Gb/s etc \n");
		print_to_file(fp,"MinimumLinkRate :Contains the minimum link rate for this phy \n");
		print_to_file(fp,"MaximumLinkRate : Contains the minimum link rate for this phy \n");
		print_to_file(fp,"PhyChangeCount  : Contains the current count of BROADCAST(CHANGE) primitives received on this phy \n");
		print_to_file(fp,"AutoDiscover :  Contains the current state of the discover process for \n"
			   "the SAS Domain. The auto-discover process may begin at power on or may be initiated \n"
			   "by an OS platform specific method. Eg: Not Supported, Not Started etc \n");

		print_to_file(fp,"DeviceType : Contains the SAS device type attached to this phy. Eg : No Device Attached, End Device etc \n");
		print_to_file(fp,"InitiatorPortProtocol :  Contains information on which SAS initiator protocols are supported by the attached device. \n");




		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior requests information about the physical characteristics \n"
			   "and interconnect to the SATA or SAS domain. Any driver that implements this specification \n"
			   "must support this behavior. \n");

		fprintf(tempo,"NumberOfPhys :  Contains the number of phys (real or virtual) supported by \n"
			   "this controller.  It is possible for a controller and/or driver to contain a virtual \n"
			   " phy that supports one or more of the SAS protocols. A management or test application \n"
			   "should not assume that all phys are real. Eg : 6 \n");

		fprintf(tempo,"DeviceType :  Contains the SAS device type. Eg : UNUSED - Indicates phy cannot be attached \n"
			   " to a physical device. END_DEVICE - Indicates that phy will have charactersitcs of SAS end device \n");

		fprintf(tempo,"InitiatorPortProtocol : Contains information on which SAS initiator protocols are \n"
			   "supported by this initiator on this phy. \n");

		fprintf(tempo,"TargetPortProtocol : Contains information on which SAS target protocols are \n"
			   "supported by this initiator on this phy. \n");

		fprintf(tempo,"PhyIdentifier  :  Contains the phy identifier of this phy. \n");
		fprintf(tempo,"PortIdentifier : Contains the port identifier associated with this phy. \n"
			   "The range of the value must be from 0 to (bNumberOfPhys - 1). Multiple phys may be \n"
			   "associated with the same port, because of wide links in SAS. For example, a 4 wide link \n"
			   "(phys 0 - 3) from an initiator to an expander would all reference one port (port 0). \n");

		fprintf(tempo,"NegotiatedLinkRate. Contains the current link rate of this phy. Eg : UNKNOWN, 1.5Gb/s etc \n");
		fprintf(tempo,"MinimumLinkRate :Contains the minimum link rate for this phy \n");
		fprintf(tempo,"MaximumLinkRate : Contains the minimum link rate for this phy \n");
		fprintf(tempo,"PhyChangeCount  : Contains the current count of BROADCAST(CHANGE) primitives received on this phy \n");
		fprintf(tempo,"AutoDiscover :  Contains the current state of the discover process for \n"
			   "the SAS Domain. The auto-discover process may begin at power on or may be initiated \n"
			   "by an OS platform specific method. Eg: Not Supported, Not Started etc \n");

		fprintf(tempo,"DeviceType : Contains the SAS device type attached to this phy. Eg : No Device Attached, End Device etc \n");
		fprintf(tempo,"InitiatorPortProtocol :  Contains information on which SAS initiator protocols are supported by the attached device. \n");

	}


}


void PrintBefore_issue_get_link_error(int descr)
{
//		printf("\tIOCTL : CC_CSMI_SAS_GET_LINK_ERRORS (SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_LINK_ERRORS (SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_LINK_ERRORS (SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	if(descr)
	{

/*		printf("\n SAS \n");
		printf("This CSMI functional behavior requests information on the link errors associated \n"
			   "with a specific phy. Any driver that implements this specification must support \n"
			   "this behavior. If the controller cannot support tracking of one or more of the \n"
			   "errors indicated, then the associated error counter should contain 0. If the \n"
			   "controller can track one or more of the errors indicated, then the resetflag must \n"
			   "be supported. If the controller cannot support any of the link error counters, \n"
			   "then it may post an IoctlHeader. \n"); */


		print_to_file(fp,"\n SAS \n");
		print_to_file(fp,"This CSMI functional behavior requests information on the link errors associated \n"
			   "with a specific phy. Any driver that implements this specification must support \n"
			   "this behavior. If the controller cannot support tracking of one or more of the \n"
			   "errors indicated, then the associated error counter should contain 0. If the \n"
			   "controller can track one or more of the errors indicated, then the resetflag must \n"
			   "be supported. If the controller cannot support any of the link error counters, \n"
			   "then it may post an IoctlHeader. \n");



		fprintf(tempo,"\n SAS \n");
		fprintf(tempo,"This CSMI functional behavior requests information on the link errors associated \n"
			   "with a specific phy. Any driver that implements this specification must support \n"
			   "this behavior. If the controller cannot support tracking of one or more of the \n"
			   "errors indicated, then the associated error counter should contain 0. If the \n"
			   "controller can track one or more of the errors indicated, then the resetflag must \n"
			   "be supported. If the controller cannot support any of the link error counters, \n"
			   "then it may post an IoctlHeader. \n");

	}


}



void PrintBefore_issue_ssp_passthru(int descr)
{


//		printf("\tIOCTL : CSMI_SAS_SSP_PASSTHRU (SATA,SAS)\n");
	print_to_file(fp,"\tIOCTL : CSMI_SAS_SSP_PASSTHRU (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CSMI_SAS_SSP_PASSTHRU (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{

/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior provides a method of sending generic STP or SATA \n"
			   "commands to a specific SAS address. Any driver that implements this specification \n"
			   "and supports the STP or SATA protocols must support this behavior; otherwise the driver \n"
			   "may respond to this control code with a generic IO error (see Submitting Control Codes).\n"
			   "A driver that emulates STP or SATA devices as SCSI devices may require that commands \n"
			   "directed to STP or SATA devices be directed to the SCSI link and transport layer. To \n"
			   "facilitate sending generic STP or SATA commands with that restriction an alternative \n"
			   "mechanism using a special SCSI command to wrap SATA commands may be provided \n");

		printf("Status : Contains the STP status structure for the STP or SATA command. \n");
		printf("ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept,Not Supported etc \n");
		printf("StatusFIS : Contains the SATA status FIS (34h). \n");
		printf("SCR : Contains the status control registers. The content of uSCR will be \n"
			   "updated at the completion of the command. Register level polling is not intended. \n");
		printf("DataBytes. Contains the number of valid bytes in bDataBuffer, in LSB order. \n");
		printf("DataBuffer. Contains any data that is being written to the device or contains any \n"
			   "data that has been read from the device. \n"); */



		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method of sending generic STP or SATA \n"
			   "commands to a specific SAS address. Any driver that implements this specification \n"
			   "and supports the STP or SATA protocols must support this behavior; otherwise the driver \n"
			   "may respond to this control code with a generic IO error (see Submitting Control Codes).\n"
			   "A driver that emulates STP or SATA devices as SCSI devices may require that commands \n"
			   "directed to STP or SATA devices be directed to the SCSI link and transport layer. To \n"
			   "facilitate sending generic STP or SATA commands with that restriction an alternative \n"
			   "mechanism using a special SCSI command to wrap SATA commands may be provided \n");

		print_to_file(fp,"Status : Contains the STP status structure for the STP or SATA command. \n");
		print_to_file(fp,"ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept,Not Supported etc \n");
		print_to_file(fp,"StatusFIS : Contains the SATA status FIS (34h). \n");
		print_to_file(fp,"SCR : Contains the status control registers. The content of uSCR will be \n"
			   "updated at the completion of the command. Register level polling is not intended. \n");
		print_to_file(fp,"DataBytes. Contains the number of valid bytes in bDataBuffer, in LSB order. \n");
		print_to_file(fp,"DataBuffer. Contains any data that is being written to the device or contains any \n"
			   "data that has been read from the device. \n");





		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior provides a method of sending generic STP or SATA \n"
			   "commands to a specific SAS address. Any driver that implements this specification \n"
			   "and supports the STP or SATA protocols must support this behavior; otherwise the driver \n"
			   "may respond to this control code with a generic IO error (see Submitting Control Codes).\n"
			   "A driver that emulates STP or SATA devices as SCSI devices may require that commands \n"
			   "directed to STP or SATA devices be directed to the SCSI link and transport layer. To \n"
			   "facilitate sending generic STP or SATA commands with that restriction an alternative \n"
			   "mechanism using a special SCSI command to wrap SATA commands may be provided \n");

		fprintf(tempo,"Status : Contains the STP status structure for the STP or SATA command. \n");
		fprintf(tempo,"ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept,Not Supported etc \n");
		fprintf(tempo,"StatusFIS : Contains the SATA status FIS (34h). \n");
		fprintf(tempo,"SCR : Contains the status control registers. The content of uSCR will be \n"
			   "updated at the completion of the command. Register level polling is not intended. \n");
		fprintf(tempo,"DataBytes. Contains the number of valid bytes in bDataBuffer, in LSB order. \n");
		fprintf(tempo,"DataBuffer. Contains any data that is being written to the device or contains any \n"
			   "data that has been read from the device. \n");

	}



}







void PrintBefore_issue_stp_passthru(int descr)
{


//		printf("\tIOCTL : CSMI_SAS_STP_PASSTHRU (SATA,SAS)\n");
	print_to_file(fp,"\tIOCTL : CSMI_SAS_STP_PASSTHRU (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	fprintf(tempo,"\tIOCTL : CSMI_SAS_STP_PASSTHRU (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{

/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior provides a method of sending generic STP or SATA \n"
			   "commands to a specific SAS address. Any driver that implements this specification \n"
			   "and supports the STP or SATA protocols must support this behavior; otherwise the driver \n"
			   "may respond to this control code with a generic IO error (see Submitting Control Codes).\n"
			   "A driver that emulates STP or SATA devices as SCSI devices may require that commands \n"
			   "directed to STP or SATA devices be directed to the SCSI link and transport layer. To \n"
			   "facilitate sending generic STP or SATA commands with that restriction an alternative \n"
			   "mechanism using a special SCSI command to wrap SATA commands may be provided \n");

		printf("Status : Contains the STP status structure for the STP or SATA command. \n");
		printf("ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept,Not Supported etc \n");
		printf("StatusFIS : Contains the SATA status FIS (34h). \n");
		printf("SCR : Contains the status control registers. The content of uSCR will be \n"
			   "updated at the completion of the command. Register level polling is not intended. \n");
		printf("DataBytes. Contains the number of valid bytes in bDataBuffer, in LSB order. \n");
		printf("DataBuffer. Contains any data that is being written to the device or contains any \n"
			   "data that has been read from the device. \n"); */



		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method of sending generic STP or SATA \n"
			   "commands to a specific SAS address. Any driver that implements this specification \n"
			   "and supports the STP or SATA protocols must support this behavior; otherwise the driver \n"
			   "may respond to this control code with a generic IO error (see Submitting Control Codes).\n"
			   "A driver that emulates STP or SATA devices as SCSI devices may require that commands \n"
			   "directed to STP or SATA devices be directed to the SCSI link and transport layer. To \n"
			   "facilitate sending generic STP or SATA commands with that restriction an alternative \n"
			   "mechanism using a special SCSI command to wrap SATA commands may be provided \n");

		print_to_file(fp,"Status : Contains the STP status structure for the STP or SATA command. \n");
		print_to_file(fp,"ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept,Not Supported etc \n");
		print_to_file(fp,"StatusFIS : Contains the SATA status FIS (34h). \n");
		print_to_file(fp,"SCR : Contains the status control registers. The content of uSCR will be \n"
			   "updated at the completion of the command. Register level polling is not intended. \n");
		print_to_file(fp,"DataBytes. Contains the number of valid bytes in bDataBuffer, in LSB order. \n");
		print_to_file(fp,"DataBuffer. Contains any data that is being written to the device or contains any \n"
			   "data that has been read from the device. \n");





		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior provides a method of sending generic STP or SATA \n"
			   "commands to a specific SAS address. Any driver that implements this specification \n"
			   "and supports the STP or SATA protocols must support this behavior; otherwise the driver \n"
			   "may respond to this control code with a generic IO error (see Submitting Control Codes).\n"
			   "A driver that emulates STP or SATA devices as SCSI devices may require that commands \n"
			   "directed to STP or SATA devices be directed to the SCSI link and transport layer. To \n"
			   "facilitate sending generic STP or SATA commands with that restriction an alternative \n"
			   "mechanism using a special SCSI command to wrap SATA commands may be provided \n");

		fprintf(tempo,"Status : Contains the STP status structure for the STP or SATA command. \n");
		fprintf(tempo,"ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept,Not Supported etc \n");
		fprintf(tempo,"StatusFIS : Contains the SATA status FIS (34h). \n");
		fprintf(tempo,"SCR : Contains the status control registers. The content of uSCR will be \n"
			   "updated at the completion of the command. Register level polling is not intended. \n");
		fprintf(tempo,"DataBytes. Contains the number of valid bytes in bDataBuffer, in LSB order. \n");
		fprintf(tempo,"DataBuffer. Contains any data that is being written to the device or contains any \n"
			   "data that has been read from the device. \n");


	}




}




void PrintBefore_issue_get_sata_signature(int descr)
{

//	printf("\tIOCTL : CC_CSMI_SAS_GET_SATA_SIGNATURE (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");




	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_SATA_SIGNATURE (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_GET_SATA_SIGNATURE (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{
/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior provides a method of obtaining the initial SATA \n"
			   "signature (the initial Register Device to Host FIS) from a directly attached SATA device.\n"
			   "The signature may be used to identify whether a SATA device supports the PACKET command set \n"
			   "or whether it is a unique SATA device (like a port multiplier). Any driver that implements \n"
			   "this specification and supports directly attached SATA devices must support this behavior. \n");
		printf("SignatureFIS : Contains the initial register device to host FIS (34h) from the \n"
			   "SATA device. Only the signature bytes are required to be valid, the remainder of the FIS \n"
			   "may be 0 filled. If the FIS type is valid, (i.e. 34h) then the entire FIS is assumed to be \n"
			   "valid (i.e. as returned from the device). \n"); */


		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method of obtaining the initial SATA \n"
			   "signature (the initial Register Device to Host FIS) from a directly attached SATA device.\n"
			   "The signature may be used to identify whether a SATA device supports the PACKET command set \n"
			   "or whether it is a unique SATA device (like a port multiplier). Any driver that implements \n"
			   "this specification and supports directly attached SATA devices must support this behavior. \n");
		print_to_file(fp,"SignatureFIS : Contains the initial register device to host FIS (34h) from the \n"
			   "SATA device. Only the signature bytes are required to be valid, the remainder of the FIS \n"
			   "may be 0 filled. If the FIS type is valid, (i.e. 34h) then the entire FIS is assumed to be \n"
			   "valid (i.e. as returned from the device). \n");


		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior provides a method of obtaining the initial SATA \n"
			   "signature (the initial Register Device to Host FIS) from a directly attached SATA device.\n"
			   "The signature may be used to identify whether a SATA device supports the PACKET command set \n"
			   "or whether it is a unique SATA device (like a port multiplier). Any driver that implements \n"
			   "this specification and supports directly attached SATA devices must support this behavior. \n");
		fprintf(tempo,"SignatureFIS : Contains the initial register device to host FIS (34h) from the \n"
			   "SATA device. Only the signature bytes are required to be valid, the remainder of the FIS \n"
			   "may be 0 filled. If the FIS type is valid, (i.e. 34h) then the entire FIS is assumed to be \n"
			   "valid (i.e. as returned from the device). \n");
	}



}



void PrintBefore_issue_get_scsi_address(int descr)
{

//	printf("\tIOCTL : CSMI_SAS_GET_SCSI_ADDRESS (SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");




	print_to_file(fp,"\tIOCTL : CSMI_SAS_GET_SCSI_ADDRESS (SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	fprintf(tempo,"\tIOCTL : CSMI_SAS_GET_SCSI_ADDRESS (SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{

/*		printf("\n SAS \n");
		printf("This CSMI functional behavior provides a method of obtaining the OS specific \n"
			   "platform address for a SAS address. Any driver that implements this specification \n"
			   "must support this behavior. The driver may generate an error on this request for the \n"
			   "following reasons: The SAS address is to an expander device. or The SAS address does not \n"
			   "have an associated OS specific address.\n");
		printf("HostIndex :  Contains the enumerated index of the driver instance An FFh \n"
			   "indicates the value is invalid. \n");
		printf("PathId : Contains the path identifier for the device. \n");
		printf("TargetId :  Contains the target identifier for the device. \n");
		printf("Lun :  Contains the Lun identifier for the device. \n"); */




		print_to_file(fp,"\n SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method of obtaining the OS specific \n"
			   "platform address for a SAS address. Any driver that implements this specification \n"
			   "must support this behavior. The driver may generate an error on this request for the \n"
			   "following reasons: The SAS address is to an expander device. or The SAS address does not \n"
			   "have an associated OS specific address.\n");
		print_to_file(fp,"HostIndex :  Contains the enumerated index of the driver instance An FFh \n"
			   "indicates the value is invalid. \n");
		print_to_file(fp,"PathId : Contains the path identifier for the device. \n");
		print_to_file(fp,"TargetId :  Contains the target identifier for the device. \n");
		print_to_file(fp,"Lun :  Contains the Lun identifier for the device. \n");


		fprintf(tempo,"\n SAS \n");
		fprintf(tempo,"This CSMI functional behavior provides a method of obtaining the OS specific \n"
			   "platform address for a SAS address. Any driver that implements this specification \n"
			   "must support this behavior. The driver may generate an error on this request for the \n"
			   "following reasons: The SAS address is to an expander device. or The SAS address does not \n"
			   "have an associated OS specific address.\n");
		fprintf(tempo,"HostIndex :  Contains the enumerated index of the driver instance An FFh \n"
			   "indicates the value is invalid. \n");
		fprintf(tempo,"PathId : Contains the path identifier for the device. \n");
		fprintf(tempo,"TargetId :  Contains the target identifier for the device. \n");
		fprintf(tempo,"Lun :  Contains the Lun identifier for the device. \n");
	}

}




void PrintBefore_issue_get_device_address(int descr)
{
//	printf("\tIOCTL : CSMI_SAS_GET_DEVICE_ADDRESS (SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");





	print_to_file(fp,"\tIOCTL : CSMI_SAS_GET_DEVICE_ADDRESS (SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	fprintf(tempo,"\tIOCTL : CSMI_SAS_GET_DEVICE_ADDRESS (SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{

/*		printf("\n SAS \n");
		printf("This CSMI functional behavior provides a method of obtaining the SAS address \n"
			   "of a device from an OS specific platform address. Any driver that implements \n"
			   "this specification must support this  behavior. The driver may generate an error \n"
			   "on this request for the following reasons: The OS specific platform address does \n"
			   "not have a SAS address.\n");
		printf("SASAddress : Contains the SAS address of the device, in MSB order. \n");
		printf("SASLun : Contains the SAS Lun of the device, in MSB order. \n"); */


		print_to_file(fp,"\n SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method of obtaining the SAS address \n"
			   "of a device from an OS specific platform address. Any driver that implements \n"
			   "this specification must support this  behavior. The driver may generate an error \n"
			   "on this request for the following reasons: The OS specific platform address does \n"
			   "not have a SAS address.\n");
		print_to_file(fp,"SASAddress : Contains the SAS address of the device, in MSB order. \n");
		print_to_file(fp,"SASLun : Contains the SAS Lun of the device, in MSB order. \n");


		fprintf(tempo,"\n SAS \n");
		fprintf(tempo,"This CSMI functional behavior provides a method of obtaining the SAS address \n"
			   "of a device from an OS specific platform address. Any driver that implements \n"
			   "this specification must support this  behavior. The driver may generate an error \n"
			   "on this request for the following reasons: The OS specific platform address does \n"
			   "not have a SAS address.\n");
		fprintf(tempo,"SASAddress : Contains the SAS address of the device, in MSB order. \n");
		fprintf(tempo,"SASLun : Contains the SAS Lun of the device, in MSB order. \n");

	}

}



void PrintBefore_issue_set_phy_info(int descr)
{
//		printf("\tIOCTL : CC_CSMI_SAS_SET_PHY_INFO (SATA,SAS)\n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_SET_PHY_INFO (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

		fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_SET_PHY_INFO (SATA,SAS)\n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	if(descr)
	{
/*		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior requests that the physical characteristics \n"
			   "of a phy be changed. Any driver that implements this specification must support \n"
			   "this behavior. Even though this CSMI functional behavior must be supported, the \n"
			   "changing of physical characteristics is not required. \n");
		printf("\n The Output will correspond to the Input Specifications \n"); */

		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior requests that the physical characteristics \n"
			   "of a phy be changed. Any driver that implements this specification must support \n"
			   "this behavior. Even though this CSMI functional behavior must be supported, the \n"
			   "changing of physical characteristics is not required. \n");
		print_to_file(fp,"\n The Output will correspond to the Input Specifications \n");


				fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior requests that the physical characteristics \n"
			   "of a phy be changed. Any driver that implements this specification must support \n"
			   "this behavior. Even though this CSMI functional behavior must be supported, the \n"
			   "changing of physical characteristics is not required. \n");
		fprintf(tempo,"\n The Output will correspond to the Input Specifications \n");
	}


}



void PrintBefore_issue_set_task_management(int descr)
{
//	        printf("\tIOCTL : CC_CSMI_SAS_TASK_MANAGEMENT (SAS) is NOT yet implemented in this tool.\n");
//        printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");






		print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_TASK_MANAGEMENT (SAS) is NOT yet implemented in this tool.\n");
        print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


		fprintf(tempo,"\tIOCTL : CC_CSMI_SAS_TASK_MANAGEMENT (SAS) is NOT yet implemented in this tool.\n");
        fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


		if(descr)
		{
/*			printf("\n SAS \n");
			printf("This CSMI functional behavior provides a method of sending a Hard Reset \n"
				   "Sequence or Task Information Unit to the specified OS specific platform address.\n");

			printf("Status :  Contains the SSP status structure for the SSP command.\n");
			printf("ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept, Not Suppoeted etc \n");
			printf("DataPresent :  Contains the directives that indicate what has been \n"
				   "returned in bResponse. Eg : No Data, Resoponse Data or Sense Data \n");

			printf("ResponseLength : Contains the number of valid bytes in the bResponse field  \n");
			printf("Response : Contains the response bytes in MSB order. \n");
			printf("DataBytes : Should be 0.\n"); */


			print_to_file(fp,"\n SAS \n");
			print_to_file(fp,"This CSMI functional behavior provides a method of sending a Hard Reset \n"
				   "Sequence or Task Information Unit to the specified OS specific platform address.\n");

			print_to_file(fp,"Status :  Contains the SSP status structure for the SSP command.\n");
			print_to_file(fp,"ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept, Not Suppoeted etc \n");
			print_to_file(fp,"DataPresent :  Contains the directives that indicate what has been \n"
				   "returned in bResponse. Eg : No Data, Resoponse Data or Sense Data \n");

			print_to_file(fp,"ResponseLength : Contains the number of valid bytes in the bResponse field  \n");
			print_to_file(fp,"Response : Contains the response bytes in MSB order. \n");
			print_to_file(fp,"DataBytes : Should be 0.\n");



			fprintf(tempo,"\n SAS \n");
			fprintf(tempo,"This CSMI functional behavior provides a method of sending a Hard Reset \n"
				   "Sequence or Task Information Unit to the specified OS specific platform address.\n");

			fprintf(tempo,"Status :  Contains the SSP status structure for the SSP command.\n");
			fprintf(tempo,"ConnectionStatus : Contains the results of the open connection attempt. Eg : Accept, Not Suppoeted etc \n");
			fprintf(tempo,"DataPresent :  Contains the directives that indicate what has been \n"
				   "returned in bResponse. Eg : No Data, Resoponse Data or Sense Data \n");

			fprintf(tempo,"ResponseLength : Contains the number of valid bytes in the bResponse field  \n");
			fprintf(tempo,"Response : Contains the response bytes in MSB order. \n");
			fprintf(tempo,"DataBytes : Should be 0.\n");
		}


}


void PrintBefore_issue_firmware_download(int descr)
{

//    printf("\n IOCTL : CC_CSMI_SAS_FIRMWARE_DOWNLOAD is NOT yet implemented in this tool.\n");
	print_to_file(fp,"\n IOCTL : CC_CSMI_SAS_FIRMWARE_DOWNLOAD is NOT yet implemented in this tool.\n");
	fprintf(tempo,"\n IOCTL : CC_CSMI_SAS_FIRMWARE_DOWNLOAD is NOT yet implemented in this tool.\n");

	if(descr)
	{

/*		printf("\n This CSMI functional behavior allows the controller firmware to be updated\n"
	           "\n  online. This is an optional behavior. \n"); */
		print_to_file(fp,"\n This CSMI functional behavior allows the controller firmware to be updated\n"
	           "\n  online. This is an optional behavior. \n");

		fprintf(tempo,"\n This CSMI functional behavior allows the controller firmware to be updated\n"
	           "\n  online. This is an optional behavior. \n");

	}


}


void PrintBefore_issue_sas_smp_passthru(int descr)
{
//	printf("\tIOCTL : CSMI_SAS_SMP_PASSTHRU (SAS) is NOT yet implemented in this tool. \n");
//	printf("\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");




	print_to_file(fp,"\tIOCTL : CSMI_SAS_SMP_PASSTHRU (SAS)is not yet implemented in this tool. \n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	fprintf(tempo,"\tIOCTL : CSMI_SAS_SMP_PASSTHRU (SAS)is not yet implemented in this tool. \n");
	fprintf(tempo,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");



	if(descr)
	{

/*		printf("\n SAS \n");
		printf("This CSMI functional behavior provides a method of sending generic SMP requests \n"
			   "to a specific SAS address. Any driver that implements this specification and supports \n"
			   "the SMP protocol must support this behavior. \n");

		printf("ConnectionStatus :  Contains the results of the open connection attempt. Eg : Successful, Blocked etc \n");
		printf("ResponseBytes :  Contains the number of valid bytes in the Parameters.Response data structure.\n");
		printf("FrameType :  Contains the SMP response type. Should be 41h.\n");
		printf("Function : Contains the SMP function. \n");
		printf("FunctionResult : Contains the SMP function result. \n");
		printf("AdditionalRequestBytes. Contains the payload bytes for the SMP function response. \n"); */


		print_to_file(fp,"\n SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method of sending generic SMP requests \n"
			   "to a specific SAS address. Any driver that implements this specification and supports \n"
			   "the SMP protocol must support this behavior. \n");

		print_to_file(fp,"ConnectionStatus :  Contains the results of the open connection attempt. Eg : Successful, Blocked etc \n");
		print_to_file(fp,"ResponseBytes :  Contains the number of valid bytes in the Parameters.Response data structure.\n");
		print_to_file(fp,"FrameType :  Contains the SMP response type. Should be 41h.\n");
		print_to_file(fp,"Function : Contains the SMP function. \n");
		print_to_file(fp,"FunctionResult : Contains the SMP function result. \n");
		print_to_file(fp,"AdditionalRequestBytes. Contains the payload bytes for the SMP function response. \n");



		fprintf(tempo,"\n SAS \n");
		fprintf(tempo,"This CSMI functional behavior provides a method of sending generic SMP requests \n"
			   "to a specific SAS address. Any driver that implements this specification and supports \n"
			   "the SMP protocol must support this behavior. \n");

		fprintf(tempo,"ConnectionStatus :  Contains the results of the open connection attempt. Eg : Successful, Blocked etc \n");
		fprintf(tempo,"ResponseBytes :  Contains the number of valid bytes in the Parameters.Response data structure.\n");
		fprintf(tempo,"FrameType :  Contains the SMP response type. Should be 41h.\n");
		fprintf(tempo,"Function : Contains the SMP function. \n");
		fprintf(tempo,"FunctionResult : Contains the SMP function result. \n");
		fprintf(tempo,"AdditionalRequestBytes. Contains the payload bytes for the SMP function response. \n");

	}





}



void PrintBefore_issue_get_connector_info(int descr)
{

	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_CONNECTOR_INFO (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	if(descr)
	{
		printf("\n SATA,SAS \n");
		printf("This CSMI functional behavior provides a method for obtaining \n"
			   "the connector information for a controller. \n"
			   "Any driver that implements this specification must support this behavior.\n");
		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method for obtaining \n"
			   "the connector information for a controller. \n"
			   "Any driver that implements this specification must support this behavior.\n");
	}
}


void PrintBefore_issue_get_location(int descr)
{

	print_to_file(fp,"\tIOCTL : CC_CSMI_SAS_GET_LOCATION (SATA,SAS)\n");
	print_to_file(fp,"\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");

	if(descr)
	{
		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior provides a method for obtaining \n"
			   "the physical location of a device from a OS specific platform address. \n"
			   "Any driver that implements this specification must support this behavior.\n"
			   "The driver may generate an error on this request for the following reasons:\n"
			   "- The OS specific platform address does not have a physical location.\n"
			   "  The return code would be CSMI_SAS_NO_DEVICE_ADDRESS\n");
		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp,"This CSMI functional behavior provides a method for obtaining \n"
			   "the connector information for a controller. \n"
			   "Any driver that implements this specification must support this behavior.\n"
			   "The driver may generate an error on this request for the following reasons:\n"
			   "- The OS specific platform address does not have a physical location.\n"
			   "  The return code would be CSMI_SAS_NO_DEVICE_ADDRESS\n");
	}
}


void PrintBefore_issue_get_raid_features(int descr)
{

	print_to_file(fp , "\tIOCTL : CC_CSMI_SAS_GET_RAID_FEATURES (SAS ,SATA)\n");
	print_to_file(fp , "\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ \n");


	if(descr)
	{
		fprintf(tempo,"\n SATA,SAS \n");
		fprintf(tempo,"This CSMI functional behavior requests information on the RAID features and controls supported"
			"by the controller. This optional functional behavior should be supported if the uControllerFlags in"
			"the CSMI_SAS_CNTLR_CONFIG structure indicates that the controller supports RAID.\n");
		print_to_file(fp,"\n SATA,SAS \n");
		print_to_file(fp , "This CSMI functional behavior requests information on the RAID features" 
				"and controls supported by the controller. This optional functional behavior" 
				"should be supported if the uControllerFlags in the CSMI_SAS_CNTLR_CONFIG" 
				"structure indicates that the controller supports RAID.\n");
	}
	
}
void DisplayDumpBefore(char *s)
{
	int cntr = 0;
	int z = 0;
	char arr[30];
	int fi = 0;





//		printf("\n Hex Dump Info before issuing the ioctl : \n");
		print_to_file(fp,"\n Hex Dump Info before issuing the ioctl : \n");
		fprintf(tempo,"\n Hex Dump Info before issuing the ioctl : \n");

        for (z=0;z<20000;z++,s++)
		{
//			printf("%02x ",*s & 0xff);
			print_to_file(fp,"%02x ",*s & 0xff);
			fprintf(tempo,"%02x ",*s & 0xff);
			arr[cntr] = *s;
			cntr++;

			   if(cntr == 16)
			   {
//				   printf(" : ");
				   print_to_file(fp," : ");
				   fprintf(tempo," : ");
				   for(fi = 0;fi < cntr; fi++)
				   {
					   if(isgraph(arr[fi]))
					   {
							//printf("%c",arr[fi]);
							print_to_file(fp,"%c",arr[fi]);
							fprintf(tempo,"%c",arr[fi]);
					   }
					   else
					   {
						   /*printf(".");*/  print_to_file(fp,"."); fprintf(tempo,".");
					   }
				   }
				   cntr = 0;
				   //printf("\n");
				   print_to_file(fp,"\n");
				   fprintf(tempo,"\n");
			   }

		}


			 for(fi = cntr;fi<16;fi++)   fprintf(tempo,"   ");
//				 printf("   ");



//			       printf(" : ");

				   print_to_file(fp," : ");
				   fprintf(tempo," : ");
				   for(fi = 0;fi < cntr; fi++)
				   {
					   if(isgraph(arr[fi]))
					   {
							//printf("%c",arr[fi]);
							print_to_file(fp,"%c",arr[fi]);
							fprintf(tempo,"%c",arr[fi]);
					   }
					   else
					   {
						   /*printf(".");*/  print_to_file(fp,"."); fprintf(tempo,".");
					   }
				   }



//		printf("\n \n");
		print_to_file(fp,"\n \n");
		fprintf(tempo,"\n \n");



}




void DisplayDumpAfter(char* s)
{
	int cntr = 0;
	int z = 0;
	char arr[30];
	int fi = 0;





//		printf("\n Hex Dump Info After issuing the ioctl : \n");
		print_to_file(fp,"\n Hex Dump Info After issuing the ioctl : \n");
		fprintf(tempo,"\n Hex Dump Info After issuing the ioctl : \n");

		//for (z=0;z<sizeof(CSMI_SAS_DRIVER_INFO_BUFFER);z++,s++)
		for (z=0;z<sizeof(CSMI_SAS_DRIVER_INFO);z++,s++)
		{
		//	printf("%02x ",*s & 0xff);
			print_to_file(fp,"%02x ",*s & 0xff);
			fprintf(tempo,"%02x ",*s & 0xff);
			arr[cntr] = *s;
			cntr++;

			   if(cntr == 16)
			   {
				   //printf(" : ");
				   print_to_file(fp," : ");
				   fprintf(tempo," : ");
				   for(fi = 0;fi < cntr; fi++)
				   {
					   if(isgraph(arr[fi]))
					   {
							//printf("%c",arr[fi]);
							print_to_file(fp,"%c",arr[fi]);
							fprintf(tempo,"%c",arr[fi]);
					   }
					   else
					   {
						  /* printf("."); */ print_to_file(fp,".");   fprintf(tempo,".");
					   }
				   }
				   cntr = 0;
				   //printf("\n");
				   print_to_file(fp,"\n");
				   fprintf(tempo,"\n");
			   }

		}


			 for(fi = cntr;fi<16;fi++)  fprintf(tempo,"   ");
				 //printf("   ");



			       //printf(" : ");
				   print_to_file(fp," : ");
				   fprintf(tempo," : ");
				   for(fi = 0;fi < cntr; fi++)
				   {
					   if(isgraph(arr[fi]))
					   {
							//printf("%c",arr[fi]);
							print_to_file(fp,"%c",arr[fi]);
							fprintf(tempo,"%c",arr[fi]);
					   }
					   else
					   {
						  /* printf("."); */ print_to_file(fp,"."); fprintf(tempo,".");
					   }
				   }



//		printf("\n \n");
		print_to_file(fp,"\n \n");
		fprintf(tempo,"\n \n");



}







void DisplaySMPPassthru(CSMI_SAS_SMP_PASSTHRU_BUFFER *PassthruBuff)
{
	int i = PassthruBuff->Parameters.uResponseBytes;
        /* Modified on 15/Feb/2005 */
        //printf("\t Number of Valid Bytes: %d\n",i);
        //printf("\t Connection Status: %d\n",PassthruBuff->Parameters.bConnectionStatus);

		print_to_file(fp,"\t Number of Valid Bytes: %d\n",i);
        print_to_file(fp,"\t Connection Status: %d\n",PassthruBuff->Parameters.bConnectionStatus);

		fprintf(tempo,"\t Number of Valid Bytes: %d\n",i);
        fprintf(tempo,"\t Connection Status: %d\n",PassthruBuff->Parameters.bConnectionStatus);


        /* End of Modification */

/*	printf("\tRESPONSE:\n");
	printf("\t  Frame Type\t\t:0x%02x\n", PassthruBuff->Parameters.Response.bFrameType);
	printf("\t  Function\t\t:%d\n", PassthruBuff->Parameters.Response.bFunction);
	printf("\t  Function Result\t:%d\n", PassthruBuff->Parameters.Response.bFunctionResult);
	printf("\n\t  Additional response bytes:\n\n\t"); */

	print_to_file(fp,"\tRESPONSE:\n");
	print_to_file(fp,"\t  Frame Type\t\t:0x%02x\n", PassthruBuff->Parameters.Response.bFrameType);
	print_to_file(fp,"\t  Function\t\t:%d\n", PassthruBuff->Parameters.Response.bFunction);
	print_to_file(fp,"\t  Function Result\t:%d\n", PassthruBuff->Parameters.Response.bFunctionResult);
	print_to_file(fp,"\n\t  Additional response bytes:\n\n\t");


	fprintf(tempo,"\tRESPONSE:\n");
	fprintf(tempo,"\t  Frame Type\t\t:0x%02x\n", PassthruBuff->Parameters.Response.bFrameType);
	fprintf(tempo,"\t  Function\t\t:%d\n", PassthruBuff->Parameters.Response.bFunction);
	fprintf(tempo,"\t  Function Result\t:%d\n", PassthruBuff->Parameters.Response.bFunctionResult);
	fprintf(tempo,"\n\t  Additional response bytes:\n\n\t");


	PassthruBuff->Parameters.Response.bAdditionalResponseBytes[i+1] = '\0';
	puts(PassthruBuff->Parameters.Response.bAdditionalResponseBytes); //HAVE NOT PRINTED TO FILE
}





void DisplayDriverInfo(CSMI_SAS_DRIVER_INFO Info)
{
/*	printf("\tName\t\t: %s\n", Info.szName);
	printf("\tDescription\t: %s\n", Info.szDescription);
	printf("\tMajor Revision\t: %d\n", Info.usMajorRevision);
	printf("\tMinor Revision\t: %d\n", Info.usMinorRevision);
	printf("\tBuild Revision\t: %d\n", Info.usBuildRevision);
	printf("\tRelease Revision: %d\n", Info.usReleaseRevision);
	printf("\tCSMI Maj Rev\t: %d\n",Info.usCSMIMajorRevision);
	printf("\tCSMI Min Rev\t: %d\n",Info.usCSMIMinorRevision); */




	print_to_file(fp,"\tName\t\t: %s\n", Info.szName);
	print_to_file(fp,"\tDescription\t: %s\n", Info.szDescription);
	print_to_file(fp,"\tMajor Revision\t: %d\n", Info.usMajorRevision);
	print_to_file(fp,"\tMinor Revision\t: %d\n", Info.usMinorRevision);
	print_to_file(fp,"\tBuild Revision\t: %d\n", Info.usBuildRevision);
	print_to_file(fp,"\tRelease Revision: %d\n", Info.usReleaseRevision);
	print_to_file(fp,"\tCSMI Maj Rev\t: %d\n",Info.usCSMIMajorRevision);
	print_to_file(fp,"\tCSMI Min Rev\t: %d\n",Info.usCSMIMinorRevision);

	fprintf(tempo,"\tName\t\t: %s\n", Info.szName);
	fprintf(tempo,"\tDescription\t: %s\n", Info.szDescription);
	fprintf(tempo,"\tMajor Revision\t: %d\n", Info.usMajorRevision);
	fprintf(tempo,"\tMinor Revision\t: %d\n", Info.usMinorRevision);
	fprintf(tempo,"\tBuild Revision\t: %d\n", Info.usBuildRevision);
	fprintf(tempo,"\tRelease Revision: %d\n", Info.usReleaseRevision);
	fprintf(tempo,"\tCSMI Maj Rev\t: %d\n",Info.usCSMIMajorRevision);
	fprintf(tempo,"\tCSMI Min Rev\t: %d\n",Info.usCSMIMinorRevision);





}

void DisplayCntlrConfig(CSMI_SAS_CNTLR_CONFIG Config)
{




//	printf("\tBase I/O Address: 0x%x\n", Config.uBaseIoAddress);
	print_to_file(fp,"\tBase I/O Address: 0x%x\n", Config.uBaseIoAddress);

        /* Modified on 15/Feb/2005 */
  //      printf("\tBase Memory Address (Low): 0x%x\n",Config.BaseMemoryAddress.uLowPart);
  //      printf("\tBase Memory Address (High): 0x%x\n",Config.BaseMemoryAddress.uHighPart);

		print_to_file(fp,"\tBase Memory Address (Low): 0x%x\n",Config.BaseMemoryAddress.uLowPart);
        print_to_file(fp,"\tBase Memory Address (High): 0x%x\n",Config.BaseMemoryAddress.uHighPart);
        /* End of Modify */

/*	printf("\tBoard ID \t: 0x%x\n", Config.uBoardID);
	printf("\tSlot Number\t: %d\n", Config.usSlotNumber);
	printf("\tController Class: %d\n", Config.bControllerClass);
	printf("\tI/O Bus Type\t: %d\n", Config.bIoBusType);
	printf("\tBus Number\t: %d\n", Config.BusAddress.PciAddress.bBusNumber);
	printf("\tDevice Number \t: %d\n", Config.BusAddress.PciAddress.bDeviceNumber);
	printf("\tFunction Number : %d\n", Config.BusAddress.PciAddress.bFunctionNumber);
	printf("\tSerial Number\t: %s\n", Config.szSerialNumber);
	printf("\tMajor Revision\t: %d\n", Config.usMajorRevision);
	printf("\tMinor Revision\t: %d\n", Config.usMinorRevision);
	printf("\tBuild Revision\t: %d\n", Config.usBuildRevision);
	printf("\tRelease Revision: %d\n", Config.usReleaseRevision);
	printf("\tBIOS Maj Rev\t: %d\n", Config.usBIOSMajorRevision);
	printf("\tBIOS Min Rev\t: %d\n", Config.usBIOSMinorRevision);
	printf("\tBIOS Build Rev\t: %d\n", Config.usBIOSBuildRevision);
	printf("\tBIOS Rel Revision: %d\n", Config.usBIOSReleaseRevision);
	printf("\tController Flags: 0x%x\n", Config.uControllerFlags);

	printf("\n\n\tRedundant Controller Info:\n");
	printf("\t--------------------------\n");
	printf("\tMajor Revision\t: %d\n", Config.usRromMajorRevision);
	printf("\tMinor Revision\t: %d\n", Config.usRromMinorRevision);
	printf("\tBuild Revision\t: %d\n", Config.usRromBuildRevision);
	printf("\tRelease Revision: %d\n", Config.usRromReleaseRevision);
	printf("\tBIOS Maj Rev\t: %d\n", Config.usRromBIOSMajorRevision);
	printf("\tBIOS Min Rev\t: %d\n", Config.usRromBIOSMinorRevision);
	printf("\tBIOS Build Rev\t: %d\n", Config.usRromBIOSBuildRevision);
	printf("\tBIOS Rel Revision: %d\n", Config.usRromBIOSReleaseRevision); */



	print_to_file(fp,"\tBoard ID \t: 0x%x\n", Config.uBoardID);
	print_to_file(fp,"\tSlot Number\t: %d\n", Config.usSlotNumber);
	print_to_file(fp,"\tController Class: %d\n", Config.bControllerClass);
	print_to_file(fp,"\tI/O Bus Type\t: %d\n", Config.bIoBusType);
	print_to_file(fp,"\tBus Number\t: %d\n", Config.BusAddress.PciAddress.bBusNumber);
	print_to_file(fp,"\tDevice Number \t: %d\n", Config.BusAddress.PciAddress.bDeviceNumber);
	print_to_file(fp,"\tFunction Number : %d\n", Config.BusAddress.PciAddress.bFunctionNumber);
	print_to_file(fp,"\tSerial Number\t: %s\n", Config.szSerialNumber);
	print_to_file(fp,"\tMajor Revision\t: %d\n", Config.usMajorRevision);
	print_to_file(fp,"\tMinor Revision\t: %d\n", Config.usMinorRevision);
	print_to_file(fp,"\tBuild Revision\t: %d\n", Config.usBuildRevision);
	print_to_file(fp,"\tRelease Revision: %d\n", Config.usReleaseRevision);
	print_to_file(fp,"\tBIOS Maj Rev\t: %d\n", Config.usBIOSMajorRevision);
	print_to_file(fp,"\tBIOS Min Rev\t: %d\n", Config.usBIOSMinorRevision);
	print_to_file(fp,"\tBIOS Build Rev\t: %d\n", Config.usBIOSBuildRevision);
	print_to_file(fp,"\tBIOS Rel Revision: %d\n", Config.usBIOSReleaseRevision);
	print_to_file(fp,"\tController Flags: 0x%x\n", Config.uControllerFlags);

	print_to_file(fp,"\n\n\tRedundant Controller Info:\n");
	print_to_file(fp,"\t--------------------------\n");
	print_to_file(fp,"\tMajor Revision\t: %d\n", Config.usRromMajorRevision);
	print_to_file(fp,"\tMinor Revision\t: %d\n", Config.usRromMinorRevision);
	print_to_file(fp,"\tBuild Revision\t: %d\n", Config.usRromBuildRevision);
	print_to_file(fp,"\tRelease Revision: %d\n", Config.usRromReleaseRevision);
	print_to_file(fp,"\tBIOS Maj Rev\t: %d\n", Config.usRromBIOSMajorRevision);
	print_to_file(fp,"\tBIOS Min Rev\t: %d\n", Config.usRromBIOSMinorRevision);
	print_to_file(fp,"\tBIOS Build Rev\t: %d\n", Config.usRromBIOSBuildRevision);
	print_to_file(fp,"\tBIOS Rel Revision: %d\n", Config.usRromBIOSReleaseRevision);



	fprintf(tempo,"\tBase I/O Address: 0x%x\n", Config.uBaseIoAddress);
	fprintf(tempo,"\tBase Memory Address (Low): 0x%x\n",Config.BaseMemoryAddress.uLowPart);
    fprintf(tempo,"\tBase Memory Address (High): 0x%x\n",Config.BaseMemoryAddress.uHighPart);
	fprintf(tempo,"\tBoard ID \t: 0x%x\n", Config.uBoardID);
	fprintf(tempo,"\tSlot Number\t: %d\n", Config.usSlotNumber);
	fprintf(tempo,"\tController Class: %d\n", Config.bControllerClass);
	fprintf(tempo,"\tI/O Bus Type\t: %d\n", Config.bIoBusType);
	fprintf(tempo,"\tBus Number\t: %d\n", Config.BusAddress.PciAddress.bBusNumber);
	fprintf(tempo,"\tDevice Number \t: %d\n", Config.BusAddress.PciAddress.bDeviceNumber);
	fprintf(tempo,"\tFunction Number : %d\n", Config.BusAddress.PciAddress.bFunctionNumber);
	fprintf(tempo,"\tSerial Number\t: %s\n", Config.szSerialNumber);
	fprintf(tempo,"\tMajor Revision\t: %d\n", Config.usMajorRevision);
	fprintf(tempo,"\tMinor Revision\t: %d\n", Config.usMinorRevision);
	fprintf(tempo,"\tBuild Revision\t: %d\n", Config.usBuildRevision);
	fprintf(tempo,"\tRelease Revision: %d\n", Config.usReleaseRevision);
	fprintf(tempo,"\tBIOS Maj Rev\t: %d\n", Config.usBIOSMajorRevision);
	fprintf(tempo,"\tBIOS Min Rev\t: %d\n", Config.usBIOSMinorRevision);
	fprintf(tempo,"\tBIOS Build Rev\t: %d\n", Config.usBIOSBuildRevision);
	fprintf(tempo,"\tBIOS Rel Revision: %d\n", Config.usBIOSReleaseRevision);
	fprintf(tempo,"\tController Flags: 0x%x\n", Config.uControllerFlags);

	fprintf(tempo,"\n\n\tRedundant Controller Info:\n");
	fprintf(tempo,"\t--------------------------\n");
	fprintf(tempo,"\tMajor Revision\t: %d\n", Config.usRromMajorRevision);
	fprintf(tempo,"\tMinor Revision\t: %d\n", Config.usRromMinorRevision);
	fprintf(tempo,"\tBuild Revision\t: %d\n", Config.usRromBuildRevision);
	fprintf(tempo,"\tRelease Revision: %d\n", Config.usRromReleaseRevision);
	fprintf(tempo,"\tBIOS Maj Rev\t: %d\n", Config.usRromBIOSMajorRevision);
	fprintf(tempo,"\tBIOS Min Rev\t: %d\n", Config.usRromBIOSMinorRevision);
	fprintf(tempo,"\tBIOS Build Rev\t: %d\n", Config.usRromBIOSBuildRevision);
	fprintf(tempo,"\tBIOS Rel Revision: %d\n", Config.usRromBIOSReleaseRevision);





}

void DisplayCntlrStatus(CSMI_SAS_CNTLR_STATUS Status)
{



//	printf("\tStatus\t\t: ");
	print_to_file(fp,"\tStatus\t\t: ");

	fprintf(tempo,"\tStatus\t\t: ");
 	switch(Status.uStatus){
		case CSMI_SAS_CNTLR_STATUS_GOOD:
			//printf("Good [%d] \n",Status.uStatus);
			print_to_file(fp,"Good [%d] \n",Status.uStatus);
			fprintf(tempo,"Good [%d] \n",Status.uStatus);
			break;
		case CSMI_SAS_CNTLR_STATUS_FAILED:
			//printf("Failed [%d] \n",Status.uStatus);
			print_to_file(fp,"Failed [%d] \n",Status.uStatus);
			fprintf(tempo,"Failed [%d] \n",Status.uStatus);
			break;
		case CSMI_SAS_CNTLR_STATUS_OFFLINE:
			//printf("Offline [%d] \n",Status.uStatus);
			print_to_file(fp,"Offline [%d] \n",Status.uStatus);
			fprintf(tempo,"Offline [%d] \n",Status.uStatus);
			break;
		case CSMI_SAS_CNTLR_STATUS_POWEROFF:
			//printf("Power OFF [%d] \n",Status.uStatus);
			print_to_file(fp,"Power OFF [%d] \n",Status.uStatus);
			fprintf(tempo,"Power OFF [%d] \n",Status.uStatus);
			break;
		default:
			//printf("Unknown!! [%d]  \n",Status.uStatus);
			print_to_file(fp,"Unknown!! [%d]  \n",Status.uStatus);
			fprintf(tempo,"Unknown!! [%d]  \n",Status.uStatus);
			break;
	}

	// Do not print reason for offline if controller is not offline
	// if (Status.uStatus != CSMI_SAS_CNTLR_STATUS_OFFLINE)
		// return;

//	printf("\n\tReason for Offline\t: ");
	print_to_file(fp,"\n\tReason for Offline\t: ");
	fprintf(tempo,"\n\tReason for Offline\t: ");

	switch(Status.uOfflineReason){
		case CSMI_SAS_OFFLINE_REASON_NO_REASON:
//			printf("No Reason [%d] \n",Status.uOfflineReason);
			print_to_file(fp,"No Reason [%d] \n",Status.uOfflineReason);
			fprintf(tempo,"No Reason [%d] \n",Status.uOfflineReason);
			break;
		case CSMI_SAS_OFFLINE_REASON_INITIALIZING:
//			printf("Initializing [%d] \n",Status.uOfflineReason);
			print_to_file(fp,"Initializing [%d] \n",Status.uOfflineReason);
			fprintf(tempo,"Initializing [%d] \n",Status.uOfflineReason);
			break;
		case CSMI_SAS_OFFLINE_REASON_BACKSIDE_BUS_DEGRADED:
//			printf("Backside Bus Degraded [%d] \n",Status.uOfflineReason);
			print_to_file(fp,"Backside Bus Degraded [%d] \n",Status.uOfflineReason);
			fprintf(tempo,"Backside Bus Degraded [%d] \n",Status.uOfflineReason);

			break;
		case CSMI_SAS_OFFLINE_REASON_BACKSIDE_BUS_FAILURE:
//			printf("Backside Bus Failure [%d] \n",Status.uOfflineReason);
			print_to_file(fp,"Backside Bus Failure [%d] \n",Status.uOfflineReason);
			fprintf(tempo,"Backside Bus Failure [%d] \n",Status.uOfflineReason);
			break;
	}


}






void DisplayRaidInfo(CSMI_SAS_RAID_INFO Info)
{



//	printf("\tNumber of Raid Sets\t: %d\n", Info.uNumRaidSets);
//	printf("\tMax Drives per Set\t: %d\n", Info.uMaxDrivesPerSet);

	print_to_file(fp,"\tNumber of Raid Sets\t: %d\n", Info.uNumRaidSets);
	//print_to_file(fp,"\tMax Drives per Set\t: %d\n", Info.uMaxDrivesPerSet);

	fprintf(tempo,"\tNumber of Raid Sets\t: %d\n", Info.uNumRaidSets);
	//fprintf(tempo,"\tMax Drives per Set\t: %d\n", Info.uMaxDrivesPerSet);


//	fprintf(tempo,   "\tNumber of Raid Sets                  \t: %d\n",  Info.uNumRaidSets);
	fprintf(tempo,   "\tMax Drives per Set                  \t: %d\n",  Info.uMaxDrivesPerSet);

	print_to_file(fp,"\tMax RAID SETS supported              \t: %d\n",  Info.uMaxRaidSets);
	fprintf(tempo,   "\tMax RAID SETS supported              \t: %d\n",  Info.uMaxRaidSets);

	print_to_file(fp,"\tMax RAID Types supported             \t: %d\n",  Info.bMaxRaidTypes);
	fprintf(tempo,   "\tMax RAID Types supported             \t: %d\n",  Info.bMaxRaidTypes);

	print_to_file(fp,"\tMin Logical User Blocks in a RAID SET (LOW)\t: %ld\n", Info.ulMinRaidSetBlocks.uLowPart);
	fprintf(tempo,   "\tMin Logical User Blocks in a RAID SET (LOW)\t: %ld\n", Info.ulMinRaidSetBlocks.uLowPart);
	print_to_file(fp,"\tMin Logical User Blocks in a RAID SET (HIGH)\t: %ld\n", Info.ulMinRaidSetBlocks.uHighPart);
	fprintf(tempo,   "\tMin Logical User Blocks in a RAID SET (HIGH)\t: %ld\n", Info.ulMinRaidSetBlocks.uHighPart);

	print_to_file(fp,"\tMax Logical User Blocks in a RAID SET (LOW)\t: %ld\n", Info.ulMaxRaidSetBlocks.uLowPart);
	fprintf(tempo,   "\tMax Logical User Blocks in a RAID SET (LOW) \t: %ld\n", Info.ulMaxRaidSetBlocks.uLowPart);
	print_to_file(fp,"\tMax Logical User Blocks in a RAID SET (HIGH)\t: %ld\n", Info.ulMaxRaidSetBlocks.uHighPart);
	fprintf(tempo,   "\tMax Logical User Blocks in a RAID SET (HIGH) \t: %ld\n", Info.ulMaxRaidSetBlocks.uHighPart);

	print_to_file(fp,"\tMax Physical Drives Supported        \t: %d\n",  Info.uMaxPhysicalDrives);
	fprintf(tempo,   "\tMax Physical Drives Supported        \t: %d\n",  Info.uMaxPhysicalDrives);

	print_to_file(fp,"\tMax Extents per Physical drive       \t: %d\n",  Info.uMaxExtents);
	fprintf(tempo,   "\tMax Extents per Physical drive       \t: %d\n",  Info.uMaxExtents);

	print_to_file(fp,"\tMax Cache Modules Supported          \t: %d\n",  Info.uMaxModules);
	fprintf(tempo,   "\tMax Cache Modules Supported          \t: %d\n",  Info.uMaxModules);

	print_to_file(fp,"\tMax RAID SET Transformation Memory   \t: %d\n",  Info.uMaxTransformationMemory);
	fprintf(tempo,   "\tMax RAID SET Transformation Memory   \t: %d\n",  Info.uMaxTransformationMemory);

	print_to_file(fp,"\tChangeCount                           \t: %d\n",  Info.uChangeCount);
	fprintf(tempo,   "\tChangeCount                           \t: %d\n",  Info.uChangeCount);

	

}


void DisplayRaidConfig(CSMI_SAS_RAID_CONFIG *raidConfig)
{

	CSMI_SAS_RAID_DRIVES *Drives;
	int index = 0;
        int i = 0;





//	printf("RaidSetIndex                   : %d\n", raidConfig->uRaidSetIndex);
//		 printf("Capacity of RAID set           : %d\n", raidConfig->uCapacity);
//		 printf("Strip size of RAID set         : %d\n", raidConfig->uStripeSize);


		 print_to_file(fp,"RaidSetIndex                   : %d\n", raidConfig->uRaidSetIndex);
		 print_to_file(fp,"Capacity of RAID set           : %d\n", raidConfig->uCapacity);
		 print_to_file(fp,"Strip size of RAID set         : %d\n", raidConfig->uStripeSize);

 		 fprintf(tempo,"RaidSetIndex                   : %d\n", raidConfig->uRaidSetIndex);
		 fprintf(tempo,"Capacity of RAID set           : %d\n", raidConfig->uCapacity);
		 fprintf(tempo,"Strip size of RAID set         : %d\n", raidConfig->uStripeSize);



	switch(raidConfig->bRaidType)
	{
	case CSMI_SAS_RAID_TYPE_NONE:
//		printf("Raid type                      : No raid [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : No raid [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : No raid [%d] \n",raidConfig->bRaidType);
		break;

	case CSMI_SAS_RAID_TYPE_0:
//		printf("Raid type                      : 0 [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 0 [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 0 [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_1:
//		printf("Raid type                      : 1 [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 1 [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 1 [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_10:
//		printf("Raid type                      : 10 [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 10 [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 10 [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_5:
//		printf("Raid type                      : 5 [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 5 [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 5 [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_15:
//		printf("Raid type                      : 15 [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 15 [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 15 [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_6:
//		printf("Raid type                      : 6 [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 6 [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 6 [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_50:
//		printf("Raid type                      : 50 [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 50 [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 50 [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_VOLUME:
//		printf("Raid type                      : VOLUME [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : VOLUME [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : VOLUME [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_1E:
//		printf("Raid type                      : 1E [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : 1E [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : 1E [%d] \n",raidConfig->bRaidType);
		break;
	case CSMI_SAS_RAID_TYPE_OTHER:
//		printf("Raid type                      : Other [%d] \n",raidConfig->bRaidType);
		print_to_file(fp,"Raid type                      : Other [%d] \n",raidConfig->bRaidType);
		fprintf(tempo,"Raid type                      : Other [%d] \n",raidConfig->bRaidType);
		break;
	}

	switch(raidConfig->bStatus)
	{
	case CSMI_SAS_RAID_SET_STATUS_OK:
		//printf("Raid status                    : OK [%d] \n",raidConfig->bStatus);
		print_to_file(fp,"Raid status                    : OK [%d] \n",raidConfig->bStatus);
		fprintf(tempo,"Raid status                    : OK [%d] \n",raidConfig->bStatus);
		break;
	case CSMI_SAS_RAID_SET_STATUS_DEGRADED:
		//printf("Raid status                    : DEGRADED [%d] \n",raidConfig->bStatus);
		print_to_file(fp,"Raid status                    : DEGRADED [%d] \n",raidConfig->bStatus);
		fprintf(tempo,"Raid status                    : DEGRADED [%d] \n",raidConfig->bStatus);
		break;
	case CSMI_SAS_RAID_SET_STATUS_REBUILDING:
		//printf("Raid status                    : REBUILDING [%d] \n",raidConfig->bStatus);
		print_to_file(fp,"Raid status                    : REBUILDING [%d] \n",raidConfig->bStatus);
		fprintf(tempo,"Raid status                    : REBUILDING [%d] \n",raidConfig->bStatus);
		break;

	case CSMI_SAS_RAID_SET_STATUS_FAILED:
		//printf("Raid status                    : FAILED [%d] \n",raidConfig->bStatus);
		print_to_file(fp,"Raid status                    : FAILED [%d] \n",raidConfig->bStatus);
		fprintf(tempo,"Raid status                    : FAILED [%d] \n",raidConfig->bStatus);
		break;
	}

//	printf("Information                    : %d\n",raidConfig->bInformation);
//	printf("Drive count                    : %d\n",raidConfig->bDriveCount);

	print_to_file(fp,"Information                    : %d\n",raidConfig->bInformation);
	print_to_file(fp,"Drive count                    : %d\n",raidConfig->bDriveCount);

	fprintf(tempo,"Information                    : %d\n",raidConfig->bInformation);
	fprintf(tempo,"Drive count                    : %d\n",raidConfig->bDriveCount);



	Drives = (CSMI_SAS_RAID_DRIVES*)&(raidConfig->Drives);

	if(raidConfig->bDataType == CSMI_SAS_RAID_DATA_DRIVES)
	{

		for(index=0;(index < raidConfig->bDriveCount) && (index < 240) ;index++) {
/*			printf("\n----------------------------------------------\n");
			printf("Drive model                : %s\n",Drives[index].bModel);
			printf("Drive firmware designation : %s\n",Drives[index].bFirmware);
			printf("Drive serial number        : %s\n",Drives[index].bSerialNumber);
			printf("Drive SAS address          : %x\n",(unsigned int) Drives[index].bSASAddress);
			printf("Drive SAS LUN              : %d\n",(int) Drives[index].bSASLun); */
	
	
			print_to_file(fp,"\n----------------------------------------------\n");
			print_to_file(fp,"Drive model                : %s\n",Drives[index].bModel);
			print_to_file(fp,"Drive firmware designation : %s\n",Drives[index].bFirmware);
			print_to_file(fp,"Drive serial number        : %s\n",Drives[index].bSerialNumber);
			print_to_file(fp,"Drive SAS address          : ");
	  		for(i=0;i<8;i++)
        		{
                		print_to_file(fp,"%02x ",(unsigned int) Drives[index].bSASAddress[i]);
	        	}

			print_to_file(fp,"\nDrive SAS LUN              : ");
			for(i=0;i<8;i++)
	                {
        	                print_to_file(fp,"%02x ",(unsigned int) Drives[index].bSASLun[i]);
                	}
	
	
			fprintf(tempo,"\n----------------------------------------------\n");
			fprintf(tempo,"Drive model                : %s\n",Drives[index].bModel);
			fprintf(tempo,"Drive firmware designation : %s\n",Drives[index].bFirmware);
			fprintf(tempo,"Drive serial number        : %s\n",Drives[index].bSerialNumber);
                	fprintf(tempo,"Drive SAS address          : ");
	                for(i=0;i<8;i++)
        	        {
                	        fprintf(tempo,"%02x ",(unsigned int) Drives[index].bSASAddress[i]);
	                }
	
        	        fprintf(tempo,"\nDrive SAS LUN\t\t: ");
                	for(i=0;i<8;i++)
	                {
        	                fprintf(tempo,"%02x ",(unsigned int) Drives[index].bSASLun[i]);
	                }
	
        	        print_to_file(fp,"\n");
                	fprintf(tempo,"\n");


	
	
			switch(Drives[index].bDriveStatus)
			{

			case CSMI_SAS_DRIVE_STATUS_OK:
//				printf("Drive status           : OK [%d] \n",Drives[index].bDriveStatus);
				print_to_file(fp,"Drive status\t\t: OK [%d] \n",Drives[index].bDriveStatus);
				fprintf(tempo,   "Drive status\t\t: OK [%d] \n",Drives[index].bDriveStatus);
				break;

			case CSMI_SAS_DRIVE_STATUS_DEGRADED:
//				printf("Drive status           : DEGRADED [%d] \n",Drives[index].bDriveStatus);
				print_to_file(fp,"Drive status\t\t: DEGRADED [%d] \n",Drives[index].bDriveStatus);
				fprintf(tempo,   "Drive status\t\t: DEGRADED [%d] \n",Drives[index].bDriveStatus);
				break;

			case CSMI_SAS_DRIVE_STATUS_REBUILDING:
//				printf("Drive status           : REBUILDING [%d] \n",Drives[index].bDriveStatus);
				print_to_file(fp,"Drive status\t\t: REBUILDING [%d] \n",Drives[index].bDriveStatus);
				fprintf(tempo,"Drive status\t\t: REBUILDING [%d] \n",Drives[index].bDriveStatus);
				break;

			case CSMI_SAS_DRIVE_STATUS_FAILED:
//				printf("Drive status           : FAILED [%d] \n",Drives[index].bDriveStatus);
				print_to_file(fp,"Drive status\t\t: FAILED [%d] \n",Drives[index].bDriveStatus);
				fprintf(tempo,"Drive status\t\t: FAILED [%d] \n",Drives[index].bDriveStatus);
				break;
			}



			switch(Drives[index].bDriveUsage)
			{
			case CSMI_SAS_DRIVE_CONFIG_NOT_USED:
//				printf("Drive usage            : Not used [%d] \n",Drives[index].bDriveUsage);
				print_to_file(fp,"Drive usage\t\t: Not used [%d] \n",Drives[index].bDriveUsage);
				fprintf(tempo,"Drive usage\t\t: Not used [%d] \n",Drives[index].bDriveUsage);
				break;
			case CSMI_SAS_DRIVE_CONFIG_MEMBER:
//				printf("Drive usage            : Part of RAID set [%d] \n",Drives[index].bDriveUsage);
				print_to_file(fp,"Drive usage\t\t: Part of RAID set [%d] \n",Drives[index].bDriveUsage);
				fprintf(tempo,"Drive usage\t\t: Part of RAID set [%d] \n",Drives[index].bDriveUsage);
				break;
			case CSMI_SAS_DRIVE_CONFIG_SPARE:
//				printf("Drive usage            : Part of RAID set as a hot swap spare [%d] \n",Drives[index].bDriveUsage);
				print_to_file(fp,"Drive usage\t\t: Part of RAID set as a hot swap spare [%d] \n",Drives[index].bDriveUsage);
				fprintf(tempo,"Drive usage\t\t: Part of RAID set as a hot swap spare [%d] \n",Drives[index].bDriveUsage);
				break;
			}
			switch(Drives[index].bDriveType){
				case CSMI_SAS_DRIVE_TYPE_UNKNOWN:
					print_to_file(fp, "Drive Type\t\t: UNKNOWN or Not Supproted\n");
					fprintf(tempo   , "Drive Type\t\t: UNKNOWN or Not Supproted\n");
					break;
				case CSMI_SAS_DRIVE_TYPE_SINGLE_PORT_SAS:
					print_to_file(fp, "Drive Type\t\t: SINGLE PORT SAS (supports SSP protocol)\n");
					fprintf(tempo   , "Drive Type\t\t: SINGLE PORT SAS (supports SSP protocol)\n");
					break;
				case CSMI_SAS_DRIVE_TYPE_DUAL_PORT_SAS:
					print_to_file(fp, "Drive Type\t\t: DUAL PORT SAS (supports SSP protocol)\n");
					fprintf(tempo   , "Drive Type\t\t: DUAL PORT SAS (supports SSP protocol)\n");
					break;
				case CSMI_SAS_DRIVE_TYPE_SATA:
					print_to_file(fp, "Drive Type\t\t: SATA (Single Port supports STP protocol)\n");
					fprintf(tempo   , "Drive Type\t\t: SATA (Single Port supports STP protocol)\n");
					break;
				case CSMI_SAS_DRIVE_TYPE_SATA_PS:
					print_to_file(fp, "Drive Type\t\t: SATA Drive is behind a SATA Port Selector\n");
					fprintf(tempo   , "Drive Type\t\t: SATA Drive is behind a SATA Port Selector\n");
					break;
				case CSMI_SAS_DRIVE_TYPE_OTHER:
					print_to_file(fp, "Drive Type\t\t: OTHER\n");
					fprintf(tempo   , "Drive Type\t\t: OTHER\n");
					break;
			}
			
			print_to_file(fp , "Block Size\t\t: %d\n", Drives[index].usBlockSize);
			fprintf(tempo     , "Block Size\t\t: %d\n", Drives[index].usBlockSize);
			
			
			print_to_file(fp , "Drive Index\t\t: ");
			fprintf(tempo    , "Drive Index\t\t: ");
		
			if(Drives[index].bDriveType == CSMI_SAS_DRIVE_TYPE_UNKNOWN){
				print_to_file(fp , "Field Not Supported\n");
				fprintf(tempo    , "Field Not Supported\n");
			}else {
				print_to_file(fp ,"%d", Drives[index].uDriveIndex); 
				fprintf(tempo    ,"%d",Drives[index].uDriveIndex);
			}

			//printf("\n----------------------------------------------\n");
			print_to_file(fp,"\n----------------------------------------------\n");
			fprintf(tempo,"\n----------------------------------------------\n");
		
		}
		
	}
	else if(raidConfig->bDataType == CSMI_SAS_RAID_DATA_DEVICE_ID){
		print_to_file(fp,"\n----------------------------------------------\n");
		fprintf(fp      ,"\n----------------------------------------------\n");		
		display_device_id(raidConfig);
		print_to_file(fp,"\n----------------------------------------------\n");
		fprintf(tempo,"\n----------------------------------------------\n");
	}
	else if(raidConfig->bDataType == CSMI_SAS_RAID_DATA_ADDITIONAL_DATA){
		print_to_file(fp,"\n----------------------------------------------\n");
		fprintf(tempo,"\n----------------------------------------------\n");
		display_additional_config_data((CSMI_SAS_RAID_SET_ADDITIONAL_DATA*)&(raidConfig->Data));
		print_to_file(fp,"\n----------------------------------------------\n");
		fprintf(tempo,"\n----------------------------------------------\n");
	}
	
    }









void display_device_id(CSMI_SAS_RAID_CONFIG *raid_config)
{
	print_to_file(fp , "VPD Page\t\t: %d\n",raid_config->DeviceId[0].bDeviceIdentificationVPDPage);
	fprintf(tempo     , "VPD Page\t\t: %d\n",raid_config->DeviceId[0].bDeviceIdentificationVPDPage);	
}

void display_additional_config_data(CSMI_SAS_RAID_SET_ADDITIONAL_DATA* add_data)
{
	int i;
	
	print_to_file(fp , "RAID SET Label\t\t: %s\n", add_data->bLabel);
	fprintf(tempo    , "RAID SET Label\t\t: %s\n", add_data->bLabel);

	print_to_file( fp , "RAID SET LUN\t\t: ");
	fprintf(tempo     , "RAID SET LUN\t\t: ");
	for(i = 0 ; i < 8 ; i++) {
		print_to_file(fp , "%02x ",add_data->bRaidSetLun[i]);
		fprintf(tempo     , "%02x ",add_data->bRaidSetLun[i]);
	}
	print_to_file( fp ,"\n");
	fprintf(tempo     ,"\n");

	print_to_file( fp ,"RAID SET Write Protect State\t: ");
	fprintf(tempo     ,"RAID SET Write Protect State\t: ");

	switch(add_data->bWriteProtection){
		case CSMI_SAS_RAID_SET_WRITE_PROTECT_ENABLED:
			print_to_file( fp ,"Enabled\n");
			fprintf(tempo     ,"Enabled\n");
			break;
		case CSMI_SAS_RAID_SET_WRITE_PROTECT_DISABLED:
			print_to_file( fp ,"Diabled\n");
			fprintf(tempo     ,"Diabled\n");
			break;
		case CSMI_SAS_RAID_SET_WRITE_PROTECT_UNKNOWN:
			print_to_file( fp ,"Unknown or Not Supported\n");
			fprintf(tempo     ,"Unknown or Not Supported\n");
			break;
	}	
	
	print_to_file( fp ,"RAID SET Cache State\t: ");
	fprintf(tempo     ,"RAID SET Cache State\t: ");

	switch(add_data->bCacheSetting){
		printf("CACHe setting : %d\n",add_data->bCacheSetting);
		case CSMI_SAS_RAID_SET_CACHE_ENABLED:
			print_to_file( fp ,"Caching Enabled\n");
			fprintf(tempo     ,"Caching Enabled\n");
			break;
		case CSMI_SAS_RAID_SET_CACHE_DISABLED:
			print_to_file( fp ,"Caching Disabled\n");
			fprintf(tempo     ,"Caching Disabled\n");
			break;
		case CSMI_SAS_RAID_SET_CACHE_CORRUPT:
			print_to_file( fp ,"Corrupted\n");
			fprintf(tempo     ,"Corrupted\n");
			break;
		case CSMI_SAS_RAID_SET_CACHE_UNKNOWN:
			print_to_file( fp ,"Unknown or Not Supported\n");
			fprintf(tempo     ,"Unknown or Not Supported\n");
			break;
	}

	print_to_file( fp ,"RAID SET Cache Ratio(write to read)\t: %d%%\n", add_data->bCacheRatio);
	fprintf(tempo     ,"RAID SET Cache Ratio(write to read)\t: %d%%\n", add_data->bCacheRatio);

	print_to_file( fp ,"RAID SET Block Size\t: %d\n", add_data->usBlockSize);
	fprintf(tempo     ,"RAID SET Block Size\t: %d\n", add_data->usBlockSize);
	
	print_to_file( fp ,"RAID SET Extent Offset\t: (LOW) %ld\n", add_data->ulRaidSetExtentOffset.uLowPart);
	fprintf(tempo     ,"RAID SET Extent Offset\t: (LOW) %ld\n", add_data->ulRaidSetExtentOffset.uLowPart);
	print_to_file( fp ,"RAID SET Extent Offset\t: (HIGH) %ld\n", add_data->ulRaidSetExtentOffset.uHighPart);
	fprintf(tempo     ,"RAID SET Extent Offset\t: (HIGH) %ld\n", add_data->ulRaidSetExtentOffset.uHighPart);

	print_to_file( fp ,"RAID SET User Blocks\t: (LOW) %ld\n", add_data->ulRaidSetBlocks.uLowPart);
	fprintf(tempo     ,"RAID SET User Blocks\t: (LOW) %ld\n", add_data->ulRaidSetBlocks.uLowPart);
	print_to_file( fp ,"RAID SET User Blocks\t: (HIGH) %ld\n", add_data->ulRaidSetBlocks.uHighPart);
	fprintf(tempo     ,"RAID SET User Blocks\t: (HIGH) %ld\n", add_data->ulRaidSetBlocks.uHighPart);

	print_to_file( fp ,"RAID SET StripSize(in Blocks)\t: %d\n", add_data->uStripeSizeInBlocks);
	fprintf(tempo     ,"RAID SET StripSize(in Blocks)\t: %d\n", add_data->uStripeSizeInBlocks);

	print_to_file( fp ,"RAID SET SectorsPerTrack\t: %d\n", add_data->uSectorsPerTrack);
	fprintf(tempo     ,"RAID SET SectorsPerTrack\t: %d\n", add_data->uSectorsPerTrack);

	print_to_file( fp ,"RAID SET ScratchPad\t: %s\n", add_data->bApplicationScratchPad);
	fprintf(tempo     ,"RAID SET ScratchPad\t: %s\n", add_data->bApplicationScratchPad);
	
	print_to_file(fp , "Number Of Heads\t\t: %d\n", add_data->uNumberOfHeads);
	fprintf(tempo     , "Number Of Heads\t\t: %d\n", add_data->uNumberOfHeads);
	
	print_to_file(fp , "Number Of Tracks\t\t: %d\n", add_data->uNumberOfTracks);
	fprintf(tempo     , "Number Of Tracks\t\t: %d\n", add_data->uNumberOfTracks);
}
void DisplaySASIdentify(CSMI_SAS_IDENTIFY Identify)
{
	int i;
//	printf("\tDevice Type             : ");
	print_to_file(fp,"\tDevice Type             : ");
	fprintf(tempo,"\tDevice Type             : ");
	switch(Identify.bDeviceType){
		case CSMI_SAS_PHY_UNUSED:
			//printf("Phy Unused. [%d] \n",Identify.bDeviceType);
			print_to_file(fp,"Phy Unused. [%d] \n",Identify.bDeviceType);
			fprintf(tempo,"Phy Unused. [%d] \n",Identify.bDeviceType);
			break;
		case CSMI_SAS_END_DEVICE:
			//printf("SAS End Device. [%d] \n",Identify.bDeviceType);
			print_to_file(fp,"SAS End Device. [%d] \n",Identify.bDeviceType);
			fprintf(tempo,"SAS End Device. [%d] \n",Identify.bDeviceType);
			break;
		default:
			//printf("Undefined. [%d] \n",Identify.bDeviceType);
			print_to_file(fp,"Undefined. [%d] \n",Identify.bDeviceType);
			fprintf(tempo,"Undefined. [%d] \n",Identify.bDeviceType);
			break;
	}
//	printf("\tInitiator Port Protocol : ");
	print_to_file(fp,"\tInitiator Port Protocol : ");
	fprintf(tempo,"\tInitiator Port Protocol : ");
	PrintProtocol(Identify.bInitiatorPortProtocol);
	//printf("\tTarget Port Protocol    : ");
	print_to_file(fp,"\tTarget Port Protocol    : ");
	fprintf(tempo,"\tTarget Port Protocol    : ");
	PrintProtocol(Identify.bTargetPortProtocol);
	//printf("\tSAS Address             : ");
	print_to_file(fp,"\tSAS Address             : ");
	fprintf(tempo,"\tSAS Address             : ");
	for(i=0;i<8;i++)
	{
		//printf("%02x ", Identify.bSASAddress[i]);
		print_to_file(fp,"%02x ", Identify.bSASAddress[i]);
		fprintf(tempo,"%02x ", Identify.bSASAddress[i]);
	}
	//printf("\n");
	//printf("\tPhy Identifier          : %d \n", Identify.bPhyIdentifier);
	print_to_file(fp,"\n");
	print_to_file(fp,"\tPhy Identifier          : %d \n", Identify.bPhyIdentifier);
	fprintf(tempo,"\n");
	fprintf(tempo,"\tPhy Identifier          : %d \n", Identify.bPhyIdentifier);
}


void DisplayPhyInfo(CSMI_SAS_PHY_INFO Info)
{
	int PhyIndex;

	//printf("\tTotal number of Phy = %d \n\n", Info.bNumberOfPhys);
	print_to_file(fp,"\tTotal number of Phy = %d \n\n", Info.bNumberOfPhys);
	fprintf(tempo,"\tTotal number of Phy = %d \n\n", Info.bNumberOfPhys);

	for(PhyIndex = 0; PhyIndex < Info.bNumberOfPhys; PhyIndex++)
	{
/*		printf("\t-------------------------------------------------\n");
		printf("\tPort Identifier         : %d \n", Info.Phy[PhyIndex].bPortIdentifier);
		printf("\tNegotiated Link Rate    : "); */


		print_to_file(fp,"\t-------------------------------------------------\n");
		print_to_file(fp,"\tPort Identifier         : %d \n", Info.Phy[PhyIndex].bPortIdentifier);
		print_to_file(fp,"\tNegotiated Link Rate    : ");


		fprintf(tempo,"\t-------------------------------------------------\n");
		fprintf(tempo,"\tPort Identifier         : %d \n", Info.Phy[PhyIndex].bPortIdentifier);
		fprintf(tempo,"\tNegotiated Link Rate    : ");


		PrintLinkRate(Info.Phy[PhyIndex].bNegotiatedLinkRate);
/* EDM - Link Rate Bit Definition
 * bit [3:0] Hardware Link Rate
 * bit [7:4] Programmed Link Rate
 */
		//printf("\tMinimum Programmed Link Rate       : ");
		print_to_file(fp,"\tMinimum Programmed Link Rate       : ");
		fprintf(tempo,"\tMinimum Programmed Link Rate       : ");
		PrintLinkRate((unsigned char)(Info.Phy[PhyIndex].bMinimumLinkRate >> 4));
		//printf("\tMaximum Programmed Link Rate       : ");
		print_to_file(fp,"\tMaximum Programmed Link Rate       : ");
		fprintf(tempo,"\tMaximum Programmed Link Rate       : ");
		PrintLinkRate((unsigned char)(Info.Phy[PhyIndex].bMaximumLinkRate >> 4));
		//printf("\tMinimum Hardware Link Rate       : ");
		print_to_file(fp,"\tMinimum Hardware Link Rate       : ");
		fprintf(tempo,"\tMinimum Hardware Link Rate       : ");
		PrintLinkRate((unsigned char)(Info.Phy[PhyIndex].bMinimumLinkRate & 0xF));
		//printf("\tMaximum Hardware Link Rate       : ");
		print_to_file(fp,"\tMaximum Hardware Link Rate       : ");
		fprintf(tempo,"\tMaximum Hardware Link Rate       : ");
		PrintLinkRate((unsigned char)(Info.Phy[PhyIndex].bMaximumLinkRate & 0xF));
		//printf("\t# of BROADCASE(CHANGE) primitives: %d \n", Info.Phy[PhyIndex].bPhyChangeCount);
		print_to_file(fp,"\t# of BROADCASE(CHANGE) primitives: %d \n", Info.Phy[PhyIndex].bPhyChangeCount);
		fprintf(tempo,"\t# of BROADCASE(CHANGE) primitives: %d \n", Info.Phy[PhyIndex].bPhyChangeCount);
		//printf("\tState of Auto Discover  : ");
		print_to_file(fp,"\tState of Auto Discover  : ");
		fprintf(tempo,"\tState of Auto Discover  : ");
		PrintAutoDiscoverState(Info.Phy[PhyIndex].bAutoDiscover);
		//printf("\n");
		print_to_file(fp,"\n");
		fprintf(tempo,"\n");
		//printf("\tInfo transfered to the attached device during a link reset:\n");
		print_to_file(fp,"\tInfo transfered to the attached device during a link reset:\n");
		fprintf(tempo,"\tInfo transfered to the attached device during a link reset:\n");
		DisplaySASIdentify(Info.Phy[PhyIndex].Identify);
		//printf("\n");
		print_to_file(fp,"\n");
		fprintf(tempo,"\n");
		//printf("\tInformation about the attached device: \n");
		print_to_file(fp,"\tInformation about the attached device: \n");
		fprintf(tempo,"\tInformation about the attached device: \n");
		DisplaySASIdentify(Info.Phy[PhyIndex].Attached);
		//printf("\n");
		print_to_file(fp,"\n");
		fprintf(tempo,"\n");
	}
}


void DisplaySetPhyInfo(CSMI_SAS_SET_PHY_INFO PhyInfo)
{

	//printf("\tPhy Identifier : %d \n", PhyInfo.bPhyIdentifier);
	//printf("\tNeg Link Rate  : ");

	print_to_file(fp,"\tPhy Identifier : %d \n", PhyInfo.bPhyIdentifier);
	print_to_file(fp,"\tNeg Link Rate  : ");

	fprintf(tempo,"\tPhy Identifier : %d \n", PhyInfo.bPhyIdentifier);
	fprintf(tempo,"\tNeg Link Rate  : ");


	switch(PhyInfo.bNegotiatedLinkRate){
		case CSMI_SAS_LINK_RATE_NEGOTIATE:
			//printf("Negotiate a new link rate [%d] \n",PhyInfo.bNegotiatedLinkRate);
			print_to_file(fp,"Negotiate a new link rate [%d] \n",PhyInfo.bNegotiatedLinkRate);
			fprintf(tempo,"Negotiate a new link rate [%d] \n",PhyInfo.bNegotiatedLinkRate);
			break;
		case CSMI_SAS_LINK_RATE_PHY_DISABLED:
			//printf("Disable the Phy [%d]  \n",PhyInfo.bNegotiatedLinkRate);
			print_to_file(fp,"Disable the Phy [%d]  \n",PhyInfo.bNegotiatedLinkRate);
			fprintf(tempo,"Disable the Phy [%d]  \n",PhyInfo.bNegotiatedLinkRate);
			break;
	}
	//printf("Min Link Rate   : ");
	print_to_file(fp,"Min Link Rate   : ");
	fprintf(tempo,"Min Link Rate   : ");
	PrintLinkRate(PhyInfo.bProgrammedMinimumLinkRate);
	//intf("Max Link Rate   : ");
	print_to_file(fp,"Max Link Rate   : ");
	fprintf(tempo,"Max Link Rate   : ");
	PrintLinkRate(PhyInfo.bProgrammedMaximumLinkRate);
}


void DisplayErrorInfo(CSMI_SAS_LINK_ERRORS Info)
{
/*	printf("\tPhy Identifier\t\t: %d \n", Info.bPhyIdentifier);
	printf("\tReset Counts\t\t: %d \n", Info.bResetCounts);
	printf("\tInvalid dwords\t\t: %d \n", Info.uInvalidDwordCount);
	printf("\tDisparity Errors\t: %d \n", Info.uRunningDisparityErrorCount);
	printf("\tLoss of dword sync\t: %d \n", Info.uLossOfDwordSyncCount);
	printf("\tPhy Reset Problem\t: %d \n", Info.uPhyResetProblemCount); */


	print_to_file(fp,"\tPhy Identifier\t\t: %d \n", Info.bPhyIdentifier);
	print_to_file(fp,"\tReset Counts\t\t: %d \n", Info.bResetCounts);
	print_to_file(fp,"\tInvalid dwords\t\t: %d \n", Info.uInvalidDwordCount);
	print_to_file(fp,"\tDisparity Errors\t: %d \n", Info.uRunningDisparityErrorCount);
	print_to_file(fp,"\tLoss of dword sync\t: %d \n", Info.uLossOfDwordSyncCount);
	print_to_file(fp,"\tPhy Reset Problem\t: %d \n", Info.uPhyResetProblemCount);


	fprintf(tempo,"\tPhy Identifier\t\t: %d \n", Info.bPhyIdentifier);
	fprintf(tempo,"\tReset Counts\t\t: %d \n", Info.bResetCounts);
	fprintf(tempo,"\tInvalid dwords\t\t: %d \n", Info.uInvalidDwordCount);
	fprintf(tempo,"\tDisparity Errors\t: %d \n", Info.uRunningDisparityErrorCount);
	fprintf(tempo,"\tLoss of dword sync\t: %d \n", Info.uLossOfDwordSyncCount);
	fprintf(tempo,"\tPhy Reset Problem\t: %d \n", Info.uPhyResetProblemCount);

}

void DisplaySignature(CSMI_SAS_SATA_SIGNATURE Signature)
{
	int i;

//	printf("\tPhy Identifier\t: %d \n", Signature.bPhyIdentifier);
	print_to_file(fp,"\tPhy Identifier\t: %d \n", Signature.bPhyIdentifier);
	fprintf(tempo,"\tPhy Identifier\t: %d \n", Signature.bPhyIdentifier);
/*	printf("\tSignature\t: <%s> \n", Signature.bSignatureFIS);*/
//	printf("\tSignature\t: ");
	print_to_file(fp,"\tSignature\t: ");
	fprintf(tempo,"\tSignature\t: ");
	for(i=0;i<20;i++)
	{
		//printf("%02x ", Signature.bSignatureFIS[i]);
		print_to_file(fp,"%02x ", Signature.bSignatureFIS[i]);
		fprintf(tempo,"%02x ", Signature.bSignatureFIS[i]);
	}
	//printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");
}

void DisplaySCSIAddr(CSMI_SAS_GET_SCSI_ADDRESS_BUFFER *ScsiAddrBuff)
{
	int i;
	//printf("\tSAS Address\t: ");
	print_to_file(fp,"\tSAS Address\t: ");
	fprintf(tempo,"\tSAS Address\t: ");
	for(i=0; i<8; i++)
	{
		//printf("%02x ", ScsiAddrBuff->bSASAddress[i]);
		print_to_file(fp,"%02x ", ScsiAddrBuff->bSASAddress[i]);
		fprintf(tempo,"%02x ", ScsiAddrBuff->bSASAddress[i]);
	}
	//printf("\n\tSAS LUN\t\t: ");
	print_to_file(fp,"\n\tSAS LUN\t\t: ");
	fprintf(tempo,"\n\tSAS LUN\t\t: ");
	for(i=0; i<8; i++)
	{
		//printf("%02x ", ScsiAddrBuff->bSASLun[i]);
		print_to_file(fp,"%02x ", ScsiAddrBuff->bSASLun[i]);
		fprintf(tempo,"%02x ", ScsiAddrBuff->bSASLun[i]);
	}
	/*printf("\n\tHost Index\t: %d\n", ScsiAddrBuff->bHostIndex);
	printf("\tPath ID\t\t: %d\n", ScsiAddrBuff->bPathId);
	printf("\tTarget ID\t: %d\n", ScsiAddrBuff->bTargetId);
	printf("\tLUN\t\t: %d\n", ScsiAddrBuff->bLun); */

        //Removed Since HOST ID is always zero and not required by Ioctl requirements
	//print_to_file(fp,"\n\tHost Index\t: %d\n", ScsiAddrBuff->bHostIndex);

	print_to_file(fp,"\tPath ID\t\t: %d\n", ScsiAddrBuff->bPathId);
	print_to_file(fp,"\tTarget ID\t: %d\n", ScsiAddrBuff->bTargetId);
	print_to_file(fp,"\tLUN\t\t: %d\n", ScsiAddrBuff->bLun);


	//fprintf(tempo,"\n\tHost Index\t: %d\n", ScsiAddrBuff->bHostIndex);
	fprintf(tempo,"\tPath ID\t\t: %d\n", ScsiAddrBuff->bPathId);
	fprintf(tempo,"\tTarget ID\t: %d\n", ScsiAddrBuff->bTargetId);
	fprintf(tempo,"\tLUN\t\t: %d\n", ScsiAddrBuff->bLun);

}

void DisplayDeviceAddress(CSMI_SAS_GET_DEVICE_ADDRESS_BUFFER *DeviceAddress)
{
	int i;
/*	printf("\tHost Index\t: %d\n", DeviceAddress->bHostIndex);
	printf("\tPath ID\t\t: %d\n", DeviceAddress->bPathId);
	printf("\tTarget ID\t: %d\n", DeviceAddress->bTargetId);
	printf("\tLun\t\t: %d\n", DeviceAddress->bLun);
	printf("\tSAS Address\t: "); */

	print_to_file(fp,"\tHost Index\t: %d\n", DeviceAddress->bHostIndex);
	print_to_file(fp,"\tPath ID\t\t: %d\n", DeviceAddress->bPathId);
	print_to_file(fp,"\tTarget ID\t: %d\n", DeviceAddress->bTargetId);
	print_to_file(fp,"\tLun\t\t: %d\n", DeviceAddress->bLun);
	print_to_file(fp,"\tSAS Address\t: ");


	fprintf(tempo,"\tHost Index\t: %d\n", DeviceAddress->bHostIndex);
	fprintf(tempo,"\tPath ID\t\t: %d\n", DeviceAddress->bPathId);
	fprintf(tempo,"\tTarget ID\t: %d\n", DeviceAddress->bTargetId);
	fprintf(tempo,"\tLun\t\t: %d\n", DeviceAddress->bLun);
	fprintf(tempo,"\tSAS Address\t: ");


	for(i=0; i<8; i++)
	{
//		printf("%02x ", DeviceAddress->bSASAddress[i]);
		print_to_file(fp,"%02x ", DeviceAddress->bSASAddress[i]);
		fprintf(tempo,"%02x ", DeviceAddress->bSASAddress[i]);
	}
	//printf("\n\tSAS LUN\t\t: ");
	print_to_file(fp,"\n\tSAS LUN\t\t: ");
	fprintf(tempo,"\n\tSAS LUN\t\t: ");
	for(i=0; i<8; i++)
	{
		//printf("%02x ", DeviceAddress->bSASLun[i]);
		print_to_file(fp,"%02x ", DeviceAddress->bSASLun[i]);
		fprintf(tempo,"%02x ", DeviceAddress->bSASLun[i]);
	}

	//printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");
}









void DisplaySTPPassthru(CSMI_SAS_STP_PASSTHRU_BUFFER *PassthruBuff)
{
	int i = 0;
	int z = 0;


	//printf("\t Phy Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPhyIdentifier);
	print_to_file(fp,"\t Phy Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPhyIdentifier);
	fprintf(tempo,"\t Phy Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPhyIdentifier);


	//printf("\t Port Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPortIdentifier);
	print_to_file(fp,"\t Port Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPortIdentifier);

	//printf("\t Connection Rate (same as input) : %d \n",PassthruBuff->Parameters.bConnectionRate);
	print_to_file(fp,"\t Connection Rate (same as input) : %d \n",PassthruBuff->Parameters.bConnectionRate);


	//printf("\t Destination SAS (same as input) \t");
	print_to_file(fp,"\t Destination SAS (same as input) \t");


	fprintf(tempo,"\t Port Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPortIdentifier);
	fprintf(tempo,"\t Connection Rate (same as input) : %d \n",PassthruBuff->Parameters.bConnectionRate);
	fprintf(tempo,"\t Destination SAS (same as input) \t");


	for(i=0;i<8;i++)
	{

//		printf(" %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);
		print_to_file(fp," %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);
		fprintf(tempo," %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);
	}


//	printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");










//	printf("\tSTATUS:\n");
//	printf("\t  Connection Status\t: %d\n", PassthruBuff->Status.bConnectionStatus);

	print_to_file(fp,"\tSTATUS:\n");
	print_to_file(fp,"\t  Connection Status\t: %d\n", PassthruBuff->Status.bConnectionStatus);

	fprintf(tempo,"\tSTATUS:\n");
	fprintf(tempo,"\t  Connection Status\t: %d\n", PassthruBuff->Status.bConnectionStatus);



//	printf("\tStatus FIS\t: \n ");
	print_to_file(fp,"\tStatus FIS\t: \n");
	fprintf(tempo,"\tStatus FIS\t: \n");
	z = 0;
	for(i=0; i<sizeof(PassthruBuff->Status.bStatusFIS); i++)
	{ z++;/*printf("%x ",PassthruBuff->Status.bStatusFIS[i]); */  fprintf(tempo,"%x ",PassthruBuff->Status.bStatusFIS[i]); print_to_file(fp,"%x ",PassthruBuff->Status.bStatusFIS[i]); if(z == 20) { z = 0; /*printf("\n");*/ print_to_file(fp,"\n"); fprintf(tempo,"\n"); } }
	//printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");

	//printf("\tSCR\t: \n");
	print_to_file(fp,"\tSCR\t: \n");
	fprintf(tempo,"\tSCR\t: \n");
	z = 0;

	for(i=0; i<sizeof(PassthruBuff->Status.uSCR); i++)
	{ z++; /* printf("%x ",PassthruBuff->Status.uSCR[i]); */ fprintf(tempo,"%x ",PassthruBuff->Status.uSCR[i]); print_to_file(fp,"%x ",PassthruBuff->Status.uSCR[i]); if(z == 20) { z = 0; /* printf("\n"); */ print_to_file(fp,"\n"); fprintf(tempo,"\n"); } }
//	if(sizeof(PassthruBuff->Status.uSCR) > 0)
//		DisplayDumpAfter(&PassthruBuff->Status.uSCR);

	//printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");

	//printf("\tData Bytes\t: %d\n",PassthruBuff->Status.uDataBytes);
	print_to_file(fp,"\tData Bytes\t: %d\n",PassthruBuff->Status.uDataBytes);
	fprintf(tempo,"\tData Bytes\t: %d\n",PassthruBuff->Status.uDataBytes);

	//printf("\tData Buffer\t: \n");
	print_to_file(fp,"\tData Buffer\t: \n");
	fprintf(tempo,"\tData Buffer\t: \n");
	z = 0;

//	for(i=0; i < (signed)PassthruBuff->Status.uDataBytes; i++)
//	{ z++; printf("%x ",PassthruBuff->bDataBuffer[i]); print_to_file(fp,"%x ",PassthruBuff->bDataBuffer[i]); if(z == 20) { z = 0; printf("\n"); print_to_file(fp,"\n"); } }
	if(PassthruBuff->Status.uDataBytes > 0)
		DisplayDumpAfter(PassthruBuff->bDataBuffer);

	//printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");


}





void DisplaySSPPassthru(CSMI_SAS_SSP_PASSTHRU_BUFFER *PassthruBuff)
{
	int i = 0;
	int z = 0;
	int cntr = 0;
	char arr[999];
	int fi;



	//printf("\t Phy Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPhyIdentifier);
	print_to_file(fp,"\t Phy Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPhyIdentifier);


	//printf("\t Port Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPortIdentifier);
	print_to_file(fp,"\t Port Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPortIdentifier);

	//printf("\t Connection Rate (same as input) : %d \n",PassthruBuff->Parameters.bConnectionRate);
	print_to_file(fp,"\t Connection Rate (same as input) : %d \n",PassthruBuff->Parameters.bConnectionRate);


	//printf("\t Destination SAS (same as input) \t");
	print_to_file(fp,"\t Destination SAS (same as input) \t");


	fprintf(tempo,"\t Phy Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPhyIdentifier);
	fprintf(tempo,"\t Port Identifier (same as input) : %d \n",PassthruBuff->Parameters.bPortIdentifier);
	fprintf(tempo,"\t Connection Rate (same as input) : %d \n",PassthruBuff->Parameters.bConnectionRate);
	fprintf(tempo,"\t Destination SAS (same as input) \t");


	for(i=0;i<8;i++)
	{

		//printf(" %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);
		print_to_file(fp," %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);
		fprintf(tempo," %d ",PassthruBuff->Parameters.bDestinationSASAddress[i]);
	}


//	printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");










	//printf("\t STATUS:\n");
	//printf("\t  Connection Status\t: %d\n", PassthruBuff->Status.bConnectionStatus);

	print_to_file(fp,"\tSTATUS:\n");
	print_to_file(fp,"\t  Connection Status\t: %d\n", PassthruBuff->Status.bConnectionStatus);

	fprintf(tempo,"\tSTATUS:\n");
	fprintf(tempo,"\t  Connection Status\t: %d\n", PassthruBuff->Status.bConnectionStatus);


//	printf("\t  Data Present\t: %d\n", PassthruBuff->Status.bDataPresent);

	print_to_file(fp,"\t  Data Present\t: %d\n", PassthruBuff->Status.bDataPresent);


//	printf("\t  Status \t: %d\n", PassthruBuff->Status.bStatus);

	print_to_file(fp,"\t  Status\t: %d\n", PassthruBuff->Status.bStatus);


//	printf("\t  Response Length \t: %d\n", (int)PassthruBuff->Status.bResponseLength);

	print_to_file(fp,"\t  Response Length \t: %d\n", (int)PassthruBuff->Status.bResponseLength);



	fprintf(tempo,"\t  Data Present\t: %d\n", PassthruBuff->Status.bDataPresent);
	fprintf(tempo,"\t  Status\t: %d\n", PassthruBuff->Status.bStatus);
	fprintf(tempo,"\t  Response Length \t: %d\n", (int)PassthruBuff->Status.bResponseLength);






//	printf("\tResponse\t: \n ");
	print_to_file(fp,"\tResponse\t: \n");
	fprintf(tempo,"\tResponse\t: \n");
	z = 0;
	for(i=0; i<sizeof(PassthruBuff->Status.bResponseLength); i++)
	{ z++;printf("%x ",PassthruBuff->Status.bResponse[i]);  fprintf(tempo,"%x ",PassthruBuff->Status.bResponse[i]); print_to_file(fp,"%x ",PassthruBuff->Status.bResponse[i]); if(z == 20) { z = 0; /*printf("\n");*/ print_to_file(fp,"\n"); fprintf(tempo,"\n"); } }
	//printf("\n");
	print_to_file(fp,"\n");
	fprintf(tempo,"\n");


	//printf("\tData Bytes\t: %d\n",PassthruBuff->Status.uDataBytes);
	print_to_file(fp,"\tData Bytes\t: %d\n",PassthruBuff->Status.uDataBytes);
	fprintf(tempo,"\tData Bytes\t: %d\n",PassthruBuff->Status.uDataBytes);



	//printf("\tData Buffer\t: \n");
	print_to_file(fp,"\tData Buffer\t: \n");
	fprintf(tempo,"\tData Buffer\t: \n");
	z = 0;

	for(i=0; i < (signed)PassthruBuff->Status.uDataBytes; i++)
	{
			//printf("%02x ",PassthruBuff->bDataBuffer[i] & 0xff);
		/*	print_to_file(fp,"%s\n", PassthruBuff->bDataBuffer);
			fprintf(tempo   , "%s\n", PassthruBuff->bDataBuffer);
			continue;*/
			print_to_file(fp,"%02x ",PassthruBuff->bDataBuffer[i] & 0xff);
			fprintf(tempo,"%02x ",PassthruBuff->bDataBuffer[i] & 0xff);
			arr[cntr] = PassthruBuff->bDataBuffer[i];
			cntr++;

			/*if(PassthruBuff->Parameters.bCDB.CDB10.OperationCode == 0x25){
				pritn_to_file( fp ,"Serial Number: %s\n", arr[cntr]);
				fprintf(    tempo , "Serial Number: %s\n", arr[cntr]); 
				continue;
			}*/

			

			   if(cntr == 16)
			   {
				   //printf(" : ");
				   print_to_file(fp," : ");
				   fprintf(tempo," : ");
				   for(fi = 0;fi < cntr; fi++)
				   {
					   if(isgraph(arr[fi]))
					   {
							//printf("%c",arr[fi]);
						   fprintf(tempo,"%c",arr[fi]);
							print_to_file(fp,"%c",arr[fi]);
					   }
					   else
					   {
						   /*printf(".");*/   print_to_file(fp,".");  fprintf(tempo,".");
					   }
				   }
				   cntr = 0;
				   //printf("\n");
				   print_to_file(fp,"\n");
				   fprintf(tempo,"\n");
			   }

		}


			 for(fi = cntr;fi<16;fi++) fprintf(tempo,"   ");
				 //printf("   ");



			       //printf(" : ");
				   print_to_file(fp," : ");
				   fprintf(tempo," : ");
				   for(fi = 0;fi < cntr; fi++)
				   {
					   if(isgraph(arr[fi]))
					   {
							//printf("%c",arr[fi]);
							print_to_file(fp,"%c",arr[fi]);
							fprintf(tempo,"%c",arr[fi]);
					   }
					   else
					   {
						   /*printf("."); */ print_to_file(fp,"."); fprintf(tempo,".");
					   }
				   }



		//printf("\n \n");
		print_to_file(fp,"\n \n");
		fprintf(tempo,"\n \n");



}



void DisplayConnectorInfo(CSMI_SAS_CONNECTOR_INFO_BUFFER *Connector,int no_of_phys)
{

	int i;
	print_to_file(fp,"\n\tTotal No of Phys :\t: %d\n", no_of_phys);
	fprintf(tempo,"\n\tTotal No of Phys :\t: %d\n", no_of_phys);
	for(i=0;i<=no_of_phys;i++)
	{
		print_to_file(fp,"\t Phy : %d \n",i);
		fprintf(tempo,"\t Phy : %d \n",i);
		print_to_file(fp,"\t Connector : %s \n",Connector->Reference[i].bConnector);
		fprintf(tempo,"\t Connector : %s \n",Connector->Reference[i].bConnector);
		switch(Connector->Reference[i].uPinout)
		{
			case CSMI_SAS_CON_UNKNOWN:
				print_to_file(fp,"\t Pinout : UNKNOWN [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : UNKNOWN [%d] \n",Connector->Reference[i].bConnector);
				break;
			case CSMI_SAS_CON_SFF_8482:
				print_to_file(fp,"\t Pinout : Single Lane SFF-8482 Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Single Lane SFF-8482 Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8470_LANE_1:
				print_to_file(fp,"\t Pinout : Lane 1 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 1 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8470_LANE_2:
				print_to_file(fp,"\t Pinout : Lane 2 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 2 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8470_LANE_3:
				print_to_file(fp,"\t Pinout : Lane 3 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 3 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8470_LANE_4:
				print_to_file(fp,"\t Pinout : Lane 4 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 4 in SFF-8470 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8484_LANE_1:
				print_to_file(fp,"\t Pinout : Lane 1 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 1 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8484_LANE_2:
				print_to_file(fp,"\t Pinout : Lane 2 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 2 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8484_LANE_3:
				print_to_file(fp,"\t Pinout : Lane 3 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 3 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			case CSMI_SAS_CON_SFF_8484_LANE_4:
				print_to_file(fp,"\t Pinout : Lane 4 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : Lane 4 in SFF-8484 4 Lane Connector [%d] \n",Connector->Reference[i].bConnector);
				break;

			default:
				print_to_file(fp,"\t Pinout : NOT A DEFINED VALUE [%d] \n",Connector->Reference[i].bConnector);
				fprintf(tempo,"\t Pinout : NOT A DEFINED VALUE [%d] \n",Connector->Reference[i].bConnector);
				break;
		}

			switch(Connector->Reference[i].bLocation)
		{
			case CSMI_SAS_CON_UNKNOWN:
				print_to_file(fp,"\t Location : UNKNOWN [%d] \n",Connector->Reference[i].bLocation);
				fprintf(tempo,"\t Location : UNKNOWN [%d] \n",Connector->Reference[i].bLocation);
				break;
			
			case CSMI_SAS_CON_INTERNAL:
				print_to_file(fp,"\t Location : Internal [%d] \n",Connector->Reference[i].bLocation);
				fprintf(tempo,"\t Location : Internal [%d] \n",Connector->Reference[i].bLocation);
				break;

			case CSMI_SAS_CON_EXTERNAL:
				print_to_file(fp,"\t Location : External [%d] \n",Connector->Reference[i].bLocation);
				fprintf(tempo,"\t Location : External [%d] \n",Connector->Reference[i].bLocation);
				break;

			case CSMI_SAS_CON_SWITCHABLE:
				print_to_file(fp,"\t Location : Switchable : Internal/External [%d] \n",Connector->Reference[i].bLocation);
				fprintf(tempo,"\t Location : Switchable : Internal/External [%d] \n",Connector->Reference[i].bLocation);
				break;

			case CSMI_SAS_CON_AUTO:
				print_to_file(fp,"\t Location : Auto Detect Activity [%d] \n",Connector->Reference[i].bLocation);
				fprintf(tempo,"\t Location : Auto Detect Activity [%d] \n",Connector->Reference[i].bLocation);
				break;

			default:
				print_to_file(fp,"\t Location : NOT A DEFINED VALUE [%d] \n",Connector->Reference[i].bLocation);
				fprintf(tempo,"\t Location : NOT A DEFINED VALUE [%d] \n",Connector->Reference[i].bLocation);
				break;
		}

	}

}





DisplayLocation(CSMI_SAS_GET_LOCATION_BUFFER *location)
{
	int i = 0, j = 0;

	print_to_file(fp , "\tIOCTL Specific Data\n");
	fprintf(tempo,"\tIOCTL Specific Data\n");

	print_to_file(fp , "\t-------------------------\n");
        fprintf(tempo, "\t-------------------------\n");


	print_to_file(fp ,   "\tNumber of Locations     = %d\n", location->bNumberOfLocationIdentifiers);
        fprintf(tempo ,      "\tNumber of Locations     = %d\n\n", location->bNumberOfLocationIdentifiers);


	//print_to_file(fp , "\t-------------------------\n");
	//fprintf(tempo, "\t-------------------------\n");
	print_to_file(fp ,   "\tHostindex  (same as input)	\t: [%d]\n", location->bHostIndex);
	fprintf(tempo,       "\tHostindext (same as input)    	\t: [%d]\n", location->bHostIndex);
	print_to_file(fp ,   "\tPathId     (same as input)    	\t: [%d]\n", location->bPathId);
	fprintf(tempo,       "\tPathId     (same as input)       	\t: [%d]\n", location->bPathId);
	print_to_file(fp ,   "\tTargetId   (same as input)	\t: [%d]\n", location->bTargetId);
	fprintf(tempo,       "\tTargetId   (same as input)     	\t: [%d]\n", location->bTargetId);
	print_to_file(fp ,   "\tLun	   (same as input)	\t: [%d]\n", location->bLun);
	fprintf(tempo,       "\tLun        (same as input)   	\t: [%d]\n", location->bLun);
	print_to_file(fp ,   "\tIdentifier (same as input)	\t: [%d]\n", location->bIdentify);
	fprintf(tempo,       "\tIdentifier (same as input)   	\t: [%d]\n", location->bIdentify);
//	print_to_file(fp ,   "\tNo.Locations	: [%d]\n", location->bNumberOfLocationIdentifiers);
//	fprintf(tempo ,      "\tNo.Locations    : [%d]\n", location->bNumberOfLocationIdentifiers);	
	
	if(location->bNumberOfLocationIdentifiers == 0 ) {
		 print_to_file(fp, "\tNo Locations Found \n ");
                 fprintf(tempo,    "\tNo Locations Found\n ");

	}
	else {

	for( j =0 ; j < location->bNumberOfLocationIdentifiers ; j++) {
		//switch(location->Location[j].bLocationFlags) {

		print_to_file(fp , "-------------------------\n");
		fprintf(tempo    ,"-------------------------\n");
		print_to_file(fp , "Location[%d]\n" , j+1);
		fprintf(tempo    , "Location[%d]\n" , j+1);
		print_to_file(fp , "-------------------------\n");
		fprintf(tempo    ,"-------------------------\n");
		
		print_to_file(fp, "\tbsasAddress \t\t: ");
		fprintf(tempo,    "\tbsasAddress \t\t: ");
		if(location->Location[j].bLocationFlags & CSMI_SAS_LOCATE_SAS_ADDRESS_VALID) {
		
			for(i =0 ; i < 8 ; i++) {
				print_to_file(fp , "%02x ",location->Location[j].bSASAddress[i]);
				fprintf(tempo,"%02x ",location->Location[j].bSASAddress[i]);
			}
			print_to_file(fp , "\n");
			fprintf(tempo,"\n");
			
		} 
		else {
			print_to_file(fp, "INVALID\n");
			fprintf(tempo   , "INVALID\n");
		}	
		print_to_file(fp ,"\tLun ID      \t\t: ");
		fprintf(tempo,    "\tLun ID      \t\t: ");
		if(location->Location[j].bLocationFlags & CSMI_SAS_LOCATE_SAS_LUN_VALID) {
			for(i =0 ; i < 8 ; i++) {
	                	print_to_file(fp , "%02x ",location->Location[j].bSASLun[i]);
	        	        fprintf(tempo,"%02x ",location->Location[j].bSASLun[i]);
	                }
			print_to_file(fp , "\n");
	                fprintf(tempo,"\n");
		}
		else {
			print_to_file(fp, "INVALID\n");
			fprintf(tempo   , "INVALID\n");
		}
		if(location->Location[j].bLocationFlags & CSMI_SAS_LOCATE_ENCLOSURE_IDENTIFIER_VALID) {
			print_to_file(fp ,"\tEnclosure id\t\t: ");
			fprintf(tempo,    "\tEnclosure id\t\t: ");
			for(i =0 ; i < 8 ; i++) {
	                	print_to_file(fp , "%02x ",location->Location[j].bEnclosureIdentifier[i]);
	                	fprintf(tempo,"%02x ",location->Location[j].bEnclosureIdentifier[i]);
	        	}
	         	print_to_file(fp , "\n");
	                fprintf(tempo,"\n");
		}
				
		print_to_file(fp, "\tEnclosure name \t\t: ");
		fprintf(tempo,    "\tEnclosure name \t\t: " );
		if(location->Location[j].bLocationFlags & CSMI_SAS_LOCATE_ENCLOSURE_NAME_VALID) {
			for(i =0 ; i < 32 ; i++) {
	        		print_to_file(fp , "%c",location->Location[0].bEnclosureName[i]);
	        		fprintf(tempo,     "%c",location->Location[0].bEnclosureName[i]);
					/*if((i% 2)== 0) {
						print_to_file(fp , " ");
	                                        fprintf(tempo," ");
					}*/
				if( i == 16) {
					print_to_file(fp , "\n\t\t\t\t  ");
                                	fprintf(tempo,"\n\t\t\t\t  ");

				}
					
	                }
	                print_to_file(fp , "\n");
	                fprintf(tempo,"\n");
		}
		else{
				print_to_file(fp, "INVALID\n");
				fprintf(tempo   , "INVALID\n");
		}
					
		print_to_file(fp, "\tBay Prefix    \t\t: ");
		fprintf(tempo,    "\tBay Prefix    \t\t: ");
		if(location->Location[j].bLocationFlags & CSMI_SAS_LOCATE_BAY_PREFIX_VALID) {
			for(i =0 ; i < 32 ; i++) {
	        		print_to_file(fp , "%c ",location->Location[j].bBayPrefix[i]);
	        		fprintf(tempo,"%c ",location->Location[j].bBayPrefix[i]);
	                }
	        	print_to_file(fp , "\n");
	                fprintf(tempo,"\n");
		}
		else {
			print_to_file(fp, "INVALID\n");
			fprintf(tempo   , "INVALID\n");
		}
		print_to_file(fp, "\tBay Identifier\t\t:");
		fprintf(tempo ,   "\tBay Identifier\t\t:");
		if(location->Location[j].bLocationFlags &  CSMI_SAS_LOCATE_BAY_IDENTIFIER_VALID) {
			print_to_file(fp, " %d\n",location->Location[j].bBayIdentifier );
			fprintf(tempo ,   " %d\n",location->Location[j].bBayIdentifier );
		}
		else {
			print_to_file(fp, "INVALID\n");
			fprintf(tempo   , "INVALID\n");
		}

		print_to_file(fp ,"\tPhysical location identifier state:");
		fprintf(tempo,"\tPysical location identifier state:");
		if(location->Location[j].bLocationFlags & CSMI_SAS_LOCATE_LOCATION_STATE_VALID) {
				//print_to_file(fp , "\tLocation state is valid\n");
				//fprintf(tempo, "\tLocation state is valid\n");
			switch(location->Location[j].bLocationState) {
				case CSMI_SAS_LOCATE_UNKNOWN:
					print_to_file(fp ,"\t UNKNOWN\n");
					fprintf(tempo,    "\t UNKNOWN\n");
					break;
				
				case CSMI_SAS_LOCATE_FORCE_ON:
					print_to_file(fp ,"\t ON\n");
					fprintf(tempo,    "\t ON\n");
					break;
			
				case CSMI_SAS_LOCATE_FORCE_OFF:
					print_to_file(fp ,"\t OFF\n");
					fprintf(tempo,    "\t OFF\n");
					break;
				
			}
		}		
		else {
			print_to_file(fp, "INVALID\n");
			fprintf(tempo   , "INVALID\n");
		}
		//} 
		}
	}
		
				
}




Display_raid_features(CSMI_SAS_RAID_FEATURES *raid_features)
{

	int i = 0 , j = 0;
        CSMI_SAS_RAID_FEATURES_BUFFER *raidFeatures;

	print_to_file(fp ,"\tRAID FEATURE SET SUPPORTED\t:");
	fprintf(tempo , "\tRAID FEATURE SET SUPPORTED\t:");
	if(raid_features->uFeatures & CSMI_SAS_RAID_FEATURE_TRANSFORMATION){
		/*print_to_file(fp , "\tRAID controller is capable of background RAID SET transformations\n"
				   "\ti.e. Normal I/O is permitted while the RAID SET is in transformation state\n");
	       	fprintf(tempo,"\tRAID controller is capable of background RAID SET transformations\n"
			      "\ti.e. Normal I/O is permitted while the RAID SET is in transformation state\n");*/
		print_to_file(fp , "\tTRANSFORMATION,\t");
		fprintf(tempo , "\tTRANSFORMATION,\t");
	}
	if(raid_features->uFeatures & CSMI_SAS_RAID_FEATURE_REBUILD) {
		/*print_to_file(fp ,"\tRAID controller is capable of background RAID SET rebuild\n"
				  "\ti.e. Normal I/O is permitted while the RAID SET is in rebuild state\n");
		fprintf(tempo , "\tRAID contriller is capable of background RAID SET rebuild\n"
				"\ti.e. Normal I/O is permitted while the RAID SET is in rebuild state\n");*/
		print_to_file(fp , "REBUILD,\t");
		fprintf(tempo ,    "REBUILD,\t");
	}
	if(raid_features->uFeatures & CSMI_SAS_RAID_FEATURE_SPLIT_MIRROR) {
		print_to_file(fp ,"SPLIT_MIRROR,\t"); 
		fprintf(tempo ,   "SPLIT_MIRROR,\t");
	}
	if(raid_features->uFeatures & CSMI_SAS_RAID_FEATURE_MERGE_MIRROR){
		print_to_file(fp ,"MERGE_MIRROR,\t");
		fprintf(tempo ,   "MERGE_MIRROR,\t");
	}
	if(raid_features->uFeatures & CSMI_SAS_RAID_FEATURE_LUN_RENUMBER) {
		print_to_file(fp ,"LUN RENUMBER,\t");
		fprintf(tempo , "LUN RENUMBER,\t");
	}
	if(raid_features->uFeatures & CSMI_SAS_RAID_FEATURE_SURFACE_SCAN) {
		print_to_file(fp ,"SURFACE SCAN,\t");
		fprintf(tempo , "SURFACE SCAN,\t");
	}
	if(raid_features->uFeatures & CSMI_SAS_RAID_FEATURE_SPARES_SHARED) {
		print_to_file(fp ,"SPARES SHARED,\t");
		fprintf(tempo , "SPARES SHARED,\t");
	}




	print_to_file(fp,"\n");
	fprintf(tempo , "\n");	

	print_to_file(fp ,"\tDefault Transform Priority\t: \t");
	fprintf(tempo ,   "\tDefault Transform Priority\t: \t");
	display_raid_priority(raid_features->bDefaultTransformPriority);

	print_to_file( fp , "\tActive TransForm Priority\t: \t");
	fprintf(tempo     , "\tActive TransForm Priority\t: \t");
      	display_raid_priority(raid_features->bTransformPriority);
	
	print_to_file(fp ,"\tDefault Rebuild Priority\t: \t");
	fprintf(tempo ,   "\tDefault Rebuild Priority\t: \t");
	display_raid_priority(raid_features->bDefaultRebuildPriority);

	print_to_file( fp , "\tActive TransForm Priority\t: \t");
	fprintf(tempo     , "\tActive TransForm Priority\t: \t");
      	display_raid_priority(raid_features->bTransformPriority);
	
	print_to_file(fp ,"\tDefault Rebuild Priority\t: \t");
	fprintf(tempo ,   "\tDefault Rebuild Priority\t: \t");
	display_raid_priority(raid_features->bDefaultRebuildPriority);

	print_to_file( fp , "\tActive Rebuild Priority \t: \t");
	fprintf(tempo     , "\tActive Rebuild Priority \t: \t");
	display_raid_priority(raid_features->bRebuildPriority);

	print_to_file(fp ,"\tDefault SurfaceScan Priority \t: \t");
	fprintf(tempo ,   "\tDefault SurfaceScan Priority \t: \t");
	display_raid_priority(raid_features->bDefaultSurfaceScanPriority);
		       
	print_to_file(fp ,"\tSurfaceScan Priority \t: \t");
	fprintf(tempo ,   "\tSurfaceScan Priority \t: \t");
	display_raid_priority(raid_features->bSurfaceScanPriority);
	print_to_file(fp ,"\n");
	fprintf(tempo ,   "\n");
	/*
	switch(raid_features->bSurfaceScanPriority)
	{
		case CSMI_SAS_RAID_SURFACE_SCAN_DISABLED:
			print_to_file(fp , "DISABLED\n");
			fprintf(tempo , "DISABLED\n");
			break;
		case CSMI_SAS_RAID_SURFACE_SCAN_UNSUPPORTED:
			print_to_file(fp , "UNSUPPORTED\n");
			fprintf(tempo ,    "UNSUPPORTED\n");
			break;
		case CSMI_SAS_RAID_SURFACE_SCAN_UNKNOWN:
			print_to_file(fp , "Not Initialized or Unsupported\n");
			fprintf(tempo ,    "Not Initialized or Unsupported\n");
			break;
		default:
		       display_raid_priority(raid_features->bSurfaceScanPriority);
		       print_to_file(fp ,"%d\n"	, raid_features->bSurfaceScanPriority);
		       fprintf(tempo ,   "%d\n" , raid_features->bSurfaceScanPriority);
		       break;
	}*/

	//print_to_file(fp , "\tMinimum SurfaceScan Delay \t: \t%d\n"  , raid_features->uMinSurfaceScanDelay);
	//fprintf(tempo ,     "\tMinimum SurfaceScan Delay \t: \t%d\n"  , raid_features->uMinSurfaceScanDelay);

	//print_to_file(fp , "\tMaximum SurfaceScan Delay \t: \t%d\n"  , raid_features->uMaxSurfaceScanDelay);
	//fprintf( tempo , "\tMaximum SurfaceScan Delay \t: \t%d\n"  , raid_features->uMaxSurfaceScanDelay);

	print_to_file(fp,"\tRAID SET Transformation rules\t : \t");
	fprintf(tempo , "\tRAID SET Transformation rules\t : \t");

	switch(raid_features->uRaidSetTransformationRules)
	{
		case CSMI_SAS_RAID_RULE_AVAILABLE_MEMORY:
			print_to_file(fp , "RULE AVAILABLE MEMORY\n");
			fprintf(tempo ,    "RULE AVAILABLE MEMORY\n");
			break;
		case CSMI_SAS_RAID_RULE_OVERLAPPED_EXTENTS:
			print_to_file(fp , "RULE_OVERLAPPED_EXTENTS\n");
			fprintf( tempo ,   "RULE_OVERLAPPED_EXTENTS\n");
			break;
		default:
			print_to_file(fp , "Unknown or not supported\n");
			fprintf(tempo ,    "Unknown or not supported\n");
			
	}

	print_to_file(fp , "\t RAID TYPES SUPPORTED\t:\n");
	fprintf(tempo    , "\t RAID TYPES SUPPORTED\t:\n");
	for(i = 0 ; i < 24 ; i++){
		if((raid_features->RaidType[i].bRaidType) == CSMI_SAS_RAID_TYPE_END)
			break;
		print_to_file(fp , "\n\t\t\t\t\t");
		fprintf(tempo, "\n\t\t\t\t\t");
		print_to_file(fp , "\t%s\n", display_raid_type(&(raid_features->RaidType[i])));
		fprintf(tempo, "\t%s\n", display_raid_type(&(raid_features->RaidType[i])));
		
	}

	print_to_file(fp , "\n\t CACHE RATIOS RANGE\t:\t\n");
	fprintf(tempo    , "\n\t CACHE RATIOS RANGE\t:\t\n");
	for(i = 0 ; i < 104 ; i++) {
		if((raid_features->bCacheRatiosSupported[i]) == CSMI_SAS_RAID_TYPE_END)
			break;
		//display_cache_ratio(raid_features->bCacheRatiosSupported[i]);
		
	}

	
	

}




//CC_CSMI_SAS_GET_RAID_FEATURES

Display_raid_element(CSMI_SAS_RAID_ELEMENT *raid_element)
{

	int i = 0 , j = 0, index = 0, index1 = 0;
	int buffer_size = 2 << 14;
	//CSMI_SAS_RAID_DRIVES *Drives;
        //CSMI_SAS_RAID_ELEMENT_BUFFER *raid_element_buffer;

	
        print_to_file(fp,"\tRAID FEATURE SET SUPPORTED \n");
	fprintf(tempo ,  "\tRAID FEATURE SET SUPPORTED \n");
	
	if(raid_element->uEnumerationType == CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE){
		print_to_file(fp,"\tRAID ELEMENT TYPE DRIVE\t: PHYSICAL DRIVE\n ");
		fprintf(tempo,   "\tRAID ELEMENT TYPE DRIVE\t: PHYSICAL DRIVE\n ");
	}
		
	if(raid_element->uEnumerationType == CSMI_SAS_RAID_ELEMENT_TYPE_MODULE){
		print_to_file(fp,"\n\n\t CACHE OR MODULE : NOT SUPPORTED\n");
	        fprintf(tempo,"\n----------------------------------------------");
		fprintf(tempo,"\n CACHE OR MODULE INFO : NOT SUPPORTED "); 
	        fprintf(tempo,"\n----------------------------------------------\n");
 	}
        
	if( raid_element->uNumElements ){
	       print_to_file(fp,"\tNumber Of Elements \t: %d \n", raid_element->uNumElements);
               fprintf(tempo,    "\tNumber Of Elements \t: %d  \n", raid_element->uNumElements);
	}

	if(raid_element->uEnumerationType == CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE_RAID_SET){
		print_to_file(fp,"\tRAID ELEMENT TYPE DRIVE SET\t: PHYSICAL DRIVE of a SPECIFIC RAID SET\n");
		fprintf(tempo,   "\tRAID ELEMENT TYPE DRIVE SET\t: PHYSICAL DRIVE of a SPECIFIC RAID SET\n");
		
		//print_to_file(fp,"\t PHYSICAL DRIVE  %d  of a SPECIFIC RAID SET \n", raid_element->uSubElementIndex);
		//fprintf(tempo,   "\t PHYSICAL DRIVE  %d of a SPECIFIC RAID SET \n", raid_element->uSubElementIndex);
	}	
	if(raid_element->uEnumerationType ==  CSMI_SAS_RAID_ELEMENT_TYPE_EXTENT_DRIVE ){
		print_to_file(fp,"\tRAID ELEMENT TYPE EXTENT DRIVE \t:  EXTENT Of a SPECIFIC PHYSICAL DRIVE\n");
		fprintf(tempo,   "\tRAID ELEMENT TYPE EXTENT DRIVE \t:  EXTENT Of a SPECIFIC PHYSICAL DRIVE\n");
 	}		
        if( raid_element->uElementIndex ){
	       print_to_file(fp,"\tIndex Number Of the REQUEST \t: %ld\n", raid_element->uElementIndex);
               fprintf(tempo,   "\tIndex Number Of the REQUEST \t:%ld \n", raid_element->uElementIndex);
	}
        if( raid_element->uChangeCount ){
	       print_to_file(fp,"\t Change Count is \t: %d\n", raid_element->uChangeCount);
               fprintf(tempo,    "\tChange Count is \t: %d\n", raid_element->uChangeCount);
	}	 
        if( raid_element->uSubElementIndex ){
	       print_to_file(fp,"\tSubelement Index is\t:   %d\n", raid_element->uSubElementIndex);
               fprintf(tempo,    "\tSubElement Index is\t:  %d\n", raid_element->uSubElementIndex);
	}	
	
/*   if((raid_element_buffer->IoctlHeader.ReturnCode) != CSMI_SAS_STATUS_INVALID_PARAMETER){
		check_return_code_element(raid_element_buffer);
}*/


        if((raid_element->uEnumerationType) == CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE){
	
		
                fprintf(tempo,"\n\t\tDRIVE INFO"); 
		
		fprintf(tempo,"\n----------------------------------------------\n");
		fprintf(tempo,"Drive model                \t: %s\n",raid_element->Element.Drive.Device.bModel);
		fprintf(tempo,"Drive firmware designation \t: %s\n",raid_element->Element.Drive.Device.bFirmware);
		fprintf(tempo,"Drive serial number        \t: %s\n",raid_element->Element.Drive.Device.bSerialNumber);
		fprintf(tempo,"Drive Block Size           \t: %d\n",raid_element->Element.Drive.Device.usBlockSize);
		fprintf(tempo,"Drive Index                \t: %ld\n",raid_element->Element.Drive.Device.uDriveIndex);
		print_to_file(fp,"Drive SAS Address       \t: "); 
		fprintf(tempo,"Drive SAS Address          \t: "); 
		for(i=0;i<8;i++)
        	{
               	print_to_file(fp,"%02x ",(unsigned int) raid_element->Element.Drive.Device.bSASAddress[i]);
               	fprintf(tempo,"%02x ", raid_element->Element.Drive.Device.bSASAddress[i]);
		}
		
		fprintf(tempo,"\n----------------------------------------------\n");
		
		print_to_file(fp,"\n\t\tDRIVE INFO"); 
		
		print_to_file(fp,"\n----------------------------------------------\n");
		print_to_file(fp,"Drive model                \t: %s\n",raid_element->Element.Drive.Device.bModel);
		print_to_file(fp,"Drive firmware designation \t: %s\n",raid_element->Element.Drive.Device.bFirmware);
		print_to_file(fp,"Drive serial number        \t: %s\n",raid_element->Element.Drive.Device.bSerialNumber);
		print_to_file(fp,"Drive status               \t: %s\n",raid_element->Element.Drive.Device.bDriveStatus);
		print_to_file(fp,"Drive Block Size           \t: %d\n",raid_element->Element.Drive.Device.usBlockSize);
		print_to_file(fp,"Drive Index                \t: %ld\n",raid_element->Element.Drive.Device.uDriveIndex);
		print_to_file(fp,"\n----------------------------------------------\n");
                

		
		switch(raid_element->Element.Drive.Device.bDriveUsage)
		{
		case CSMI_SAS_DRIVE_CONFIG_NOT_USED:
			print_to_file(fp,"Drive usage  : Not used [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			fprintf(tempo,"Drive usage     : Not used [%d] \n",raid_element->Element.Drive.Device.bDriveUsage);
			break;
		case CSMI_SAS_DRIVE_CONFIG_MEMBER:
			print_to_file(fp,"Drive usage:Part of RAID set [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			fprintf(tempo,"Drive usage:Part of RAID set [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			break;
		case CSMI_SAS_DRIVE_CONFIG_SPARE:
			print_to_file(fp,"Drive usage : Part of RAID set as a hot swap spare [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			fprintf(tempo,"Drive usage : Part of RAID set as a hot swap spare [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			break;
		}
		print_to_file(fp,"\n----------------------------------------------\n");
		fprintf(tempo,"\n----------------------------------------------\n");

	
		switch(raid_element->Element.Drive.Device.bDriveStatus)
		{

		case CSMI_SAS_DRIVE_STATUS_OK:
		      print_to_file(fp,"Drive status  : OK [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : OK [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;

		case CSMI_SAS_DRIVE_STATUS_DEGRADED:
		      print_to_file(fp,"Drive status  : DEGRADED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : DEGRADED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;

		case CSMI_SAS_DRIVE_STATUS_REBUILDING:
		      print_to_file(fp,"Drive status  : REBUILDING [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : REBUILDING [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;

		case CSMI_SAS_DRIVE_STATUS_FAILED:
		      print_to_file(fp,"Drive status  : FAILED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : FAILED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;
		}

                print_to_file(fp,"\n");
                fprintf(tempo,"\n");

                fprintf(tempo,"\t\tLINK RATE INFO"); 
	        fprintf(tempo,"\n----------------------------------------------\n");
	        PrintLinkRate( raid_element->Element.Drive.Data.bNegotitiatedLInkRate[0] );
	        PrintLinkRate( raid_element->Element.Drive.Data.bNegotitiatedLInkRate[1] );
	
                print_to_file(fp,"\t Location INFO \t: NOT SUPPORTED");
                fprintf(tempo,"\t\tLOCATION INFO \t: NOT SUPPORTED \n"); 
	  } 
	 
      

	   /* if((raid_element->uEnumerationType) == CSMI_SAS_RAID_ELEMENT_TYPE_MODULE){
                
	        fprintf(tempo,"\n----------------------------------------------\n");
		fprintf(tempo,"\n\n\t\tCACHE OR MODULE INFO : NOT SUPPORTED "); 
	        fprintf(tempo,"\n----------------------------------------------\n");
                
		print_to_file(fp,"\t \t: %02x\n\n", raid_element->Element.Module.bReserved );   
                fprintf(tempo,"\t CACHE OR MODULE   \t: %ld\n", raid_element->uElementIndex );  
                fprintf(tempo,"\t INFO              \t: %02x\n\n", raid_element->Element.Module.bReserved );   
           } */ 

		

        if((raid_element->uEnumerationType) == CSMI_SAS_RAID_ELEMENT_TYPE_DRIVE_RAID_SET){
                
  
                fprintf(tempo,"\n\t\tDRIVE INFO"); 
		
		fprintf(tempo,"\n----------------------------------------------\n");
		fprintf(tempo,"Drive model                \t: %s\n",raid_element->Element.Drive.Device.bModel);
		fprintf(tempo,"Drive firmware designation \t: %s\n",raid_element->Element.Drive.Device.bFirmware);
		fprintf(tempo,"Drive serial number        \t: %s\n",raid_element->Element.Drive.Device.bSerialNumber);
		fprintf(tempo,"Drive Block Size           \t: %d\n",raid_element->Element.Drive.Device.usBlockSize);
		fprintf(tempo,"Drive Index                \t: %ld\n",raid_element->Element.Drive.Device.uDriveIndex);
		print_to_file(fp,"Drive SAS Address       \t: "); 
		fprintf(tempo,"Drive SAS Address          \t: "); 
		for(i=0;i<8;i++)
        	{
               	print_to_file(fp,"%02x ",(unsigned int) raid_element->Element.Drive.Device.bSASAddress[i]);
               	fprintf(tempo,"%02x ", raid_element->Element.Drive.Device.bSASAddress[i]);
		}
		
		
		print_to_file(fp,"\n\t\tDRIVE INFO"); 
		
		print_to_file(fp,"\n----------------------------------------------\n");
		print_to_file(fp,"Drive model                \t: %s\n",raid_element->Element.Drive.Device.bModel);
		print_to_file(fp,"Drive firmware designation \t: %s\n",raid_element->Element.Drive.Device.bFirmware);
		print_to_file(fp,"Drive serial number        \t: %s\n",raid_element->Element.Drive.Device.bSerialNumber);
		print_to_file(fp,"Drive Block Size           \t: %d\n",raid_element->Element.Drive.Device.usBlockSize);
		print_to_file(fp,"Drive Index                \t: %ld\n",raid_element->Element.Drive.Device.uDriveIndex);
		print_to_file(fp,"\n----------------------------------------------\n");
                
		fprintf(tempo,"\n----------------------------------------------\n");
		
		switch(raid_element->Element.Drive.Device.bDriveUsage)
		{
		case CSMI_SAS_DRIVE_CONFIG_NOT_USED:
			print_to_file(fp,"Drive usage  : Not used [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			fprintf(tempo,"Drive usage     : Not used [%d] \n",raid_element->Element.Drive.Device.bDriveUsage);
			break;
		case CSMI_SAS_DRIVE_CONFIG_MEMBER:
			print_to_file(fp,"Drive usage:Part of RAID set [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			fprintf(tempo,"Drive usage:Part of RAID set [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			break;
		case CSMI_SAS_DRIVE_CONFIG_SPARE:
			print_to_file(fp,"Drive usage : Part of RAID set as a hot swap spare [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			fprintf(tempo,"Drive usage : Part of RAID set as a hot swap spare [%d] \n", raid_element->Element.Drive.Device.bDriveUsage);
			break;
		}
		print_to_file(fp,"\n----------------------------------------------\n");
		fprintf(tempo,"\n----------------------------------------------\n");
                
	
		switch(raid_element->Element.Drive.Device.bDriveStatus)
		{

		case CSMI_SAS_DRIVE_STATUS_OK:
		      print_to_file(fp,"Drive status  : OK [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : OK [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;

		case CSMI_SAS_DRIVE_STATUS_DEGRADED:
		      print_to_file(fp,"Drive status  : DEGRADED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : DEGRADED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;

		case CSMI_SAS_DRIVE_STATUS_REBUILDING:
		      print_to_file(fp,"Drive status  : REBUILDING [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : REBUILDING [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;

		case CSMI_SAS_DRIVE_STATUS_FAILED:
		      print_to_file(fp,"Drive status  : FAILED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      fprintf(tempo,"Drive status     : FAILED [%d] \n",raid_element->Element.Drive.Device.bDriveStatus);
		      break;
		}
		
		print_to_file(fp,"Additional INFO:\n");
	       
	        PrintLinkRate( raid_element->Element.Drive.Data.bNegotitiatedLInkRate[0] );
	        PrintLinkRate( raid_element->Element.Drive.Data.bNegotitiatedLInkRate[1] );
           
               print_to_file(fp,"\t Location INFO \t: NOT SUPPORTED");
               fprintf(tempo,"\t\tLOCATION INFO \t: NOT SUPPORTED \n"); 
               

		}
  
        if((raid_element->uEnumerationType) == CSMI_SAS_RAID_ELEMENT_TYPE_EXTENT_DRIVE){
		
		print_to_file(fp,"\n\t\t"); 
		print_to_file(fp,"\n----------------------------------------------\n");
		print_to_file(fp,"\tDrive Index                \t: %d\n",raid_element->Element.Extent.uDriveIndex);
		fprintf(tempo,"\tDrive Index                   \t: %d\n",raid_element->Element.Extent.uDriveIndex);
               
		print_to_file(fp,"\tEXTENT TYPE IS \t\t\t:"); 
		fprintf(tempo,"\tEXTENT TYPE IS \t\t\t:"); 
		switch( raid_element->Element.Extent.bExtentType ){

		       
       /* case CSMI_SAS_RAID_EXTENT_RAW:  
	 	print_to_file(fp,"RAID EXTENT RAW \t \n" );	
        	fprintf(tempo,"RAID EXTENT RAW    \t \n");
                break;*/ 
                
        case CSMI_SAS_RAID_EXTENT_METADATA:  
		print_to_file(fp,"METADATA OF A PHYSICAL DRIVE  \t \n" );	
        	fprintf(tempo," METADATA OF A PHYSICAL DRIVE    \t \n" );
                break; 

        case CSMI_SAS_RAID_EXTENT_ALLOCATED:  
		print_to_file(fp,"USER REGION OF A PHYSICAL DRIVE \t \n");	
        	fprintf(tempo," USER REGION OF A PHYSICAL DRIVE    \t \n");
                break; 


        case CSMI_SAS_RAID_EXTENT_UNALLOCATED:  
		print_to_file(fp,"USER REGION NOT ALLOCATED \t \n");	
        	fprintf(tempo,"USER REGION NOT ALLOCATED   \t \n");
                break; 

       }
		
      print_to_file(fp,"\nEXTENT OFFSET IS \t\t:"); 
      fprintf(tempo,"\nEXTENT OFFSET IS \t\t:"); 

      if( raid_element->Element.Extent.ulExtentOffset.uLowPart || raid_element->Element.Extent.ulExtentOffset.uHighPart )
      {	
      switch( raid_element->Element.Extent.bExtentType ){

        /*case CSMI_SAS_RAID_EXTENT_RAW:  
		print_to_file(fp," %ld  \n",raid_element->Element.Extent.ulExtentOffset );	
        	fprintf(tempo," %ld  \n",( unsigned int) raid_element->Element.Extent.ulExtentOffset );
                break;*/ 
                
        case CSMI_SAS_RAID_EXTENT_METADATA:  
		print_to_file(fp," %ld (LOW)\n",raid_element->Element.Extent.ulExtentOffset.uLowPart );	
        	fprintf(tempo," %ld (LOW)\n",( unsigned int)raid_element->Element.Extent.ulExtentOffset.uLowPart );
		print_to_file(fp," %ld (HIGH)\n",raid_element->Element.Extent.ulExtentOffset.uHighPart );	
        	fprintf(tempo," %ld (HIGH)\n",( unsigned int)raid_element->Element.Extent.ulExtentOffset.uHighPart );
                break; 

        case CSMI_SAS_RAID_EXTENT_ALLOCATED:  
		print_to_file(fp," %ld (LOW)\n",raid_element->Element.Extent.ulExtentOffset.uLowPart);	
        	fprintf(tempo," %ld (LOW)\n",(unsigned int)raid_element->Element.Extent.ulExtentOffset.uLowPart);
		print_to_file(fp," %ld (HIGH)\n",raid_element->Element.Extent.ulExtentOffset.uHighPart);	
        	fprintf(tempo," %ld (HIGH) \n",(unsigned int)raid_element->Element.Extent.ulExtentOffset.uHighPart);
                break; 

        case CSMI_SAS_RAID_EXTENT_UNALLOCATED:  
		print_to_file(fp," %ld (LOW)\n",raid_element->Element.Extent.ulExtentOffset.uLowPart);	
        	fprintf(tempo," %ld (LOW)\n",(unsigned int) raid_element->Element.Extent.ulExtentOffset.uLowPart);
		print_to_file(fp," %ld (HIGH)\n",raid_element->Element.Extent.ulExtentOffset.uHighPart);	
        	fprintf(tempo," %ld (HIGH)\n",(unsigned int) raid_element->Element.Extent.ulExtentOffset.uHighPart);
                break; 

          } 
       }
 
		print_to_file(fp," %ld (LOW)\n",raid_element->Element.Extent.ulExtentBlocks.uLowPart);	
        	fprintf(tempo," %ld (LOW)\n",(unsigned int) raid_element->Element.Extent.ulExtentBlocks.uLowPart);
		print_to_file(fp," %ld (HIGH)\n",raid_element->Element.Extent.ulExtentBlocks.uHighPart);	
        	fprintf(tempo," %ld (HIGH)\n",(unsigned int) raid_element->Element.Extent.ulExtentBlocks.uHighPart);
       
      		if( raid_element->Element.Extent.bExtentType == CSMI_SAS_RAID_EXTENT_ALLOCATED ){
		print_to_file(fp," %ld (LOW)\n",raid_element->Element.Extent.uRaidSetIndex);	
        	fprintf(tempo," %ld (LOW)\n",(unsigned int) raid_element->Element.Extent.uRaidSetIndex);
		print_to_file(fp," %ld (HIGH)\n",raid_element->Element.Extent.uRaidSetIndex);	
        	fprintf(tempo," %ld (HIGH)\n",(unsigned int) raid_element->Element.Extent.uRaidSetIndex);

      }
    } 

}

display_cache_ratio(int ratio)
{
	if ((ratio >=0 && ratio <= 100))
			print_to_file(fp , "%d%% read %d%% write\n",ratio , (100 -ratio));
			fprintf(tempo ,    "%d%% read %d%% write\n",ratio , (100 -ratio));
			return;
	switch(ratio)
	{
		case CSMI_SAS_RAID_CACHE_RATIO_FIXED:
			print_to_file(fp , "FIXED(Cannot be altered)\n");
			fprintf(tempo ,    "FIXED(Cannot be altered)\n");
			break;
		case CSMI_SAS_RAID_CACHE_RATIO_AUTO:
			print_to_file(fp , "AUTO (Dynamically altered depending on IO command Stream)\n");
			fprintf(tempo    , "AUTO (Dynamically altered depending on IO command Stream)\n");
			break;
		case CSMI_SAS_RAID_CACHE_RATIO_RANGE:
			print_to_file(fp , "Adjusted over entire range(0 - 100)\n");
			fprintf(tempo    , "Adjusted over entire range(0 - 100)\n");
			break;
	}
	
}

char *display_raid_type(CSMI_SAS_RAID_TYPE_DESCRIPTION *raid_descr)
{
	switch(raid_descr->bRaidType)
	{
		case CSMI_SAS_RAID_TYPE_NONE:
			return "NONE";
		case CSMI_SAS_RAID_TYPE_0:
			return "RAID TYPE 0";
		case CSMI_SAS_RAID_TYPE_1:
			return "RAID TYPE 1";
		case CSMI_SAS_RAID_TYPE_10:
			return "RAID TYPE ONE PLUS 0";
		case CSMI_SAS_RAID_TYPE_5:
			return "RAID TYPE 5";
		case CSMI_SAS_RAID_TYPE_15:
			return "RAID TYPE ONE PLUS 5";
		case CSMI_SAS_RAID_TYPE_6:
			return "RAID TYPE 6";
		case CSMI_SAS_RAID_TYPE_OTHER:
			return "OTHER";
	}

			
			
	
}
	
	
display_raid_priority(int priority)
{	
	
	switch(priority)
	{
		case CSMI_SAS_PRIORITY_UNKNOWN:
			print_to_file(fp , "UNKNOWN\n");
			fprintf(tempo ,    "UNKNOWN\n");
			break;
		case CSMI_SAS_PRIORITY_AUTO: 
			print_to_file(fp , "AUTO\n");
			fprintf(tempo ,    "AUTO\n");
			break;
		case CSMI_SAS_PRIORITY_OFF:
			print_to_file(fp , "OFF\n");
			fprintf(tempo ,    "OFF\n");
			break;
		case CSMI_SAS_PRIORITY_LOW:
			print_to_file(fp , "LOW\n");
			fprintf(tempo ,    "LOW\n");
			break;
		case CSMI_SAS_PRIORITY_MEDIUM:
			print_to_file(fp , "MEDIUM\n");
			fprintf(tempo ,    "MEDIUM\n");
			break;
		case CSMI_SAS_PRIORITY_HIGH:
			print_to_file(fp , "HIGH\n");
			fprintf(tempo ,    "HIGH\n");
			break;
	}

}



/*
void check_return_code_element(CSMI_SAS_RAID_ELEMENT_BUFFER *raid_element_buffer)
{
	if((raid_element_buffer->IoctlHeader.ReturnCode) == CSMI_SAS_STATUS_INVALID_PARAMETER){
		switch(raid_element_buffer->Information.uFailureCode){
			case CSMI_SAS_FAIL_CODE_OK:
				print_to_file(fp , "\tOperation SuccessFull\n");
				fprintf(tempo     , "\tOperation SuccessFull\n");
				break;
			case CSMI_SAS_FAIL_CODE_ELEMENT_INDEX_INVALID:
				print_to_file(fp , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				fprintf(tempo     , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				break;
			case CSMI_SAS_FAIL_CODE_SUBELEMENT_INDEX_INVALID:
				print_to_file(fp , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				fprintf(tempo     , "\tValue Provided is Out Of Range or Invalid: %s\n" ,raid_element_buffer->Information.bFailureDescription );
				break;
		}
	}
}

*/

